/* cli.c generated by valac 0.56.18, the Vala compiler
 * generated from cli.vala, do not modify */

/*
   This file is part of GNOME 2048.

   Copyright (C) 2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME 2048 is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME 2048 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME 2048.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <stdio.h>
#include <errno.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())
#define _tile_free0(var) ((var == NULL) ? NULL : (var = (tile_free (var), NULL)))

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())
typedef struct _TileMovement TileMovement;

struct _GridPosition {
	gint8 row;
	gint8 col;
};

struct _Tile {
	GridPosition pos;
	guint8 val;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

VALA_EXTERN gint cli_play_cli (const gchar* cli,
                   const gchar* schema_name,
                   guint8* cols,
                   guint8* rows);
VALA_EXTERN GType grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Grid, g_object_unref)
VALA_EXTERN Grid* grid_new (guint8 rows,
                guint8 cols);
VALA_EXTERN Grid* grid_construct (GType object_type,
                      guint8 rows,
                      guint8 cols);
VALA_EXTERN gboolean grid_restore_game (Grid* self,
                            const gchar* path);
VALA_EXTERN guint8 grid_get_cols (Grid* self);
VALA_EXTERN guint8 grid_get_rows (Grid* self);
VALA_EXTERN void grid_set_target_value (Grid* self,
                            guint value);
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType grid_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GridPosition* grid_position_dup (const GridPosition* self);
VALA_EXTERN void grid_position_free (GridPosition* self);
VALA_EXTERN Tile* tile_dup (const Tile* self);
VALA_EXTERN void tile_free (Tile* self);
VALA_EXTERN void grid_new_tile (Grid* self,
                    Tile* tile);
VALA_EXTERN void cli_print_board (guint8 cols,
                      guint8 rows,
                      Grid* grid,
                      gboolean do_congrat,
                      gboolean print_score,
                      Tile* new_tile);
VALA_EXTERN GType move_request_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean cli_request_move (Grid* grid,
                           MoveRequest req);
VALA_EXTERN gboolean grid_is_finished (Grid* self);
VALA_EXTERN gboolean grid_get_target_value_reached (Grid* self);
VALA_EXTERN void grid_save_game (Grid* self,
                     const gchar* path);
VALA_EXTERN gboolean cli_can_play (Grid* grid);
VALA_EXTERN GType tile_movement_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TileMovement* tile_movement_dup (const TileMovement* self);
VALA_EXTERN void tile_movement_free (TileMovement* self);
VALA_EXTERN void grid_move (Grid* self,
                MoveRequest request,
                GeeLinkedList** to_move,
                GeeLinkedList** to_hide,
                GeeLinkedList** to_show);
VALA_EXTERN gboolean cli_has_moves (GeeLinkedList** to_move,
                        GeeLinkedList** to_hide);
VALA_EXTERN guint8 grid_get (Grid* self,
                 guint8 row,
                 guint8 col);
VALA_EXTERN guint grid_get_target_value_simple (Grid* self);
VALA_EXTERN glong grid_get_score (Grid* self);
VALA_EXTERN gboolean cli_parse_size (const gchar* size,
                         guint8* cols,
                         guint8* rows);
VALA_EXTERN gboolean grid_is_disallowed_grid_size (guint8* rows,
                                       guint8* cols);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gpointer
_tile_dup0 (gpointer self)
{
#line 125 "../src/cli.vala"
	return self ? tile_dup (self) : NULL;
#line 168 "cli.c"
}

gint
cli_play_cli (const gchar* cli,
              const gchar* schema_name,
              guint8* cols,
              guint8* rows)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* saved_path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GSettings* settings = NULL;
	GSettings* _tmp4_;
	gboolean new_game = FALSE;
	Grid* grid = NULL;
	gboolean _tmp5_ = FALSE;
	Grid* _tmp23_;
	GSettings* _tmp24_;
	const gchar* _tmp27_;
	GQuark _tmp29_ = 0U;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label0 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label1 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label2 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label3 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label4 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label5 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label6 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label7 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label8 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label9 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label10 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label11 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label12 = 0;
#line 75 "../src/cli.vala"
	static GQuark _tmp28_label13 = 0;
#line 219 "cli.c"
	Tile* new_tile = NULL;
	Grid* _tmp35_;
	gboolean do_congrat = FALSE;
	GSettings* _tmp40_;
	gboolean _tmp41_ = FALSE;
	Grid* _tmp46_;
	Tile* _tmp47_;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	Grid* _tmp51_;
	gint result;
#line 22 "../src/cli.vala"
	g_return_val_if_fail (cli != NULL, 0);
#line 22 "../src/cli.vala"
	g_return_val_if_fail (schema_name != NULL, 0);
#line 24 "../src/cli.vala"
	if (((gint) (*cols)) != 0) {
#line 24 "../src/cli.vala"
		_tmp1_ = TRUE;
#line 240 "cli.c"
	} else {
#line 24 "../src/cli.vala"
		_tmp1_ = ((gint) (*rows)) != 0;
#line 244 "cli.c"
	}
#line 24 "../src/cli.vala"
	if (_tmp1_) {
#line 24 "../src/cli.vala"
		_tmp0_ = g_strcmp0 (cli, "new") != 0;
#line 250 "cli.c"
	} else {
#line 24 "../src/cli.vala"
		_tmp0_ = FALSE;
#line 254 "cli.c"
	}
#line 24 "../src/cli.vala"
	if (_tmp0_) {
#line 26 "../src/cli.vala"
		g_warning ("cli.vala:26: %s", "Size can only be given for new games." "\n");
#line 27 "../src/cli.vala"
		result = EXIT_FAILURE;
#line 27 "../src/cli.vala"
		return result;
#line 264 "cli.c"
	}
#line 30 "../src/cli.vala"
	_tmp2_ = g_get_user_data_dir ();
#line 30 "../src/cli.vala"
	_tmp3_ = g_build_filename (_tmp2_, "gnome-2048", "saved", NULL);
#line 30 "../src/cli.vala"
	saved_path = _tmp3_;
#line 32 "../src/cli.vala"
	_tmp4_ = g_settings_new (schema_name);
#line 32 "../src/cli.vala"
	settings = _tmp4_;
#line 36 "../src/cli.vala"
	if (((gint) (*cols)) != 0) {
#line 36 "../src/cli.vala"
		_tmp5_ = TRUE;
#line 280 "cli.c"
	} else {
#line 36 "../src/cli.vala"
		_tmp5_ = ((gint) (*rows)) != 0;
#line 284 "cli.c"
	}
#line 36 "../src/cli.vala"
	if (_tmp5_) {
#line 288 "cli.c"
		gboolean _tmp6_ = FALSE;
		GSettings* _tmp7_;
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		GSettings* _tmp10_;
		Grid* _tmp11_;
#line 38 "../src/cli.vala"
		if (((gint) (*cols)) == 0) {
#line 38 "../src/cli.vala"
			_tmp6_ = TRUE;
#line 299 "cli.c"
		} else {
#line 38 "../src/cli.vala"
			_tmp6_ = ((gint) (*rows)) == 0;
#line 303 "cli.c"
		}
#line 38 "../src/cli.vala"
		if (_tmp6_) {
#line 39 "../src/cli.vala"
			g_assert_not_reached ();
#line 309 "cli.c"
		}
#line 41 "../src/cli.vala"
		_tmp7_ = settings;
#line 41 "../src/cli.vala"
		g_settings_delay (_tmp7_);
#line 42 "../src/cli.vala"
		_tmp8_ = settings;
#line 42 "../src/cli.vala"
		g_settings_set_int (_tmp8_, "cols", (gint) (*cols));
#line 43 "../src/cli.vala"
		_tmp9_ = settings;
#line 43 "../src/cli.vala"
		g_settings_set_int (_tmp9_, "rows", (gint) (*rows));
#line 44 "../src/cli.vala"
		_tmp10_ = settings;
#line 44 "../src/cli.vala"
		g_settings_apply (_tmp10_);
#line 45 "../src/cli.vala"
		g_settings_sync ();
#line 47 "../src/cli.vala"
		_tmp11_ = grid_new (*rows, *cols);
#line 47 "../src/cli.vala"
		_g_object_unref0 (grid);
#line 47 "../src/cli.vala"
		grid = _tmp11_;
#line 48 "../src/cli.vala"
		new_game = TRUE;
#line 337 "cli.c"
	} else {
		GSettings* _tmp12_;
		GSettings* _tmp13_;
		Grid* _tmp14_;
#line 52 "../src/cli.vala"
		_tmp12_ = settings;
#line 52 "../src/cli.vala"
		*cols = (guint8) g_settings_get_int (_tmp12_, "cols");
#line 53 "../src/cli.vala"
		_tmp13_ = settings;
#line 53 "../src/cli.vala"
		*rows = (guint8) g_settings_get_int (_tmp13_, "rows");
#line 55 "../src/cli.vala"
		_tmp14_ = grid_new (*rows, *cols);
#line 55 "../src/cli.vala"
		_g_object_unref0 (grid);
#line 55 "../src/cli.vala"
		grid = _tmp14_;
#line 56 "../src/cli.vala"
		if (g_strcmp0 (cli, "new") == 0) {
#line 57 "../src/cli.vala"
			new_game = TRUE;
#line 360 "cli.c"
		} else {
			Grid* _tmp15_;
			const gchar* _tmp16_;
#line 58 "../src/cli.vala"
			_tmp15_ = grid;
#line 58 "../src/cli.vala"
			_tmp16_ = saved_path;
#line 58 "../src/cli.vala"
			if (!grid_restore_game (_tmp15_, _tmp16_)) {
#line 59 "../src/cli.vala"
				new_game = TRUE;
#line 372 "cli.c"
			} else {
				Grid* _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				Grid* _tmp20_;
				guint8 _tmp21_;
				guint8 _tmp22_;
#line 62 "../src/cli.vala"
				new_game = FALSE;
#line 63 "../src/cli.vala"
				_tmp17_ = grid;
#line 63 "../src/cli.vala"
				_tmp18_ = grid_get_cols (_tmp17_);
#line 63 "../src/cli.vala"
				_tmp19_ = _tmp18_;
#line 63 "../src/cli.vala"
				*cols = _tmp19_;
#line 64 "../src/cli.vala"
				_tmp20_ = grid;
#line 64 "../src/cli.vala"
				_tmp21_ = grid_get_rows (_tmp20_);
#line 64 "../src/cli.vala"
				_tmp22_ = _tmp21_;
#line 64 "../src/cli.vala"
				*rows = _tmp22_;
#line 398 "cli.c"
			}
		}
	}
#line 67 "../src/cli.vala"
	_tmp23_ = grid;
#line 67 "../src/cli.vala"
	_tmp24_ = settings;
#line 67 "../src/cli.vala"
	grid_set_target_value (_tmp23_, (guint) g_settings_get_int (_tmp24_, "target-value"));
#line 69 "../src/cli.vala"
	if (new_game) {
#line 410 "cli.c"
		Tile tile = {0};
		Grid* _tmp25_;
		Tile _tmp26_ = {0};
#line 72 "../src/cli.vala"
		_tmp25_ = grid;
#line 72 "../src/cli.vala"
		grid_new_tile (_tmp25_, &_tmp26_);
#line 72 "../src/cli.vala"
		tile = _tmp26_;
#line 420 "cli.c"
	}
#line 75 "../src/cli.vala"
	_tmp27_ = cli;
#line 75 "../src/cli.vala"
	_tmp29_ = (NULL == _tmp27_) ? 0 : g_quark_from_string (_tmp27_);
#line 75 "../src/cli.vala"
	if ((_tmp29_ == ((0 != _tmp28_label0) ? _tmp28_label0 : (_tmp28_label0 = g_quark_from_static_string ("help")))) || (_tmp29_ == ((0 != _tmp28_label1) ? _tmp28_label1 : (_tmp28_label1 = g_quark_from_static_string ("HELP"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 430 "cli.c"
			default:
			{
#line 79 "../src/cli.vala"
				g_assert_not_reached ();
#line 435 "cli.c"
			}
		}
	} else if (((_tmp29_ == ((0 != _tmp28_label2) ? _tmp28_label2 : (_tmp28_label2 = g_quark_from_static_string ("")))) || (_tmp29_ == ((0 != _tmp28_label3) ? _tmp28_label3 : (_tmp28_label3 = g_quark_from_static_string ("show"))))) || (_tmp29_ == ((0 != _tmp28_label4) ? _tmp28_label4 : (_tmp28_label4 = g_quark_from_static_string ("status"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 441 "cli.c"
			default:
			{
				Grid* _tmp30_;
#line 84 "../src/cli.vala"
				if (new_game) {
#line 85 "../src/cli.vala"
					break;
#line 449 "cli.c"
				}
#line 87 "../src/cli.vala"
				_tmp30_ = grid;
#line 87 "../src/cli.vala"
				cli_print_board (*cols, *rows, _tmp30_, FALSE, TRUE, NULL);
#line 88 "../src/cli.vala"
				result = EXIT_SUCCESS;
#line 88 "../src/cli.vala"
				_g_object_unref0 (grid);
#line 88 "../src/cli.vala"
				_g_object_unref0 (settings);
#line 88 "../src/cli.vala"
				_g_free0 (saved_path);
#line 88 "../src/cli.vala"
				return result;
#line 465 "cli.c"
			}
		}
	} else if (_tmp29_ == ((0 != _tmp28_label5) ? _tmp28_label5 : (_tmp28_label5 = g_quark_from_static_string ("new")))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 471 "cli.c"
			default:
			{
#line 91 "../src/cli.vala"
				break;
#line 476 "cli.c"
			}
		}
	} else if ((_tmp29_ == ((0 != _tmp28_label6) ? _tmp28_label6 : (_tmp28_label6 = g_quark_from_static_string ("r")))) || (_tmp29_ == ((0 != _tmp28_label7) ? _tmp28_label7 : (_tmp28_label7 = g_quark_from_static_string ("right"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 482 "cli.c"
			default:
			{
				Grid* _tmp31_;
#line 95 "../src/cli.vala"
				_tmp31_ = grid;
#line 95 "../src/cli.vala"
				if (!cli_request_move (_tmp31_, MOVE_REQUEST_RIGHT)) {
#line 96 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 96 "../src/cli.vala"
					_g_object_unref0 (grid);
#line 96 "../src/cli.vala"
					_g_object_unref0 (settings);
#line 96 "../src/cli.vala"
					_g_free0 (saved_path);
#line 96 "../src/cli.vala"
					return result;
#line 500 "cli.c"
				}
#line 97 "../src/cli.vala"
				break;
#line 504 "cli.c"
			}
		}
	} else if ((_tmp29_ == ((0 != _tmp28_label8) ? _tmp28_label8 : (_tmp28_label8 = g_quark_from_static_string ("l")))) || (_tmp29_ == ((0 != _tmp28_label9) ? _tmp28_label9 : (_tmp28_label9 = g_quark_from_static_string ("left"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 510 "cli.c"
			default:
			{
				Grid* _tmp32_;
#line 101 "../src/cli.vala"
				_tmp32_ = grid;
#line 101 "../src/cli.vala"
				if (!cli_request_move (_tmp32_, MOVE_REQUEST_LEFT)) {
#line 102 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 102 "../src/cli.vala"
					_g_object_unref0 (grid);
#line 102 "../src/cli.vala"
					_g_object_unref0 (settings);
#line 102 "../src/cli.vala"
					_g_free0 (saved_path);
#line 102 "../src/cli.vala"
					return result;
#line 528 "cli.c"
				}
#line 103 "../src/cli.vala"
				break;
#line 532 "cli.c"
			}
		}
	} else if ((_tmp29_ == ((0 != _tmp28_label10) ? _tmp28_label10 : (_tmp28_label10 = g_quark_from_static_string ("u")))) || (_tmp29_ == ((0 != _tmp28_label11) ? _tmp28_label11 : (_tmp28_label11 = g_quark_from_static_string ("up"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 538 "cli.c"
			default:
			{
				Grid* _tmp33_;
#line 107 "../src/cli.vala"
				_tmp33_ = grid;
#line 107 "../src/cli.vala"
				if (!cli_request_move (_tmp33_, MOVE_REQUEST_UP)) {
#line 108 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 108 "../src/cli.vala"
					_g_object_unref0 (grid);
#line 108 "../src/cli.vala"
					_g_object_unref0 (settings);
#line 108 "../src/cli.vala"
					_g_free0 (saved_path);
#line 108 "../src/cli.vala"
					return result;
#line 556 "cli.c"
				}
#line 109 "../src/cli.vala"
				break;
#line 560 "cli.c"
			}
		}
	} else if ((_tmp29_ == ((0 != _tmp28_label12) ? _tmp28_label12 : (_tmp28_label12 = g_quark_from_static_string ("d")))) || (_tmp29_ == ((0 != _tmp28_label13) ? _tmp28_label13 : (_tmp28_label13 = g_quark_from_static_string ("down"))))) {
#line 75 "../src/cli.vala"
		switch (0) {
#line 566 "cli.c"
			default:
			{
				Grid* _tmp34_;
#line 113 "../src/cli.vala"
				_tmp34_ = grid;
#line 113 "../src/cli.vala"
				if (!cli_request_move (_tmp34_, MOVE_REQUEST_DOWN)) {
#line 114 "../src/cli.vala"
					result = EXIT_FAILURE;
#line 114 "../src/cli.vala"
					_g_object_unref0 (grid);
#line 114 "../src/cli.vala"
					_g_object_unref0 (settings);
#line 114 "../src/cli.vala"
					_g_free0 (saved_path);
#line 114 "../src/cli.vala"
					return result;
#line 584 "cli.c"
				}
#line 115 "../src/cli.vala"
				break;
#line 588 "cli.c"
			}
		}
	} else {
#line 75 "../src/cli.vala"
		switch (0) {
#line 594 "cli.c"
			default:
			{
#line 118 "../src/cli.vala"
				g_warning ("cli.vala:118: %s", "Cannot parse “--cli” command, aborting." "\n");
#line 119 "../src/cli.vala"
				result = EXIT_FAILURE;
#line 119 "../src/cli.vala"
				_g_object_unref0 (grid);
#line 119 "../src/cli.vala"
				_g_object_unref0 (settings);
#line 119 "../src/cli.vala"
				_g_free0 (saved_path);
#line 119 "../src/cli.vala"
				return result;
#line 609 "cli.c"
			}
		}
	}
#line 122 "../src/cli.vala"
	new_tile = NULL;
#line 123 "../src/cli.vala"
	_tmp35_ = grid;
#line 123 "../src/cli.vala"
	if (!grid_is_finished (_tmp35_)) {
#line 619 "cli.c"
		Grid* _tmp36_;
		Tile _tmp37_ = {0};
		Tile _tmp38_;
		Tile* _tmp39_;
#line 125 "../src/cli.vala"
		_tmp36_ = grid;
#line 125 "../src/cli.vala"
		grid_new_tile (_tmp36_, &_tmp37_);
#line 125 "../src/cli.vala"
		_tile_free0 (new_tile);
#line 125 "../src/cli.vala"
		_tmp38_ = _tmp37_;
#line 125 "../src/cli.vala"
		_tmp39_ = _tile_dup0 (&_tmp38_);
#line 125 "../src/cli.vala"
		new_tile = _tmp39_;
#line 126 "../src/cli.vala"
		if (g_strcmp0 (cli, "new") == 0) {
#line 127 "../src/cli.vala"
			_tile_free0 (new_tile);
#line 127 "../src/cli.vala"
			new_tile = NULL;
#line 642 "cli.c"
		}
	}
#line 130 "../src/cli.vala"
	_tmp40_ = settings;
#line 130 "../src/cli.vala"
	do_congrat = g_settings_get_boolean (_tmp40_, "do-congrat");
#line 131 "../src/cli.vala"
	if (do_congrat) {
#line 651 "cli.c"
		Grid* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp44_;
#line 131 "../src/cli.vala"
		_tmp42_ = grid;
#line 131 "../src/cli.vala"
		_tmp43_ = grid_get_target_value_reached (_tmp42_);
#line 131 "../src/cli.vala"
		_tmp44_ = _tmp43_;
#line 131 "../src/cli.vala"
		_tmp41_ = _tmp44_;
#line 663 "cli.c"
	} else {
#line 131 "../src/cli.vala"
		_tmp41_ = FALSE;
#line 667 "cli.c"
	}
#line 131 "../src/cli.vala"
	if (_tmp41_) {
#line 671 "cli.c"
		GSettings* _tmp45_;
#line 132 "../src/cli.vala"
		_tmp45_ = settings;
#line 132 "../src/cli.vala"
		g_settings_set_boolean (_tmp45_, "do-congrat", FALSE);
#line 677 "cli.c"
	}
#line 134 "../src/cli.vala"
	_tmp46_ = grid;
#line 134 "../src/cli.vala"
	_tmp47_ = new_tile;
#line 134 "../src/cli.vala"
	cli_print_board (*cols, *rows, _tmp46_, do_congrat, FALSE, _tmp47_);
#line 136 "../src/cli.vala"
	_tmp51_ = grid;
#line 136 "../src/cli.vala"
	if (!grid_is_finished (_tmp51_)) {
#line 136 "../src/cli.vala"
		_tmp50_ = TRUE;
#line 691 "cli.c"
	} else {
		Grid* _tmp52_;
		guint8 _tmp53_;
		guint8 _tmp54_;
		Grid* _tmp55_;
		guint8 _tmp56_;
		guint8 _tmp57_;
#line 137 "../src/cli.vala"
		_tmp52_ = grid;
#line 137 "../src/cli.vala"
		_tmp53_ = grid_get_cols (_tmp52_);
#line 137 "../src/cli.vala"
		_tmp54_ = _tmp53_;
#line 137 "../src/cli.vala"
		_tmp55_ = grid;
#line 137 "../src/cli.vala"
		_tmp56_ = grid_get_rows (_tmp55_);
#line 137 "../src/cli.vala"
		_tmp57_ = _tmp56_;
#line 137 "../src/cli.vala"
		_tmp50_ = _tmp54_ != _tmp57_;
#line 713 "cli.c"
	}
#line 136 "../src/cli.vala"
	if (_tmp50_) {
#line 136 "../src/cli.vala"
		_tmp49_ = TRUE;
#line 719 "cli.c"
	} else {
		Grid* _tmp58_;
		guint8 _tmp59_;
		guint8 _tmp60_;
#line 138 "../src/cli.vala"
		_tmp58_ = grid;
#line 138 "../src/cli.vala"
		_tmp59_ = grid_get_cols (_tmp58_);
#line 138 "../src/cli.vala"
		_tmp60_ = _tmp59_;
#line 138 "../src/cli.vala"
		_tmp49_ = ((gint) _tmp60_) < 3;
#line 732 "cli.c"
	}
#line 136 "../src/cli.vala"
	if (_tmp49_) {
#line 136 "../src/cli.vala"
		_tmp48_ = TRUE;
#line 738 "cli.c"
	} else {
		Grid* _tmp61_;
		guint8 _tmp62_;
		guint8 _tmp63_;
#line 138 "../src/cli.vala"
		_tmp61_ = grid;
#line 138 "../src/cli.vala"
		_tmp62_ = grid_get_cols (_tmp61_);
#line 138 "../src/cli.vala"
		_tmp63_ = _tmp62_;
#line 138 "../src/cli.vala"
		_tmp48_ = ((gint) _tmp63_) > 5;
#line 751 "cli.c"
	}
#line 136 "../src/cli.vala"
	if (_tmp48_) {
#line 755 "cli.c"
		Grid* _tmp64_;
		const gchar* _tmp65_;
#line 139 "../src/cli.vala"
		_tmp64_ = grid;
#line 139 "../src/cli.vala"
		_tmp65_ = saved_path;
#line 139 "../src/cli.vala"
		grid_save_game (_tmp64_, _tmp65_);
#line 764 "cli.c"
	}
#line 141 "../src/cli.vala"
	result = EXIT_SUCCESS;
#line 141 "../src/cli.vala"
	_tile_free0 (new_tile);
#line 141 "../src/cli.vala"
	_g_object_unref0 (grid);
#line 141 "../src/cli.vala"
	_g_object_unref0 (settings);
#line 141 "../src/cli.vala"
	_g_free0 (saved_path);
#line 141 "../src/cli.vala"
	return result;
#line 778 "cli.c"
}

gboolean
cli_request_move (Grid* grid,
                  MoveRequest req)
{
	GeeLinkedList* to_move = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* to_hide = NULL;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* to_show = NULL;
	GeeLinkedList* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 148 "../src/cli.vala"
	g_return_val_if_fail (grid != NULL, FALSE);
#line 150 "../src/cli.vala"
	if (!cli_can_play (grid)) {
#line 151 "../src/cli.vala"
		result = FALSE;
#line 151 "../src/cli.vala"
		return result;
#line 801 "cli.c"
	}
#line 153 "../src/cli.vala"
	_tmp0_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 153 "../src/cli.vala"
	to_move = _tmp0_;
#line 154 "../src/cli.vala"
	_tmp1_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 154 "../src/cli.vala"
	to_hide = _tmp1_;
#line 155 "../src/cli.vala"
	_tmp2_ = gee_linked_list_new (TYPE_TILE, (GBoxedCopyFunc) tile_dup, (GDestroyNotify) tile_free, NULL, NULL, NULL);
#line 155 "../src/cli.vala"
	to_show = _tmp2_;
#line 157 "../src/cli.vala"
	grid_move (grid, req, &to_move, &to_hide, &to_show);
#line 158 "../src/cli.vala"
	_tmp3_ = cli_has_moves (&to_move, &to_hide);
#line 158 "../src/cli.vala"
	if (!_tmp3_) {
#line 159 "../src/cli.vala"
		result = FALSE;
#line 159 "../src/cli.vala"
		_g_object_unref0 (to_show);
#line 159 "../src/cli.vala"
		_g_object_unref0 (to_hide);
#line 159 "../src/cli.vala"
		_g_object_unref0 (to_move);
#line 159 "../src/cli.vala"
		return result;
#line 831 "cli.c"
	}
#line 161 "../src/cli.vala"
	result = TRUE;
#line 161 "../src/cli.vala"
	_g_object_unref0 (to_show);
#line 161 "../src/cli.vala"
	_g_object_unref0 (to_hide);
#line 161 "../src/cli.vala"
	_g_object_unref0 (to_move);
#line 161 "../src/cli.vala"
	return result;
#line 843 "cli.c"
}

inline gboolean
cli_can_play (Grid* grid)
{
	gboolean result;
#line 164 "../src/cli.vala"
	g_return_val_if_fail (grid != NULL, FALSE);
#line 166 "../src/cli.vala"
	if (!grid_is_finished (grid)) {
#line 167 "../src/cli.vala"
		result = TRUE;
#line 167 "../src/cli.vala"
		return result;
#line 858 "cli.c"
	}
#line 169 "../src/cli.vala"
	g_warning ("cli.vala:169: %s", "Grid is finished, impossible to move." "\n");
#line 170 "../src/cli.vala"
	result = FALSE;
#line 170 "../src/cli.vala"
	return result;
#line 866 "cli.c"
}

inline gboolean
cli_has_moves (GeeLinkedList** to_move,
               GeeLinkedList** to_hide)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 173 "../src/cli.vala"
	g_return_val_if_fail (*to_move != NULL, FALSE);
#line 173 "../src/cli.vala"
	g_return_val_if_fail (*to_hide != NULL, FALSE);
#line 176 "../src/cli.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) (*to_move));
#line 176 "../src/cli.vala"
	_tmp2_ = _tmp1_;
#line 176 "../src/cli.vala"
	if (_tmp2_ != 0) {
#line 176 "../src/cli.vala"
		_tmp0_ = TRUE;
#line 889 "cli.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 176 "../src/cli.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) (*to_hide));
#line 176 "../src/cli.vala"
		_tmp4_ = _tmp3_;
#line 176 "../src/cli.vala"
		_tmp0_ = _tmp4_ != 0;
#line 899 "cli.c"
	}
#line 176 "../src/cli.vala"
	if (_tmp0_) {
#line 177 "../src/cli.vala"
		result = TRUE;
#line 177 "../src/cli.vala"
		return result;
#line 907 "cli.c"
	}
#line 179 "../src/cli.vala"
	g_warning ("cli.vala:179: %s", "Impossible to move in that direction." "\n");
#line 180 "../src/cli.vala"
	result = FALSE;
#line 180 "../src/cli.vala"
	return result;
#line 915 "cli.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 928 "cli.c"
}

void
cli_print_board (guint8 cols,
                 guint8 rows,
                 Grid* grid,
                 gboolean do_congrat,
                 gboolean print_score,
                 Tile* new_tile)
{
	gchar* board = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	const gchar* _tmp67_;
	gchar* _tmp68_;
	gboolean _tmp69_ = FALSE;
	FILE* _tmp111_;
	const gchar* _tmp112_;
#line 187 "../src/cli.vala"
	g_return_if_fail (grid != NULL);
#line 189 "../src/cli.vala"
	_tmp0_ = g_strdup ("");
#line 189 "../src/cli.vala"
	board = _tmp0_;
#line 191 "../src/cli.vala"
	_tmp1_ = board;
#line 191 "../src/cli.vala"
	_tmp2_ = g_strconcat (_tmp1_, "\n ┏", NULL);
#line 191 "../src/cli.vala"
	_g_free0 (board);
#line 191 "../src/cli.vala"
	board = _tmp2_;
#line 966 "cli.c"
	{
		guint8 i = 0U;
#line 192 "../src/cli.vala"
		i = (guint8) 0;
#line 971 "cli.c"
		{
			gboolean _tmp3_ = FALSE;
#line 192 "../src/cli.vala"
			_tmp3_ = TRUE;
#line 192 "../src/cli.vala"
			while (TRUE) {
#line 978 "cli.c"
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 192 "../src/cli.vala"
				if (!_tmp3_) {
#line 983 "cli.c"
					guint8 _tmp4_;
#line 192 "../src/cli.vala"
					_tmp4_ = i;
#line 192 "../src/cli.vala"
					i = _tmp4_ + 1;
#line 989 "cli.c"
				}
#line 192 "../src/cli.vala"
				_tmp3_ = FALSE;
#line 192 "../src/cli.vala"
				if (!(((gint) i) <= (7 * cols))) {
#line 192 "../src/cli.vala"
					break;
#line 997 "cli.c"
				}
#line 193 "../src/cli.vala"
				_tmp5_ = board;
#line 193 "../src/cli.vala"
				_tmp6_ = g_strconcat (_tmp5_, "━", NULL);
#line 193 "../src/cli.vala"
				_g_free0 (board);
#line 193 "../src/cli.vala"
				board = _tmp6_;
#line 1007 "cli.c"
			}
		}
	}
#line 194 "../src/cli.vala"
	_tmp7_ = board;
#line 194 "../src/cli.vala"
	_tmp8_ = g_strconcat (_tmp7_, "┓\n", NULL);
#line 194 "../src/cli.vala"
	_g_free0 (board);
#line 194 "../src/cli.vala"
	board = _tmp8_;
#line 1019 "cli.c"
	{
		guint8 y = 0U;
#line 196 "../src/cli.vala"
		y = (guint8) 0;
#line 1024 "cli.c"
		{
			gboolean _tmp9_ = FALSE;
#line 196 "../src/cli.vala"
			_tmp9_ = TRUE;
#line 196 "../src/cli.vala"
			while (TRUE) {
#line 1031 "cli.c"
				const gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp51_;
				gchar* _tmp52_;
				const gchar* _tmp59_;
				gchar* _tmp60_;
#line 196 "../src/cli.vala"
				if (!_tmp9_) {
#line 1042 "cli.c"
					guint8 _tmp10_;
#line 196 "../src/cli.vala"
					_tmp10_ = y;
#line 196 "../src/cli.vala"
					y = _tmp10_ + 1;
#line 1048 "cli.c"
				}
#line 196 "../src/cli.vala"
				_tmp9_ = FALSE;
#line 196 "../src/cli.vala"
				if (!(y < rows)) {
#line 196 "../src/cli.vala"
					break;
#line 1056 "cli.c"
				}
#line 198 "../src/cli.vala"
				_tmp11_ = board;
#line 198 "../src/cli.vala"
				_tmp12_ = g_strconcat (_tmp11_, " ┃", NULL);
#line 198 "../src/cli.vala"
				_g_free0 (board);
#line 198 "../src/cli.vala"
				board = _tmp12_;
#line 1066 "cli.c"
				{
					guint8 x = 0U;
#line 199 "../src/cli.vala"
					x = (guint8) 0;
#line 1071 "cli.c"
					{
						gboolean _tmp13_ = FALSE;
#line 199 "../src/cli.vala"
						_tmp13_ = TRUE;
#line 199 "../src/cli.vala"
						while (TRUE) {
#line 199 "../src/cli.vala"
							if (!_tmp13_) {
#line 1080 "cli.c"
								guint8 _tmp14_;
#line 199 "../src/cli.vala"
								_tmp14_ = x;
#line 199 "../src/cli.vala"
								x = _tmp14_ + 1;
#line 1086 "cli.c"
							}
#line 199 "../src/cli.vala"
							_tmp13_ = FALSE;
#line 199 "../src/cli.vala"
							if (!(x < cols)) {
#line 199 "../src/cli.vala"
								break;
#line 1094 "cli.c"
							}
#line 201 "../src/cli.vala"
							if (((gint) grid_get (grid, y, x)) == 0) {
#line 1098 "cli.c"
								const gchar* _tmp15_;
								gchar* _tmp16_;
#line 202 "../src/cli.vala"
								_tmp15_ = board;
#line 202 "../src/cli.vala"
								_tmp16_ = g_strconcat (_tmp15_, "       ", NULL);
#line 202 "../src/cli.vala"
								_g_free0 (board);
#line 202 "../src/cli.vala"
								board = _tmp16_;
#line 1109 "cli.c"
							} else {
								const gchar* _tmp17_;
								gchar* _tmp18_;
#line 204 "../src/cli.vala"
								_tmp17_ = board;
#line 204 "../src/cli.vala"
								_tmp18_ = g_strconcat (_tmp17_, " ╭────╮", NULL);
#line 204 "../src/cli.vala"
								_g_free0 (board);
#line 204 "../src/cli.vala"
								board = _tmp18_;
#line 1121 "cli.c"
							}
						}
					}
				}
#line 206 "../src/cli.vala"
				_tmp19_ = board;
#line 206 "../src/cli.vala"
				_tmp20_ = g_strconcat (_tmp19_, " ┃\n ┃", NULL);
#line 206 "../src/cli.vala"
				_g_free0 (board);
#line 206 "../src/cli.vala"
				board = _tmp20_;
#line 1134 "cli.c"
				{
					guint8 x = 0U;
#line 207 "../src/cli.vala"
					x = (guint8) 0;
#line 1139 "cli.c"
					{
						gboolean _tmp21_ = FALSE;
#line 207 "../src/cli.vala"
						_tmp21_ = TRUE;
#line 207 "../src/cli.vala"
						while (TRUE) {
#line 1146 "cli.c"
							guint8 tile_value = 0U;
#line 207 "../src/cli.vala"
							if (!_tmp21_) {
#line 1150 "cli.c"
								guint8 _tmp22_;
#line 207 "../src/cli.vala"
								_tmp22_ = x;
#line 207 "../src/cli.vala"
								x = _tmp22_ + 1;
#line 1156 "cli.c"
							}
#line 207 "../src/cli.vala"
							_tmp21_ = FALSE;
#line 207 "../src/cli.vala"
							if (!(x < cols)) {
#line 207 "../src/cli.vala"
								break;
#line 1164 "cli.c"
							}
#line 209 "../src/cli.vala"
							tile_value = grid_get (grid, y, x);
#line 210 "../src/cli.vala"
							if (((gint) tile_value) == 0) {
#line 1170 "cli.c"
								const gchar* _tmp23_;
								gchar* _tmp24_;
#line 211 "../src/cli.vala"
								_tmp23_ = board;
#line 211 "../src/cli.vala"
								_tmp24_ = g_strconcat (_tmp23_, "       ", NULL);
#line 211 "../src/cli.vala"
								_g_free0 (board);
#line 211 "../src/cli.vala"
								board = _tmp24_;
#line 1181 "cli.c"
							} else {
								gchar* tile_value_string = NULL;
								gchar* _tmp25_;
								gboolean _tmp26_ = FALSE;
								gboolean _tmp27_ = FALSE;
								gboolean _tmp28_ = FALSE;
#line 214 "../src/cli.vala"
								_tmp25_ = g_strdup_printf ("%hhu", tile_value);
#line 214 "../src/cli.vala"
								tile_value_string = _tmp25_;
#line 215 "../src/cli.vala"
								if (((gint) tile_value) == 1) {
#line 215 "../src/cli.vala"
									_tmp28_ = new_tile != NULL;
#line 1196 "cli.c"
								} else {
#line 215 "../src/cli.vala"
									_tmp28_ = FALSE;
#line 1200 "cli.c"
								}
#line 215 "../src/cli.vala"
								if (_tmp28_) {
#line 1204 "cli.c"
									GridPosition _tmp29_;
#line 215 "../src/cli.vala"
									_tmp29_ = ((Tile) (*new_tile)).pos;
#line 215 "../src/cli.vala"
									_tmp27_ = ((guint8) _tmp29_.col) == x;
#line 1210 "cli.c"
								} else {
#line 215 "../src/cli.vala"
									_tmp27_ = FALSE;
#line 1214 "cli.c"
								}
#line 215 "../src/cli.vala"
								if (_tmp27_) {
#line 1218 "cli.c"
									GridPosition _tmp30_;
#line 215 "../src/cli.vala"
									_tmp30_ = ((Tile) (*new_tile)).pos;
#line 215 "../src/cli.vala"
									_tmp26_ = ((guint8) _tmp30_.row) == y;
#line 1224 "cli.c"
								} else {
#line 215 "../src/cli.vala"
									_tmp26_ = FALSE;
#line 1228 "cli.c"
								}
#line 215 "../src/cli.vala"
								if (_tmp26_) {
#line 1232 "cli.c"
									const gchar* _tmp31_;
									gchar* _tmp32_;
#line 216 "../src/cli.vala"
									_tmp31_ = board;
#line 216 "../src/cli.vala"
									_tmp32_ = g_strconcat (_tmp31_, " │ +1 │", NULL);
#line 216 "../src/cli.vala"
									_g_free0 (board);
#line 216 "../src/cli.vala"
									board = _tmp32_;
#line 1243 "cli.c"
								} else {
									const gchar* _tmp33_;
									gint _tmp34_;
									gint _tmp35_;
#line 217 "../src/cli.vala"
									_tmp33_ = tile_value_string;
#line 217 "../src/cli.vala"
									_tmp34_ = strlen (_tmp33_);
#line 217 "../src/cli.vala"
									_tmp35_ = _tmp34_;
#line 217 "../src/cli.vala"
									if (_tmp35_ == 1) {
#line 1256 "cli.c"
										const gchar* _tmp36_;
										const gchar* _tmp37_;
										const gchar* _tmp38_;
										gchar* _tmp39_;
										gchar* _tmp40_;
										gchar* _tmp41_;
#line 218 "../src/cli.vala"
										_tmp36_ = board;
#line 218 "../src/cli.vala"
										_tmp37_ = tile_value_string;
#line 218 "../src/cli.vala"
										_tmp38_ = string_to_string (_tmp37_);
#line 218 "../src/cli.vala"
										_tmp39_ = g_strconcat (" │  ", _tmp38_, " │", NULL);
#line 218 "../src/cli.vala"
										_tmp40_ = _tmp39_;
#line 218 "../src/cli.vala"
										_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 218 "../src/cli.vala"
										_g_free0 (board);
#line 218 "../src/cli.vala"
										board = _tmp41_;
#line 218 "../src/cli.vala"
										_g_free0 (_tmp40_);
#line 1281 "cli.c"
									} else {
										const gchar* _tmp42_;
										gint _tmp43_;
										gint _tmp44_;
#line 219 "../src/cli.vala"
										_tmp42_ = tile_value_string;
#line 219 "../src/cli.vala"
										_tmp43_ = strlen (_tmp42_);
#line 219 "../src/cli.vala"
										_tmp44_ = _tmp43_;
#line 219 "../src/cli.vala"
										if (_tmp44_ == 2) {
#line 1294 "cli.c"
											const gchar* _tmp45_;
											const gchar* _tmp46_;
											const gchar* _tmp47_;
											gchar* _tmp48_;
											gchar* _tmp49_;
											gchar* _tmp50_;
#line 220 "../src/cli.vala"
											_tmp45_ = board;
#line 220 "../src/cli.vala"
											_tmp46_ = tile_value_string;
#line 220 "../src/cli.vala"
											_tmp47_ = string_to_string (_tmp46_);
#line 220 "../src/cli.vala"
											_tmp48_ = g_strconcat (" │ ", _tmp47_, " │", NULL);
#line 220 "../src/cli.vala"
											_tmp49_ = _tmp48_;
#line 220 "../src/cli.vala"
											_tmp50_ = g_strconcat (_tmp45_, _tmp49_, NULL);
#line 220 "../src/cli.vala"
											_g_free0 (board);
#line 220 "../src/cli.vala"
											board = _tmp50_;
#line 220 "../src/cli.vala"
											_g_free0 (_tmp49_);
#line 1319 "cli.c"
										} else {
#line 221 "../src/cli.vala"
											g_assert_not_reached ();
#line 1323 "cli.c"
										}
									}
								}
#line 210 "../src/cli.vala"
								_g_free0 (tile_value_string);
#line 1329 "cli.c"
							}
						}
					}
				}
#line 224 "../src/cli.vala"
				_tmp51_ = board;
#line 224 "../src/cli.vala"
				_tmp52_ = g_strconcat (_tmp51_, " ┃\n ┃", NULL);
#line 224 "../src/cli.vala"
				_g_free0 (board);
#line 224 "../src/cli.vala"
				board = _tmp52_;
#line 1342 "cli.c"
				{
					guint8 x = 0U;
#line 225 "../src/cli.vala"
					x = (guint8) 0;
#line 1347 "cli.c"
					{
						gboolean _tmp53_ = FALSE;
#line 225 "../src/cli.vala"
						_tmp53_ = TRUE;
#line 225 "../src/cli.vala"
						while (TRUE) {
#line 225 "../src/cli.vala"
							if (!_tmp53_) {
#line 1356 "cli.c"
								guint8 _tmp54_;
#line 225 "../src/cli.vala"
								_tmp54_ = x;
#line 225 "../src/cli.vala"
								x = _tmp54_ + 1;
#line 1362 "cli.c"
							}
#line 225 "../src/cli.vala"
							_tmp53_ = FALSE;
#line 225 "../src/cli.vala"
							if (!(x < cols)) {
#line 225 "../src/cli.vala"
								break;
#line 1370 "cli.c"
							}
#line 227 "../src/cli.vala"
							if (((gint) grid_get (grid, y, x)) == 0) {
#line 1374 "cli.c"
								const gchar* _tmp55_;
								gchar* _tmp56_;
#line 228 "../src/cli.vala"
								_tmp55_ = board;
#line 228 "../src/cli.vala"
								_tmp56_ = g_strconcat (_tmp55_, "       ", NULL);
#line 228 "../src/cli.vala"
								_g_free0 (board);
#line 228 "../src/cli.vala"
								board = _tmp56_;
#line 1385 "cli.c"
							} else {
								const gchar* _tmp57_;
								gchar* _tmp58_;
#line 230 "../src/cli.vala"
								_tmp57_ = board;
#line 230 "../src/cli.vala"
								_tmp58_ = g_strconcat (_tmp57_, " ╰────╯", NULL);
#line 230 "../src/cli.vala"
								_g_free0 (board);
#line 230 "../src/cli.vala"
								board = _tmp58_;
#line 1397 "cli.c"
							}
						}
					}
				}
#line 232 "../src/cli.vala"
				_tmp59_ = board;
#line 232 "../src/cli.vala"
				_tmp60_ = g_strconcat (_tmp59_, " ┃\n", NULL);
#line 232 "../src/cli.vala"
				_g_free0 (board);
#line 232 "../src/cli.vala"
				board = _tmp60_;
#line 1410 "cli.c"
			}
		}
	}
#line 235 "../src/cli.vala"
	_tmp61_ = board;
#line 235 "../src/cli.vala"
	_tmp62_ = g_strconcat (_tmp61_, " ┗", NULL);
#line 235 "../src/cli.vala"
	_g_free0 (board);
#line 235 "../src/cli.vala"
	board = _tmp62_;
#line 1422 "cli.c"
	{
		guint8 i = 0U;
#line 236 "../src/cli.vala"
		i = (guint8) 0;
#line 1427 "cli.c"
		{
			gboolean _tmp63_ = FALSE;
#line 236 "../src/cli.vala"
			_tmp63_ = TRUE;
#line 236 "../src/cli.vala"
			while (TRUE) {
#line 1434 "cli.c"
				const gchar* _tmp65_;
				gchar* _tmp66_;
#line 236 "../src/cli.vala"
				if (!_tmp63_) {
#line 1439 "cli.c"
					guint8 _tmp64_;
#line 236 "../src/cli.vala"
					_tmp64_ = i;
#line 236 "../src/cli.vala"
					i = _tmp64_ + 1;
#line 1445 "cli.c"
				}
#line 236 "../src/cli.vala"
				_tmp63_ = FALSE;
#line 236 "../src/cli.vala"
				if (!(((gint) i) <= (7 * cols))) {
#line 236 "../src/cli.vala"
					break;
#line 1453 "cli.c"
				}
#line 237 "../src/cli.vala"
				_tmp65_ = board;
#line 237 "../src/cli.vala"
				_tmp66_ = g_strconcat (_tmp65_, "━", NULL);
#line 237 "../src/cli.vala"
				_g_free0 (board);
#line 237 "../src/cli.vala"
				board = _tmp66_;
#line 1463 "cli.c"
			}
		}
	}
#line 238 "../src/cli.vala"
	_tmp67_ = board;
#line 238 "../src/cli.vala"
	_tmp68_ = g_strconcat (_tmp67_, "┛\n\n", NULL);
#line 238 "../src/cli.vala"
	_g_free0 (board);
#line 238 "../src/cli.vala"
	board = _tmp68_;
#line 240 "../src/cli.vala"
	if (do_congrat) {
#line 1477 "cli.c"
		gboolean _tmp70_;
		gboolean _tmp71_;
#line 240 "../src/cli.vala"
		_tmp70_ = grid_get_target_value_reached (grid);
#line 240 "../src/cli.vala"
		_tmp71_ = _tmp70_;
#line 240 "../src/cli.vala"
		_tmp69_ = _tmp71_;
#line 1486 "cli.c"
	} else {
#line 240 "../src/cli.vala"
		_tmp69_ = FALSE;
#line 1490 "cli.c"
	}
#line 240 "../src/cli.vala"
	if (_tmp69_) {
#line 1494 "cli.c"
		const gchar* _tmp72_;
		guint _tmp73_;
		guint _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
#line 241 "../src/cli.vala"
		_tmp72_ = board;
#line 241 "../src/cli.vala"
		_tmp73_ = grid_get_target_value_simple (grid);
#line 241 "../src/cli.vala"
		_tmp74_ = _tmp73_;
#line 241 "../src/cli.vala"
		_tmp75_ = g_strdup_printf ("You have obtained the %u tile for the first time!", _tmp74_);
#line 241 "../src/cli.vala"
		_tmp76_ = _tmp75_;
#line 241 "../src/cli.vala"
		_tmp77_ = g_strconcat (" ", _tmp76_, NULL);
#line 241 "../src/cli.vala"
		_tmp78_ = _tmp77_;
#line 241 "../src/cli.vala"
		_tmp79_ = g_strconcat (_tmp78_, "\n\n", NULL);
#line 241 "../src/cli.vala"
		_tmp80_ = _tmp79_;
#line 241 "../src/cli.vala"
		_tmp81_ = g_strconcat (_tmp72_, _tmp80_, NULL);
#line 241 "../src/cli.vala"
		_g_free0 (board);
#line 241 "../src/cli.vala"
		board = _tmp81_;
#line 241 "../src/cli.vala"
		_g_free0 (_tmp80_);
#line 241 "../src/cli.vala"
		_g_free0 (_tmp78_);
#line 241 "../src/cli.vala"
		_g_free0 (_tmp76_);
#line 1535 "cli.c"
	}
#line 243 "../src/cli.vala"
	if (grid_is_finished (grid)) {
#line 1539 "cli.c"
		gboolean _tmp82_ = FALSE;
		gboolean _tmp83_ = FALSE;
		gboolean _tmp84_ = FALSE;
#line 245 "../src/cli.vala"
		if (print_score) {
#line 245 "../src/cli.vala"
			_tmp84_ = TRUE;
#line 1547 "cli.c"
		} else {
			guint8 _tmp85_;
			guint8 _tmp86_;
			guint8 _tmp87_;
			guint8 _tmp88_;
#line 246 "../src/cli.vala"
			_tmp85_ = grid_get_cols (grid);
#line 246 "../src/cli.vala"
			_tmp86_ = _tmp85_;
#line 246 "../src/cli.vala"
			_tmp87_ = grid_get_rows (grid);
#line 246 "../src/cli.vala"
			_tmp88_ = _tmp87_;
#line 246 "../src/cli.vala"
			_tmp84_ = _tmp86_ != _tmp88_;
#line 1563 "cli.c"
		}
#line 245 "../src/cli.vala"
		if (_tmp84_) {
#line 245 "../src/cli.vala"
			_tmp83_ = TRUE;
#line 1569 "cli.c"
		} else {
			guint8 _tmp89_;
			guint8 _tmp90_;
#line 247 "../src/cli.vala"
			_tmp89_ = grid_get_cols (grid);
#line 247 "../src/cli.vala"
			_tmp90_ = _tmp89_;
#line 247 "../src/cli.vala"
			_tmp83_ = ((gint) _tmp90_) < 3;
#line 1579 "cli.c"
		}
#line 245 "../src/cli.vala"
		if (_tmp83_) {
#line 245 "../src/cli.vala"
			_tmp82_ = TRUE;
#line 1585 "cli.c"
		} else {
			guint8 _tmp91_;
			guint8 _tmp92_;
#line 247 "../src/cli.vala"
			_tmp91_ = grid_get_cols (grid);
#line 247 "../src/cli.vala"
			_tmp92_ = _tmp91_;
#line 247 "../src/cli.vala"
			_tmp82_ = ((gint) _tmp92_) > 5;
#line 1595 "cli.c"
		}
#line 245 "../src/cli.vala"
		if (_tmp82_) {
#line 1599 "cli.c"
			const gchar* _tmp93_;
			gchar* _tmp94_;
			gchar* _tmp95_;
			gchar* _tmp96_;
			gchar* _tmp97_;
			gchar* _tmp98_;
#line 248 "../src/cli.vala"
			_tmp93_ = board;
#line 248 "../src/cli.vala"
			_tmp94_ = g_strdup_printf ("%li", grid_get_score (grid));
#line 248 "../src/cli.vala"
			_tmp95_ = _tmp94_;
#line 248 "../src/cli.vala"
			_tmp96_ = g_strconcat (" Game is finished! Your score is ", _tmp95_, ".\n\n", NULL);
#line 248 "../src/cli.vala"
			_tmp97_ = _tmp96_;
#line 248 "../src/cli.vala"
			_tmp98_ = g_strconcat (_tmp93_, _tmp97_, NULL);
#line 248 "../src/cli.vala"
			_g_free0 (board);
#line 248 "../src/cli.vala"
			board = _tmp98_;
#line 248 "../src/cli.vala"
			_g_free0 (_tmp97_);
#line 248 "../src/cli.vala"
			_g_free0 (_tmp95_);
#line 1626 "cli.c"
		} else {
			const gchar* _tmp99_;
			gchar* _tmp100_;
			gchar* _tmp101_;
			gchar* _tmp102_;
			gchar* _tmp103_;
			gchar* _tmp104_;
#line 250 "../src/cli.vala"
			_tmp99_ = board;
#line 250 "../src/cli.vala"
			_tmp100_ = g_strdup_printf ("%li", grid_get_score (grid));
#line 250 "../src/cli.vala"
			_tmp101_ = _tmp100_;
#line 250 "../src/cli.vala"
			_tmp102_ = g_strconcat (" Game is finished! Your score is ", _tmp101_, ". (If you want to save it, use GNOME 2048 graphical interface.)\n\n", NULL);
#line 250 "../src/cli.vala"
			_tmp103_ = _tmp102_;
#line 250 "../src/cli.vala"
			_tmp104_ = g_strconcat (_tmp99_, _tmp103_, NULL);
#line 250 "../src/cli.vala"
			_g_free0 (board);
#line 250 "../src/cli.vala"
			board = _tmp104_;
#line 250 "../src/cli.vala"
			_g_free0 (_tmp103_);
#line 250 "../src/cli.vala"
			_g_free0 (_tmp101_);
#line 1654 "cli.c"
		}
	} else {
#line 252 "../src/cli.vala"
		if (print_score) {
#line 1659 "cli.c"
			const gchar* _tmp105_;
			gchar* _tmp106_;
			gchar* _tmp107_;
			gchar* _tmp108_;
			gchar* _tmp109_;
			gchar* _tmp110_;
#line 253 "../src/cli.vala"
			_tmp105_ = board;
#line 253 "../src/cli.vala"
			_tmp106_ = g_strdup_printf ("%li", grid_get_score (grid));
#line 253 "../src/cli.vala"
			_tmp107_ = _tmp106_;
#line 253 "../src/cli.vala"
			_tmp108_ = g_strconcat (" Your score is ", _tmp107_, ".\n\n", NULL);
#line 253 "../src/cli.vala"
			_tmp109_ = _tmp108_;
#line 253 "../src/cli.vala"
			_tmp110_ = g_strconcat (_tmp105_, _tmp109_, NULL);
#line 253 "../src/cli.vala"
			_g_free0 (board);
#line 253 "../src/cli.vala"
			board = _tmp110_;
#line 253 "../src/cli.vala"
			_g_free0 (_tmp109_);
#line 253 "../src/cli.vala"
			_g_free0 (_tmp107_);
#line 1686 "cli.c"
		}
	}
#line 255 "../src/cli.vala"
	_tmp111_ = stdout;
#line 255 "../src/cli.vala"
	_tmp112_ = board;
#line 255 "../src/cli.vala"
	fprintf (_tmp111_, "%s", _tmp112_);
#line 187 "../src/cli.vala"
	_g_free0 (board);
#line 1697 "cli.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1733 "cli.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 1741 "cli.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 1745 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1753 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1759 "cli.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 1763 "cli.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1776 "cli.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1782 "cli.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 1786 "cli.c"
	}
}

inline gboolean
cli_parse_size (const gchar* size,
                guint8* cols,
                guint8* rows)
{
	guint8 _vala_cols = 0U;
	guint8 _vala_rows = 0U;
	gchar** tokens = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint tokens_length1;
	gint _tokens_size_;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	guint64 test = 0ULL;
	gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	guint64 _tmp7_ = 0ULL;
	gboolean _tmp8_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	guint64 _tmp13_ = 0ULL;
	gboolean _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_;
	gboolean result;
#line 262 "../src/cli.vala"
	g_return_val_if_fail (size != NULL, FALSE);
#line 264 "../src/cli.vala"
	_vala_cols = (guint8) 0;
#line 265 "../src/cli.vala"
	_vala_rows = (guint8) 0;
#line 268 "../src/cli.vala"
	_tmp1_ = _tmp0_ = g_strsplit (size, "x", 0);
#line 268 "../src/cli.vala"
	tokens = _tmp1_;
#line 268 "../src/cli.vala"
	tokens_length1 = _vala_array_length (_tmp0_);
#line 268 "../src/cli.vala"
	_tokens_size_ = tokens_length1;
#line 269 "../src/cli.vala"
	_tmp3_ = tokens;
#line 269 "../src/cli.vala"
	_tmp3__length1 = tokens_length1;
#line 269 "../src/cli.vala"
	if (_tmp3__length1 == 0) {
#line 269 "../src/cli.vala"
		_tmp2_ = TRUE;
#line 1844 "cli.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 269 "../src/cli.vala"
		_tmp4_ = tokens;
#line 269 "../src/cli.vala"
		_tmp4__length1 = tokens_length1;
#line 269 "../src/cli.vala"
		_tmp2_ = _tmp4__length1 > 2;
#line 1854 "cli.c"
	}
#line 269 "../src/cli.vala"
	if (_tmp2_) {
#line 270 "../src/cli.vala"
		result = FALSE;
#line 270 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 270 "../src/cli.vala"
		if (cols) {
#line 270 "../src/cli.vala"
			*cols = _vala_cols;
#line 1866 "cli.c"
		}
#line 270 "../src/cli.vala"
		if (rows) {
#line 270 "../src/cli.vala"
			*rows = _vala_rows;
#line 1872 "cli.c"
		}
#line 270 "../src/cli.vala"
		return result;
#line 1876 "cli.c"
	}
#line 274 "../src/cli.vala"
	_tmp5_ = tokens;
#line 274 "../src/cli.vala"
	_tmp5__length1 = tokens_length1;
#line 274 "../src/cli.vala"
	_tmp6_ = _tmp5_[0];
#line 274 "../src/cli.vala"
	_tmp8_ = uint64_try_parse (_tmp6_, &_tmp7_, NULL, (guint) 0);
#line 274 "../src/cli.vala"
	test = _tmp7_;
#line 274 "../src/cli.vala"
	if (!_tmp8_) {
#line 275 "../src/cli.vala"
		result = FALSE;
#line 275 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 275 "../src/cli.vala"
		if (cols) {
#line 275 "../src/cli.vala"
			*cols = _vala_cols;
#line 1898 "cli.c"
		}
#line 275 "../src/cli.vala"
		if (rows) {
#line 275 "../src/cli.vala"
			*rows = _vala_rows;
#line 1904 "cli.c"
		}
#line 275 "../src/cli.vala"
		return result;
#line 1908 "cli.c"
	}
#line 276 "../src/cli.vala"
	if (test <= ((guint64) 0)) {
#line 276 "../src/cli.vala"
		_tmp9_ = TRUE;
#line 1914 "cli.c"
	} else {
#line 276 "../src/cli.vala"
		_tmp9_ = test > ((guint64) 9);
#line 1918 "cli.c"
	}
#line 276 "../src/cli.vala"
	if (_tmp9_) {
#line 277 "../src/cli.vala"
		result = FALSE;
#line 277 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 277 "../src/cli.vala"
		if (cols) {
#line 277 "../src/cli.vala"
			*cols = _vala_cols;
#line 1930 "cli.c"
		}
#line 277 "../src/cli.vala"
		if (rows) {
#line 277 "../src/cli.vala"
			*rows = _vala_rows;
#line 1936 "cli.c"
		}
#line 277 "../src/cli.vala"
		return result;
#line 1940 "cli.c"
	}
#line 278 "../src/cli.vala"
	_vala_cols = (guint8) test;
#line 281 "../src/cli.vala"
	_tmp10_ = tokens;
#line 281 "../src/cli.vala"
	_tmp10__length1 = tokens_length1;
#line 281 "../src/cli.vala"
	if (_tmp10__length1 == 1) {
#line 283 "../src/cli.vala"
		if (((gint) _vala_cols) < 2) {
#line 284 "../src/cli.vala"
			result = FALSE;
#line 284 "../src/cli.vala"
			tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 284 "../src/cli.vala"
			if (cols) {
#line 284 "../src/cli.vala"
				*cols = _vala_cols;
#line 1960 "cli.c"
			}
#line 284 "../src/cli.vala"
			if (rows) {
#line 284 "../src/cli.vala"
				*rows = _vala_rows;
#line 1966 "cli.c"
			}
#line 284 "../src/cli.vala"
			return result;
#line 1970 "cli.c"
		}
#line 285 "../src/cli.vala"
		_vala_rows = _vala_cols;
#line 286 "../src/cli.vala"
		result = TRUE;
#line 286 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 286 "../src/cli.vala"
		if (cols) {
#line 286 "../src/cli.vala"
			*cols = _vala_cols;
#line 1982 "cli.c"
		}
#line 286 "../src/cli.vala"
		if (rows) {
#line 286 "../src/cli.vala"
			*rows = _vala_rows;
#line 1988 "cli.c"
		}
#line 286 "../src/cli.vala"
		return result;
#line 1992 "cli.c"
	}
#line 290 "../src/cli.vala"
	_tmp11_ = tokens;
#line 290 "../src/cli.vala"
	_tmp11__length1 = tokens_length1;
#line 290 "../src/cli.vala"
	_tmp12_ = _tmp11_[1];
#line 290 "../src/cli.vala"
	_tmp14_ = uint64_try_parse (_tmp12_, &_tmp13_, NULL, (guint) 0);
#line 290 "../src/cli.vala"
	test = _tmp13_;
#line 290 "../src/cli.vala"
	if (!_tmp14_) {
#line 291 "../src/cli.vala"
		result = FALSE;
#line 291 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 291 "../src/cli.vala"
		if (cols) {
#line 291 "../src/cli.vala"
			*cols = _vala_cols;
#line 2014 "cli.c"
		}
#line 291 "../src/cli.vala"
		if (rows) {
#line 291 "../src/cli.vala"
			*rows = _vala_rows;
#line 2020 "cli.c"
		}
#line 291 "../src/cli.vala"
		return result;
#line 2024 "cli.c"
	}
#line 292 "../src/cli.vala"
	if (test <= ((guint64) 0)) {
#line 292 "../src/cli.vala"
		_tmp15_ = TRUE;
#line 2030 "cli.c"
	} else {
#line 292 "../src/cli.vala"
		_tmp15_ = test > ((guint64) 9);
#line 2034 "cli.c"
	}
#line 292 "../src/cli.vala"
	if (_tmp15_) {
#line 293 "../src/cli.vala"
		result = FALSE;
#line 293 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 293 "../src/cli.vala"
		if (cols) {
#line 293 "../src/cli.vala"
			*cols = _vala_cols;
#line 2046 "cli.c"
		}
#line 293 "../src/cli.vala"
		if (rows) {
#line 293 "../src/cli.vala"
			*rows = _vala_rows;
#line 2052 "cli.c"
		}
#line 293 "../src/cli.vala"
		return result;
#line 2056 "cli.c"
	}
#line 294 "../src/cli.vala"
	_vala_rows = (guint8) test;
#line 297 "../src/cli.vala"
	_tmp16_ = grid_is_disallowed_grid_size (&_vala_cols, &_vala_rows);
#line 297 "../src/cli.vala"
	if (_tmp16_) {
#line 298 "../src/cli.vala"
		result = FALSE;
#line 298 "../src/cli.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 298 "../src/cli.vala"
		if (cols) {
#line 298 "../src/cli.vala"
			*cols = _vala_cols;
#line 2072 "cli.c"
		}
#line 298 "../src/cli.vala"
		if (rows) {
#line 298 "../src/cli.vala"
			*rows = _vala_rows;
#line 2078 "cli.c"
		}
#line 298 "../src/cli.vala"
		return result;
#line 2082 "cli.c"
	}
#line 300 "../src/cli.vala"
	result = TRUE;
#line 300 "../src/cli.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 300 "../src/cli.vala"
	if (cols) {
#line 300 "../src/cli.vala"
		*cols = _vala_cols;
#line 2092 "cli.c"
	}
#line 300 "../src/cli.vala"
	if (rows) {
#line 300 "../src/cli.vala"
		*rows = _vala_rows;
#line 2098 "cli.c"
	}
#line 300 "../src/cli.vala"
	return result;
#line 2102 "cli.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

