/* game.c generated by valac 0.56.18, the Vala compiler
 * generated from game.vala, do not modify */

/*
   This file is part of GNOME 2048.

   Copyright (C) 2014-2015 Juan R. García Blanco <juanrgar@gmail.com>
   Copyright (C) 2016-2019 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   GNOME 2048 is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME 2048 is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME 2048.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;

#define TYPE_GRID (grid_get_type ())
#define GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRID, Grid))
#define GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRID, GridClass))
#define IS_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRID))
#define IS_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRID))
#define GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRID, GridClass))

typedef struct _Grid Grid;
typedef struct _GridClass GridClass;

#define TYPE_ROUNDED_RECTANGLE (rounded_rectangle_get_type ())
#define ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangle))
#define ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))
#define IS_ROUNDED_RECTANGLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ROUNDED_RECTANGLE))
#define IS_ROUNDED_RECTANGLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ROUNDED_RECTANGLE))
#define ROUNDED_RECTANGLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ROUNDED_RECTANGLE, RoundedRectangleClass))

typedef struct _RoundedRectangle RoundedRectangle;
typedef struct _RoundedRectangleClass RoundedRectangleClass;

#define TYPE_TILE_VIEW (tile_view_get_type ())
#define TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE_VIEW, TileView))
#define TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE_VIEW, TileViewClass))
#define IS_TILE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE_VIEW))
#define IS_TILE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE_VIEW))
#define TILE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE_VIEW, TileViewClass))

typedef struct _TileView TileView;
typedef struct _TileViewClass TileViewClass;

#define TYPE_TILE_MOVEMENT (tile_movement_get_type ())
typedef struct _TileMovement TileMovement;

#define TYPE_GRID_POSITION (grid_position_get_type ())
typedef struct _GridPosition GridPosition;

#define TYPE_TILE (tile_get_type ())
typedef struct _Tile Tile;
typedef enum  {
	GAME_GAME_STATE_STOPPED,
	GAME_GAME_STATE_IDLE,
	GAME_GAME_STATE_MOVING,
	GAME_GAME_STATE_SHOWING_FIRST_TILE,
	GAME_GAME_STATE_SHOWING_NEW_TILE,
	GAME_GAME_STATE_RESTORING_TILES
} GameGameState;

#define GAME_TYPE_GAME_STATE (game_game_state_get_type ())
enum  {
	GAME_0_PROPERTY,
	GAME_VIEW_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	MOVE_REQUEST_UP,
	MOVE_REQUEST_RIGHT,
	MOVE_REQUEST_DOWN,
	MOVE_REQUEST_LEFT
} MoveRequest;

#define TYPE_MOVE_REQUEST (move_request_get_type ())
#define _tile_movement_free0(var) ((var == NULL) ? NULL : (var = (tile_movement_free (var), NULL)))
#define _tile_free0(var) ((var == NULL) ? NULL : (var = (tile_free (var), NULL)))
enum  {
	GAME_FINISHED_SIGNAL,
	GAME_TARGET_VALUE_REACHED_SIGNAL,
	GAME_UNDO_ENABLED_SIGNAL,
	GAME_UNDO_DISABLED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GridPosition {
	gint8 row;
	gint8 col;
};

struct _TileMovement {
	GridPosition from;
	GridPosition to;
};

struct _Tile {
	GridPosition pos;
	guint8 val;
};

struct _GamePrivate {
	gint BLANK_COL_WIDTH;
	gint BLANK_ROW_HEIGHT;
	Grid* _grid;
	RoundedRectangle** _background;
	gint _background_length1;
	gint _background_length2;
	gboolean _background_init_done;
	TileView** _foreground_cur;
	gint _foreground_cur_length1;
	gint _foreground_cur_length2;
	TileView** _foreground_nxt;
	gint _foreground_nxt_length1;
	gint _foreground_nxt_length2;
	GeeLinkedList* _to_move;
	GeeLinkedList* _to_hide;
	GeeLinkedList* _to_show;
	GameGameState _state;
	ClutterTransitionGroup* _show_hide_trans;
	ClutterTransitionGroup* _move_trans;
	gint _animations_duration;
	gchar* _saved_path;
	guint _resize_view_id;
	ClutterActor* _view;
	ClutterActor* _view_background;
	ClutterActor* _view_foreground;
	gboolean _just_restored;
	glong _score;
	guint _finish_move_id;
	gboolean _update_handled;
	gboolean _allow_undo;
	guint _undo_stack_max_size;
	GeeLinkedList* _undo_stack;
};

static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN GType grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Grid, g_object_unref)
VALA_EXTERN GType rounded_rectangle_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RoundedRectangle, g_object_unref)
VALA_EXTERN GType tile_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TileView, g_object_unref)
VALA_EXTERN GType tile_movement_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType grid_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GridPosition* grid_position_dup (const GridPosition* self);
VALA_EXTERN void grid_position_free (GridPosition* self);
VALA_EXTERN TileMovement* tile_movement_dup (const TileMovement* self);
VALA_EXTERN void tile_movement_free (TileMovement* self);
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Tile* tile_dup (const Tile* self);
VALA_EXTERN void tile_free (Tile* self);
static GType game_game_state_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* game_game_state_to_string (GameGameState state);
VALA_EXTERN Game* game_new (GSettings** settings);
VALA_EXTERN Game* game_construct (GType object_type,
                      GSettings** settings);
static void _game_init_grid (guint8 rows,
                      guint8 cols,
                      Grid** grid,
                      GSettings** settings);
VALA_EXTERN Grid* grid_new (guint8 rows,
                guint8 cols);
VALA_EXTERN Grid* grid_construct (GType object_type,
                      guint8 rows,
                      guint8 cols);
static void _game_on_allocation_changed (Game* self,
                                  ClutterActorBox* box,
                                  ClutterAllocationFlags flags);
static void _game_resize_view (Game* self);
static void _game_init_background (Game* self);
VALA_EXTERN void game_new_game (Game* self,
                    GSettings** settings);
static inline void _game_clean_finish_move_animation (Game* self);
VALA_EXTERN void grid_clear (Grid* self);
static void _game_clear_history (Game* self);
VALA_EXTERN guint8 grid_get_rows (Grid* self);
VALA_EXTERN guint8 grid_get_cols (Grid* self);
static void _game_clear_foreground (Game* self);
static void _game_clear_background (Game* self);
static void game_set_score (Game* self,
                     glong value);
static void _game_create_random_tile (Game* self);
VALA_EXTERN void game_save_game (Game* self);
VALA_EXTERN void grid_save_game (Grid* self,
                     const gchar* path);
VALA_EXTERN gboolean game_restore_game (Game* self,
                            GSettings** settings);
VALA_EXTERN gboolean grid_restore_game (Grid* self,
                            const gchar* path);
VALA_EXTERN glong grid_get_score (Grid* self);
static void _game_restore_foreground (Game* self,
                               gboolean animate);
VALA_EXTERN gboolean game_cannot_move (Game* self);
VALA_EXTERN void game_load_settings (Game* self,
                         GSettings** settings);
static void _game_load_undo_settings (Game* self,
                               GSettings** settings);
VALA_EXTERN RoundedRectangle* rounded_rectangle_new (gfloat x,
                                         gfloat y,
                                         gfloat width,
                                         gfloat height);
VALA_EXTERN RoundedRectangle* rounded_rectangle_construct (GType object_type,
                                               gfloat x,
                                               gfloat y,
                                               gfloat width,
                                               gfloat height);
VALA_EXTERN ClutterActor* rounded_rectangle_get_actor (RoundedRectangle* self);
VALA_EXTERN ClutterCanvas* rounded_rectangle_get_canvas (RoundedRectangle* self);
VALA_EXTERN void rounded_rectangle_resize (RoundedRectangle* self,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height);
static gboolean _game_idle_resize_view (Game* self);
static gboolean __game_idle_resize_view_gsource_func (gpointer self);
VALA_EXTERN void rounded_rectangle_idle_resize (RoundedRectangle* self);
VALA_EXTERN void grid_new_tile (Grid* self,
                    Tile* tile);
static void _game_create_show_hide_transition (Game* self,
                                        gboolean animate);
static void _game_create_tile (Game* self,
                        Tile* tile);
static void _game_show_tile (Game* self,
                      GridPosition* pos);
VALA_EXTERN TileView* tile_view_new (gfloat x,
                         gfloat y,
                         gfloat width,
                         gfloat height,
                         guint8 val);
VALA_EXTERN TileView* tile_view_construct (GType object_type,
                               gfloat x,
                               gfloat y,
                               gfloat width,
                               gfloat height,
                               guint8 val);
VALA_EXTERN gchar* grid_position_to_string (GridPosition *self);
static void _game_move_tile (Game* self,
                      GridPosition* from,
                      GridPosition* to);
static void _game_prepare_move_tile (Game* self,
                              GridPosition* from,
                              GridPosition* to);
static void _game_dim_tile (Game* self,
                     GridPosition* pos);
VALA_EXTERN guint8 rounded_rectangle_get_color (RoundedRectangle* self);
VALA_EXTERN guint8 grid_get (Grid* self,
                 guint8 row,
                 guint8 col);
VALA_EXTERN GType move_request_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void game_move (Game* self,
                MoveRequest request);
static void _game_apply_move (Game* self);
VALA_EXTERN gchar* move_request_debug_string (MoveRequest request);
VALA_EXTERN Grid* grid_clone (Grid* self);
static void _game_on_move_trans_stopped (Game* self,
                                  ClutterTimeline* trans,
                                  gboolean is_finished);
static void __game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                            gboolean is_finished,
                                                            gpointer self);
VALA_EXTERN void grid_move (Grid* self,
                MoveRequest request,
                GeeLinkedList** to_move,
                GeeLinkedList** to_hide,
                GeeLinkedList** to_show);
static void _game_store_movement (Game* self,
                           Grid* clone);
VALA_EXTERN gchar* grid_to_string (Grid* self);
VALA_EXTERN glong game_get_score (Game* self);
static void _game_on_show_hide_trans_stopped (Game* self,
                                       ClutterTimeline* trans,
                                       gboolean is_finished);
static void __game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                                 gboolean is_finished,
                                                                 gpointer self);
VALA_EXTERN gboolean grid_get_target_value_reached (Grid* self);
VALA_EXTERN guint grid_get_target_value (Grid* self);
VALA_EXTERN void grid_set_target_value_reached (Grid* self,
                                    gboolean value);
static gboolean _game_finish_move (Game* self);
static gboolean __game_finish_move_gsource_func (gpointer self);
VALA_EXTERN gboolean grid_is_finished (Grid* self);
VALA_EXTERN void game_undo (Game* self);
VALA_EXTERN ClutterActor* game_get_view (Game* self);
VALA_EXTERN void game_set_view (Game* self,
                    ClutterActor* value);
static void __game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                                    ClutterActorBox* box,
                                                                    ClutterAllocationFlags flags,
                                                                    gpointer self);
static void game_finalize (GObject * obj);
static GType game_get_type_once (void);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

static gchar*
game_game_state_to_string (GameGameState state)
{
	gchar* result;
#line 33 "../src/game.vala"
	switch (state) {
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_STOPPED:
#line 393 "game.c"
		{
			gchar* _tmp0_;
#line 35 "../src/game.vala"
			_tmp0_ = g_strdup ("stopped");
#line 35 "../src/game.vala"
			result = _tmp0_;
#line 35 "../src/game.vala"
			return result;
#line 402 "game.c"
		}
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_IDLE:
#line 406 "game.c"
		{
			gchar* _tmp1_;
#line 36 "../src/game.vala"
			_tmp1_ = g_strdup ("idle");
#line 36 "../src/game.vala"
			result = _tmp1_;
#line 36 "../src/game.vala"
			return result;
#line 415 "game.c"
		}
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_MOVING:
#line 419 "game.c"
		{
			gchar* _tmp2_;
#line 37 "../src/game.vala"
			_tmp2_ = g_strdup ("moving");
#line 37 "../src/game.vala"
			result = _tmp2_;
#line 37 "../src/game.vala"
			return result;
#line 428 "game.c"
		}
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_SHOWING_FIRST_TILE:
#line 432 "game.c"
		{
			gchar* _tmp3_;
#line 38 "../src/game.vala"
			_tmp3_ = g_strdup ("showing first tile");
#line 38 "../src/game.vala"
			result = _tmp3_;
#line 38 "../src/game.vala"
			return result;
#line 441 "game.c"
		}
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_SHOWING_NEW_TILE:
#line 445 "game.c"
		{
			gchar* _tmp4_;
#line 39 "../src/game.vala"
			_tmp4_ = g_strdup ("showing new tile");
#line 39 "../src/game.vala"
			result = _tmp4_;
#line 39 "../src/game.vala"
			return result;
#line 454 "game.c"
		}
#line 33 "../src/game.vala"
		case GAME_GAME_STATE_RESTORING_TILES:
#line 458 "game.c"
		{
			gchar* _tmp5_;
#line 40 "../src/game.vala"
			_tmp5_ = g_strdup ("restoring tiles");
#line 40 "../src/game.vala"
			result = _tmp5_;
#line 40 "../src/game.vala"
			return result;
#line 467 "game.c"
		}
		default:
		{
#line 41 "../src/game.vala"
			g_assert_not_reached ();
#line 473 "game.c"
		}
	}
}

static GType
game_game_state_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_GAME_STATE_STOPPED, "GAME_GAME_STATE_STOPPED", "stopped"}, {GAME_GAME_STATE_IDLE, "GAME_GAME_STATE_IDLE", "idle"}, {GAME_GAME_STATE_MOVING, "GAME_GAME_STATE_MOVING", "moving"}, {GAME_GAME_STATE_SHOWING_FIRST_TILE, "GAME_GAME_STATE_SHOWING_FIRST_TILE", "showing-first-tile"}, {GAME_GAME_STATE_SHOWING_NEW_TILE, "GAME_GAME_STATE_SHOWING_NEW_TILE", "showing-new-tile"}, {GAME_GAME_STATE_RESTORING_TILES, "GAME_GAME_STATE_RESTORING_TILES", "restoring-tiles"}, {0, NULL, NULL}};
	GType game_game_state_type_id;
	game_game_state_type_id = g_enum_register_static ("GameGameState", values);
	return game_game_state_type_id;
}

static GType
game_game_state_get_type (void)
{
	static volatile gsize game_game_state_type_id__once = 0;
	if (g_once_init_enter (&game_game_state_type_id__once)) {
		GType game_game_state_type_id;
		game_game_state_type_id = game_game_state_get_type_once ();
		g_once_init_leave (&game_game_state_type_id__once, game_game_state_type_id);
	}
	return game_game_state_type_id__once;
}

Game*
game_construct (GType object_type,
                GSettings** settings)
{
	Game * self = NULL;
	guint8 cols = 0U;
	guint8 rows = 0U;
	Grid* _tmp0_ = NULL;
#line 69 "../src/game.vala"
	g_return_val_if_fail (*settings != NULL, NULL);
#line 69 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 71 "../src/game.vala"
	cols = (guint8) g_settings_get_int (*settings, "cols");
#line 72 "../src/game.vala"
	rows = (guint8) g_settings_get_int (*settings, "rows");
#line 73 "../src/game.vala"
	_game_init_grid (rows, cols, &_tmp0_, settings);
#line 73 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 73 "../src/game.vala"
	self->priv->_grid = _tmp0_;
#line 69 "../src/game.vala"
	return self;
#line 523 "game.c"
}

Game*
game_new (GSettings** settings)
{
#line 69 "../src/game.vala"
	return game_construct (TYPE_GAME, settings);
#line 531 "game.c"
}

static void
_game_init_grid (guint8 rows,
                 guint8 cols,
                 Grid** grid,
                 GSettings** settings)
{
	Grid* _vala_grid = NULL;
	Grid* _tmp0_;
#line 76 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 78 "../src/game.vala"
	_tmp0_ = grid_new (rows, cols);
#line 78 "../src/game.vala"
	_g_object_unref0 (_vala_grid);
#line 78 "../src/game.vala"
	_vala_grid = _tmp0_;
#line 79 "../src/game.vala"
	g_settings_bind (*settings, "target-value", (GObject*) _vala_grid, "target-value", G_SETTINGS_BIND_DEFAULT | G_SETTINGS_BIND_NO_SENSITIVITY);
#line 76 "../src/game.vala"
	if (grid) {
#line 76 "../src/game.vala"
		*grid = _vala_grid;
#line 556 "game.c"
	} else {
#line 76 "../src/game.vala"
		_g_object_unref0 (_vala_grid);
#line 560 "game.c"
	}
}

static void
_game_on_allocation_changed (Game* self,
                             ClutterActorBox* box,
                             ClutterAllocationFlags flags)
{
#line 105 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/game.vala"
	g_return_if_fail (box != NULL);
#line 107 "../src/game.vala"
	if (self->priv->_background_init_done) {
#line 108 "../src/game.vala"
		_game_resize_view (self);
#line 577 "game.c"
	} else {
#line 110 "../src/game.vala"
		_game_init_background (self);
#line 581 "game.c"
	}
}

void
game_new_game (Game* self,
               GSettings** settings)
{
	gboolean _tmp0_ = FALSE;
	Grid* _tmp1_;
	guint8 cols = 0U;
	guint8 rows = 0U;
	gboolean _tmp2_ = FALSE;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
#line 121 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 123 "../src/game.vala"
	if (self->priv->_state != GAME_GAME_STATE_IDLE) {
#line 123 "../src/game.vala"
		_tmp0_ = self->priv->_state != GAME_GAME_STATE_STOPPED;
#line 605 "game.c"
	} else {
#line 123 "../src/game.vala"
		_tmp0_ = FALSE;
#line 609 "game.c"
	}
#line 123 "../src/game.vala"
	if (_tmp0_) {
#line 124 "../src/game.vala"
		return;
#line 615 "game.c"
	}
#line 126 "../src/game.vala"
	_game_clean_finish_move_animation (self);
#line 127 "../src/game.vala"
	_tmp1_ = self->priv->_grid;
#line 127 "../src/game.vala"
	grid_clear (_tmp1_);
#line 128 "../src/game.vala"
	_game_clear_history (self);
#line 130 "../src/game.vala"
	cols = (guint8) g_settings_get_int (*settings, "cols");
#line 131 "../src/game.vala"
	rows = (guint8) g_settings_get_int (*settings, "rows");
#line 133 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 133 "../src/game.vala"
	_tmp4_ = grid_get_rows (_tmp3_);
#line 133 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 133 "../src/game.vala"
	if (rows != _tmp5_) {
#line 133 "../src/game.vala"
		_tmp2_ = TRUE;
#line 639 "game.c"
	} else {
		Grid* _tmp6_;
		guint8 _tmp7_;
		guint8 _tmp8_;
#line 133 "../src/game.vala"
		_tmp6_ = self->priv->_grid;
#line 133 "../src/game.vala"
		_tmp7_ = grid_get_cols (_tmp6_);
#line 133 "../src/game.vala"
		_tmp8_ = _tmp7_;
#line 133 "../src/game.vala"
		_tmp2_ = cols != _tmp8_;
#line 652 "game.c"
	}
#line 133 "../src/game.vala"
	if (_tmp2_) {
#line 656 "game.c"
		Grid* _tmp9_ = NULL;
#line 135 "../src/game.vala"
		_game_clear_foreground (self);
#line 136 "../src/game.vala"
		_game_clear_background (self);
#line 138 "../src/game.vala"
		_game_init_grid (rows, cols, &_tmp9_, settings);
#line 138 "../src/game.vala"
		_g_object_unref0 (self->priv->_grid);
#line 138 "../src/game.vala"
		self->priv->_grid = _tmp9_;
#line 140 "../src/game.vala"
		_game_init_background (self);
#line 670 "game.c"
	} else {
#line 142 "../src/game.vala"
		if (self->priv->_background_init_done) {
#line 143 "../src/game.vala"
			_game_clear_foreground (self);
#line 676 "game.c"
		} else {
#line 145 "../src/game.vala"
			_game_init_background (self);
#line 680 "game.c"
		}
	}
#line 147 "../src/game.vala"
	game_set_score (self, (glong) 0);
#line 148 "../src/game.vala"
	self->priv->_state = GAME_GAME_STATE_SHOWING_FIRST_TILE;
#line 149 "../src/game.vala"
	_game_create_random_tile (self);
#line 150 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 152 "../src/game.vala"
	self->priv->_just_restored = FALSE;
#line 693 "game.c"
}

void
game_save_game (Game* self)
{
	Grid* _tmp0_;
	const gchar* _tmp1_;
#line 155 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 157 "../src/game.vala"
	_tmp1_ = self->priv->_saved_path;
#line 157 "../src/game.vala"
	grid_save_game (_tmp0_, _tmp1_);
#line 709 "game.c"
}

gboolean
game_restore_game (Game* self,
                   GSettings** settings)
{
	Grid* _tmp0_;
	const gchar* _tmp1_;
	Grid* _tmp2_;
	guint8 rows = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	guint8 cols = 0U;
	Grid* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean result;
#line 160 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "../src/game.vala"
	g_return_val_if_fail (*settings != NULL, FALSE);
#line 162 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 162 "../src/game.vala"
	_tmp1_ = self->priv->_saved_path;
#line 162 "../src/game.vala"
	if (!grid_restore_game (_tmp0_, _tmp1_)) {
#line 163 "../src/game.vala"
		result = FALSE;
#line 163 "../src/game.vala"
		return result;
#line 746 "game.c"
	}
#line 165 "../src/game.vala"
	_tmp2_ = self->priv->_grid;
#line 165 "../src/game.vala"
	game_set_score (self, grid_get_score (_tmp2_));
#line 167 "../src/game.vala"
	if (self->priv->_background_init_done) {
#line 168 "../src/game.vala"
		_game_clear_background (self);
#line 756 "game.c"
	}
#line 169 "../src/game.vala"
	_game_init_background (self);
#line 170 "../src/game.vala"
	_game_restore_foreground (self, TRUE);
#line 172 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 172 "../src/game.vala"
	_tmp4_ = grid_get_rows (_tmp3_);
#line 172 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 172 "../src/game.vala"
	rows = _tmp5_;
#line 173 "../src/game.vala"
	_tmp6_ = self->priv->_grid;
#line 173 "../src/game.vala"
	_tmp7_ = grid_get_cols (_tmp6_);
#line 173 "../src/game.vala"
	_tmp8_ = _tmp7_;
#line 173 "../src/game.vala"
	cols = _tmp8_;
#line 174 "../src/game.vala"
	if (((gint) rows) == 3) {
#line 174 "../src/game.vala"
		_tmp12_ = ((gint) cols) != 3;
#line 782 "game.c"
	} else {
#line 174 "../src/game.vala"
		_tmp12_ = FALSE;
#line 786 "game.c"
	}
#line 174 "../src/game.vala"
	if (_tmp12_) {
#line 174 "../src/game.vala"
		_tmp11_ = TRUE;
#line 792 "game.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 175 "../src/game.vala"
		if (((gint) rows) == 4) {
#line 175 "../src/game.vala"
			_tmp13_ = ((gint) cols) != 4;
#line 799 "game.c"
		} else {
#line 175 "../src/game.vala"
			_tmp13_ = FALSE;
#line 803 "game.c"
		}
#line 175 "../src/game.vala"
		_tmp11_ = _tmp13_;
#line 807 "game.c"
	}
#line 174 "../src/game.vala"
	if (_tmp11_) {
#line 174 "../src/game.vala"
		_tmp10_ = TRUE;
#line 813 "game.c"
	} else {
		gboolean _tmp14_ = FALSE;
#line 176 "../src/game.vala"
		if (((gint) rows) == 5) {
#line 176 "../src/game.vala"
			_tmp14_ = ((gint) cols) != 5;
#line 820 "game.c"
		} else {
#line 176 "../src/game.vala"
			_tmp14_ = FALSE;
#line 824 "game.c"
		}
#line 176 "../src/game.vala"
		_tmp10_ = _tmp14_;
#line 828 "game.c"
	}
#line 174 "../src/game.vala"
	if (_tmp10_) {
#line 174 "../src/game.vala"
		_tmp9_ = TRUE;
#line 834 "game.c"
	} else {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
#line 177 "../src/game.vala"
		if (((gint) rows) != 3) {
#line 177 "../src/game.vala"
			_tmp16_ = ((gint) rows) != 4;
#line 842 "game.c"
		} else {
#line 177 "../src/game.vala"
			_tmp16_ = FALSE;
#line 846 "game.c"
		}
#line 177 "../src/game.vala"
		if (_tmp16_) {
#line 177 "../src/game.vala"
			_tmp15_ = ((gint) rows) != 5;
#line 852 "game.c"
		} else {
#line 177 "../src/game.vala"
			_tmp15_ = FALSE;
#line 856 "game.c"
		}
#line 177 "../src/game.vala"
		_tmp9_ = _tmp15_;
#line 860 "game.c"
	}
#line 174 "../src/game.vala"
	if (_tmp9_) {
#line 179 "../src/game.vala"
		g_settings_delay (*settings);
#line 180 "../src/game.vala"
		g_settings_set_int (*settings, "rows", (gint) rows);
#line 181 "../src/game.vala"
		g_settings_set_int (*settings, "cols", (gint) cols);
#line 182 "../src/game.vala"
		g_settings_apply (*settings);
#line 872 "game.c"
	}
#line 185 "../src/game.vala"
	self->priv->_just_restored = TRUE;
#line 187 "../src/game.vala"
	g_debug ("game.vala:187: game restored successfully");
#line 188 "../src/game.vala"
	result = TRUE;
#line 188 "../src/game.vala"
	return result;
#line 882 "game.c"
}

gboolean
game_cannot_move (Game* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 191 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 193 "../src/game.vala"
	if (self->priv->_state != GAME_GAME_STATE_IDLE) {
#line 194 "../src/game.vala"
		_tmp0_ = self->priv->_state != GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 896 "game.c"
	} else {
#line 193 "../src/game.vala"
		_tmp0_ = FALSE;
#line 900 "game.c"
	}
#line 193 "../src/game.vala"
	result = _tmp0_;
#line 193 "../src/game.vala"
	return result;
#line 906 "game.c"
}

void
game_load_settings (Game* self,
                    GSettings** settings)
{
#line 197 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 199 "../src/game.vala"
	self->priv->_animations_duration = (gint) g_settings_get_double (*settings, "animations-speed");
#line 200 "../src/game.vala"
	_game_load_undo_settings (self, settings);
#line 921 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 236 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 929 "game.c"
}

static void
_game_init_background (Game* self)
{
	guint8 rows = 0U;
	Grid* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 cols = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	ClutterColor background_color = {0};
	ClutterActor* _tmp6_;
	ClutterColor _tmp7_;
	RoundedRectangle** _tmp8_;
	TileView** _tmp9_;
	TileView** _tmp10_;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	gfloat tile_width = 0.0F;
	gfloat tile_height = 0.0F;
#line 203 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 205 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 205 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 205 "../src/game.vala"
	rows = _tmp2_;
#line 206 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 206 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 206 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 206 "../src/game.vala"
	cols = _tmp5_;
#line 207 "../src/game.vala"
	clutter_color_from_string (&background_color, "#babdb6");
#line 208 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 208 "../src/game.vala"
	_tmp7_ = background_color;
#line 208 "../src/game.vala"
	clutter_actor_set_background_color (_tmp6_, &_tmp7_);
#line 210 "../src/game.vala"
	_tmp8_ = g_new0 (RoundedRectangle*, (rows * cols) + 1);
#line 210 "../src/game.vala"
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
#line 210 "../src/game.vala"
	self->priv->_background = _tmp8_;
#line 210 "../src/game.vala"
	self->priv->_background_length1 = rows;
#line 210 "../src/game.vala"
	self->priv->_background_length2 = cols;
#line 211 "../src/game.vala"
	_tmp9_ = g_new0 (TileView*, (rows * cols) + 1);
#line 211 "../src/game.vala"
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
#line 211 "../src/game.vala"
	self->priv->_foreground_cur = _tmp9_;
#line 211 "../src/game.vala"
	self->priv->_foreground_cur_length1 = rows;
#line 211 "../src/game.vala"
	self->priv->_foreground_cur_length2 = cols;
#line 212 "../src/game.vala"
	_tmp10_ = g_new0 (TileView*, (rows * cols) + 1);
#line 212 "../src/game.vala"
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
#line 212 "../src/game.vala"
	self->priv->_foreground_nxt = _tmp10_;
#line 212 "../src/game.vala"
	self->priv->_foreground_nxt_length1 = rows;
#line 212 "../src/game.vala"
	self->priv->_foreground_nxt_length2 = cols;
#line 214 "../src/game.vala"
	_tmp11_ = self->priv->_view;
#line 214 "../src/game.vala"
	_tmp12_ = clutter_actor_get_width (_tmp11_);
#line 214 "../src/game.vala"
	_tmp13_ = _tmp12_;
#line 214 "../src/game.vala"
	canvas_width = _tmp13_;
#line 215 "../src/game.vala"
	_tmp14_ = self->priv->_view;
#line 215 "../src/game.vala"
	_tmp15_ = clutter_actor_get_height (_tmp14_);
#line 215 "../src/game.vala"
	_tmp16_ = _tmp15_;
#line 215 "../src/game.vala"
	canvas_height = _tmp16_;
#line 217 "../src/game.vala"
	canvas_width -= (gfloat) ((cols + 1) * self->priv->BLANK_COL_WIDTH);
#line 218 "../src/game.vala"
	canvas_height -= (gfloat) ((rows + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 220 "../src/game.vala"
	tile_width = canvas_width / cols;
#line 221 "../src/game.vala"
	tile_height = canvas_height / rows;
#line 1039 "game.c"
	{
		guint8 i = 0U;
#line 223 "../src/game.vala"
		i = (guint8) 0;
#line 1044 "game.c"
		{
			gboolean _tmp17_ = FALSE;
#line 223 "../src/game.vala"
			_tmp17_ = TRUE;
#line 223 "../src/game.vala"
			while (TRUE) {
#line 223 "../src/game.vala"
				if (!_tmp17_) {
#line 1053 "game.c"
					guint8 _tmp18_;
#line 223 "../src/game.vala"
					_tmp18_ = i;
#line 223 "../src/game.vala"
					i = _tmp18_ + 1;
#line 1059 "game.c"
				}
#line 223 "../src/game.vala"
				_tmp17_ = FALSE;
#line 223 "../src/game.vala"
				if (!(i < rows)) {
#line 223 "../src/game.vala"
					break;
#line 1067 "game.c"
				}
				{
					guint8 j = 0U;
#line 225 "../src/game.vala"
					j = (guint8) 0;
#line 1073 "game.c"
					{
						gboolean _tmp19_ = FALSE;
#line 225 "../src/game.vala"
						_tmp19_ = TRUE;
#line 225 "../src/game.vala"
						while (TRUE) {
#line 1080 "game.c"
							gfloat x = 0.0F;
							gfloat y = 0.0F;
							RoundedRectangle* rect = NULL;
							RoundedRectangle* _tmp21_;
							ClutterActor* _tmp22_;
							RoundedRectangle* _tmp23_;
							ClutterActor* _tmp24_;
							ClutterActor* _tmp25_;
							RoundedRectangle* _tmp26_;
							ClutterCanvas* _tmp27_;
							ClutterCanvas* _tmp28_;
							RoundedRectangle* _tmp29_;
							ClutterActor* _tmp30_;
							ClutterActor* _tmp31_;
							RoundedRectangle** _tmp32_;
							gint _tmp32__length1;
							gint _tmp32__length2;
							RoundedRectangle* _tmp33_;
							RoundedRectangle* _tmp34_;
							TileView** _tmp35_;
							gint _tmp35__length1;
							gint _tmp35__length2;
							TileView** _tmp36_;
							gint _tmp36__length1;
							gint _tmp36__length2;
#line 225 "../src/game.vala"
							if (!_tmp19_) {
#line 1108 "game.c"
								guint8 _tmp20_;
#line 225 "../src/game.vala"
								_tmp20_ = j;
#line 225 "../src/game.vala"
								j = _tmp20_ + 1;
#line 1114 "game.c"
							}
#line 225 "../src/game.vala"
							_tmp19_ = FALSE;
#line 225 "../src/game.vala"
							if (!(j < cols)) {
#line 225 "../src/game.vala"
								break;
#line 1122 "game.c"
							}
#line 227 "../src/game.vala"
							x = (j * tile_width) + ((j + 1) * self->priv->BLANK_COL_WIDTH);
#line 228 "../src/game.vala"
							y = (i * tile_height) + ((i + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 230 "../src/game.vala"
							_tmp21_ = rounded_rectangle_new (x, y, tile_width, tile_height);
#line 230 "../src/game.vala"
							rect = _tmp21_;
#line 232 "../src/game.vala"
							_tmp22_ = self->priv->_view_background;
#line 232 "../src/game.vala"
							_tmp23_ = rect;
#line 232 "../src/game.vala"
							_tmp24_ = rounded_rectangle_get_actor (_tmp23_);
#line 232 "../src/game.vala"
							_tmp25_ = _tmp24_;
#line 232 "../src/game.vala"
							clutter_actor_add_child (_tmp22_, _tmp25_);
#line 233 "../src/game.vala"
							_tmp26_ = rect;
#line 233 "../src/game.vala"
							_tmp27_ = rounded_rectangle_get_canvas (_tmp26_);
#line 233 "../src/game.vala"
							_tmp28_ = _tmp27_;
#line 233 "../src/game.vala"
							clutter_content_invalidate ((ClutterContent*) _tmp28_);
#line 234 "../src/game.vala"
							_tmp29_ = rect;
#line 234 "../src/game.vala"
							_tmp30_ = rounded_rectangle_get_actor (_tmp29_);
#line 234 "../src/game.vala"
							_tmp31_ = _tmp30_;
#line 234 "../src/game.vala"
							clutter_actor_show (_tmp31_);
#line 236 "../src/game.vala"
							_tmp32_ = self->priv->_background;
#line 236 "../src/game.vala"
							_tmp32__length1 = self->priv->_background_length1;
#line 236 "../src/game.vala"
							_tmp32__length2 = self->priv->_background_length2;
#line 236 "../src/game.vala"
							_tmp33_ = rect;
#line 236 "../src/game.vala"
							_tmp34_ = _g_object_ref0 (_tmp33_);
#line 236 "../src/game.vala"
							_g_object_unref0 (_tmp32_[(i * _tmp32__length2) + j]);
#line 236 "../src/game.vala"
							_tmp32_[(i * _tmp32__length2) + j] = _tmp34_;
#line 237 "../src/game.vala"
							_tmp35_ = self->priv->_foreground_cur;
#line 237 "../src/game.vala"
							_tmp35__length1 = self->priv->_foreground_cur_length1;
#line 237 "../src/game.vala"
							_tmp35__length2 = self->priv->_foreground_cur_length2;
#line 237 "../src/game.vala"
							_g_object_unref0 (_tmp35_[(i * _tmp35__length2) + j]);
#line 237 "../src/game.vala"
							_tmp35_[(i * _tmp35__length2) + j] = NULL;
#line 238 "../src/game.vala"
							_tmp36_ = self->priv->_foreground_nxt;
#line 238 "../src/game.vala"
							_tmp36__length1 = self->priv->_foreground_nxt_length1;
#line 238 "../src/game.vala"
							_tmp36__length2 = self->priv->_foreground_nxt_length2;
#line 238 "../src/game.vala"
							_g_object_unref0 (_tmp36_[(i * _tmp36__length2) + j]);
#line 238 "../src/game.vala"
							_tmp36_[(i * _tmp36__length2) + j] = NULL;
#line 225 "../src/game.vala"
							_g_object_unref0 (rect);
#line 1194 "game.c"
						}
					}
				}
			}
		}
	}
#line 241 "../src/game.vala"
	self->priv->_background_init_done = TRUE;
#line 1203 "game.c"
}

static gboolean
__game_idle_resize_view_gsource_func (gpointer self)
{
	gboolean result;
	result = _game_idle_resize_view ((Game*) self);
#line 275 "../src/game.vala"
	return result;
#line 1213 "game.c"
}

static void
_game_resize_view (Game* self)
{
	guint8 rows = 0U;
	Grid* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 cols = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gfloat canvas_width = 0.0F;
	ClutterActor* _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gfloat canvas_height = 0.0F;
	ClutterActor* _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat tile_width = 0.0F;
	gfloat tile_height = 0.0F;
#line 244 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 246 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 246 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 246 "../src/game.vala"
	rows = _tmp2_;
#line 247 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 247 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 247 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 247 "../src/game.vala"
	cols = _tmp5_;
#line 248 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 248 "../src/game.vala"
	_tmp7_ = clutter_actor_get_width (_tmp6_);
#line 248 "../src/game.vala"
	_tmp8_ = _tmp7_;
#line 248 "../src/game.vala"
	canvas_width = _tmp8_;
#line 249 "../src/game.vala"
	_tmp9_ = self->priv->_view;
#line 249 "../src/game.vala"
	_tmp10_ = clutter_actor_get_height (_tmp9_);
#line 249 "../src/game.vala"
	_tmp11_ = _tmp10_;
#line 249 "../src/game.vala"
	canvas_height = _tmp11_;
#line 251 "../src/game.vala"
	canvas_width -= (gfloat) ((cols + 1) * self->priv->BLANK_COL_WIDTH);
#line 252 "../src/game.vala"
	canvas_height -= (gfloat) ((rows + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 254 "../src/game.vala"
	tile_width = canvas_width / cols;
#line 255 "../src/game.vala"
	tile_height = canvas_height / rows;
#line 1279 "game.c"
	{
		guint8 i = 0U;
#line 257 "../src/game.vala"
		i = (guint8) 0;
#line 1284 "game.c"
		{
			gboolean _tmp12_ = FALSE;
#line 257 "../src/game.vala"
			_tmp12_ = TRUE;
#line 257 "../src/game.vala"
			while (TRUE) {
#line 257 "../src/game.vala"
				if (!_tmp12_) {
#line 1293 "game.c"
					guint8 _tmp13_;
#line 257 "../src/game.vala"
					_tmp13_ = i;
#line 257 "../src/game.vala"
					i = _tmp13_ + 1;
#line 1299 "game.c"
				}
#line 257 "../src/game.vala"
				_tmp12_ = FALSE;
#line 257 "../src/game.vala"
				if (!(i < rows)) {
#line 257 "../src/game.vala"
					break;
#line 1307 "game.c"
				}
				{
					guint8 j = 0U;
#line 259 "../src/game.vala"
					j = (guint8) 0;
#line 1313 "game.c"
					{
						gboolean _tmp14_ = FALSE;
#line 259 "../src/game.vala"
						_tmp14_ = TRUE;
#line 259 "../src/game.vala"
						while (TRUE) {
#line 1320 "game.c"
							gfloat x = 0.0F;
							gfloat y = 0.0F;
							RoundedRectangle** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							RoundedRectangle* _tmp17_;
							TileView** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							TileView* _tmp19_;
							TileView** _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							TileView* _tmp23_;
#line 259 "../src/game.vala"
							if (!_tmp14_) {
#line 1337 "game.c"
								guint8 _tmp15_;
#line 259 "../src/game.vala"
								_tmp15_ = j;
#line 259 "../src/game.vala"
								j = _tmp15_ + 1;
#line 1343 "game.c"
							}
#line 259 "../src/game.vala"
							_tmp14_ = FALSE;
#line 259 "../src/game.vala"
							if (!(j < cols)) {
#line 259 "../src/game.vala"
								break;
#line 1351 "game.c"
							}
#line 261 "../src/game.vala"
							x = (j * tile_width) + ((j + 1) * self->priv->BLANK_COL_WIDTH);
#line 262 "../src/game.vala"
							y = (i * tile_height) + ((i + 1) * self->priv->BLANK_ROW_HEIGHT);
#line 264 "../src/game.vala"
							_tmp16_ = self->priv->_background;
#line 264 "../src/game.vala"
							_tmp16__length1 = self->priv->_background_length1;
#line 264 "../src/game.vala"
							_tmp16__length2 = self->priv->_background_length2;
#line 264 "../src/game.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 264 "../src/game.vala"
							rounded_rectangle_resize (_tmp17_, x, y, tile_width, tile_height);
#line 266 "../src/game.vala"
							_tmp18_ = self->priv->_foreground_cur;
#line 266 "../src/game.vala"
							_tmp18__length1 = self->priv->_foreground_cur_length1;
#line 266 "../src/game.vala"
							_tmp18__length2 = self->priv->_foreground_cur_length2;
#line 266 "../src/game.vala"
							_tmp19_ = _tmp18_[(i * _tmp18__length2) + j];
#line 266 "../src/game.vala"
							if (_tmp19_ != NULL) {
#line 1377 "game.c"
								TileView** _tmp20_;
								gint _tmp20__length1;
								gint _tmp20__length2;
								TileView* _tmp21_;
#line 267 "../src/game.vala"
								_tmp20_ = self->priv->_foreground_cur;
#line 267 "../src/game.vala"
								_tmp20__length1 = self->priv->_foreground_cur_length1;
#line 267 "../src/game.vala"
								_tmp20__length2 = self->priv->_foreground_cur_length2;
#line 267 "../src/game.vala"
								_tmp21_ = _tmp20_[(i * _tmp20__length2) + j];
#line 267 "../src/game.vala"
								rounded_rectangle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_TILE_VIEW, TileView), x, y, tile_width, tile_height);
#line 1392 "game.c"
							}
#line 269 "../src/game.vala"
							_tmp22_ = self->priv->_foreground_nxt;
#line 269 "../src/game.vala"
							_tmp22__length1 = self->priv->_foreground_nxt_length1;
#line 269 "../src/game.vala"
							_tmp22__length2 = self->priv->_foreground_nxt_length2;
#line 269 "../src/game.vala"
							_tmp23_ = _tmp22_[(i * _tmp22__length2) + j];
#line 269 "../src/game.vala"
							if (_tmp23_ != NULL) {
#line 1404 "game.c"
								TileView** _tmp24_;
								gint _tmp24__length1;
								gint _tmp24__length2;
								TileView* _tmp25_;
#line 270 "../src/game.vala"
								_tmp24_ = self->priv->_foreground_nxt;
#line 270 "../src/game.vala"
								_tmp24__length1 = self->priv->_foreground_nxt_length1;
#line 270 "../src/game.vala"
								_tmp24__length2 = self->priv->_foreground_nxt_length2;
#line 270 "../src/game.vala"
								_tmp25_ = _tmp24_[(i * _tmp24__length2) + j];
#line 270 "../src/game.vala"
								rounded_rectangle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_TILE_VIEW, TileView), x, y, tile_width, tile_height);
#line 1419 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 274 "../src/game.vala"
	if (self->priv->_resize_view_id == ((guint) 0)) {
#line 275 "../src/game.vala"
		self->priv->_resize_view_id = clutter_threads_add_timeout ((guint) 1000, __game_idle_resize_view_gsource_func, self);
#line 1431 "game.c"
	}
}

static gboolean
_game_idle_resize_view (Game* self)
{
	guint8 rows = 0U;
	Grid* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 cols = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gboolean result;
#line 278 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 280 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 280 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 280 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 280 "../src/game.vala"
	rows = _tmp2_;
#line 281 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 281 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 281 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 281 "../src/game.vala"
	cols = _tmp5_;
#line 1465 "game.c"
	{
		guint8 i = 0U;
#line 282 "../src/game.vala"
		i = (guint8) 0;
#line 1470 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 282 "../src/game.vala"
			_tmp6_ = TRUE;
#line 282 "../src/game.vala"
			while (TRUE) {
#line 282 "../src/game.vala"
				if (!_tmp6_) {
#line 1479 "game.c"
					guint8 _tmp7_;
#line 282 "../src/game.vala"
					_tmp7_ = i;
#line 282 "../src/game.vala"
					i = _tmp7_ + 1;
#line 1485 "game.c"
				}
#line 282 "../src/game.vala"
				_tmp6_ = FALSE;
#line 282 "../src/game.vala"
				if (!(i < rows)) {
#line 282 "../src/game.vala"
					break;
#line 1493 "game.c"
				}
				{
					guint8 j = 0U;
#line 284 "../src/game.vala"
					j = (guint8) 0;
#line 1499 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 284 "../src/game.vala"
						_tmp8_ = TRUE;
#line 284 "../src/game.vala"
						while (TRUE) {
#line 1506 "game.c"
							RoundedRectangle** _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							RoundedRectangle* _tmp11_;
							TileView** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							TileView* _tmp13_;
							TileView** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							TileView* _tmp17_;
#line 284 "../src/game.vala"
							if (!_tmp8_) {
#line 1521 "game.c"
								guint8 _tmp9_;
#line 284 "../src/game.vala"
								_tmp9_ = j;
#line 284 "../src/game.vala"
								j = _tmp9_ + 1;
#line 1527 "game.c"
							}
#line 284 "../src/game.vala"
							_tmp8_ = FALSE;
#line 284 "../src/game.vala"
							if (!(j < cols)) {
#line 284 "../src/game.vala"
								break;
#line 1535 "game.c"
							}
#line 286 "../src/game.vala"
							_tmp10_ = self->priv->_background;
#line 286 "../src/game.vala"
							_tmp10__length1 = self->priv->_background_length1;
#line 286 "../src/game.vala"
							_tmp10__length2 = self->priv->_background_length2;
#line 286 "../src/game.vala"
							_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 286 "../src/game.vala"
							rounded_rectangle_idle_resize (_tmp11_);
#line 288 "../src/game.vala"
							_tmp12_ = self->priv->_foreground_cur;
#line 288 "../src/game.vala"
							_tmp12__length1 = self->priv->_foreground_cur_length1;
#line 288 "../src/game.vala"
							_tmp12__length2 = self->priv->_foreground_cur_length2;
#line 288 "../src/game.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 288 "../src/game.vala"
							if (_tmp13_ != NULL) {
#line 1557 "game.c"
								TileView** _tmp14_;
								gint _tmp14__length1;
								gint _tmp14__length2;
								TileView* _tmp15_;
#line 289 "../src/game.vala"
								_tmp14_ = self->priv->_foreground_cur;
#line 289 "../src/game.vala"
								_tmp14__length1 = self->priv->_foreground_cur_length1;
#line 289 "../src/game.vala"
								_tmp14__length2 = self->priv->_foreground_cur_length2;
#line 289 "../src/game.vala"
								_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 289 "../src/game.vala"
								rounded_rectangle_idle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_TILE_VIEW, TileView));
#line 1572 "game.c"
							}
#line 291 "../src/game.vala"
							_tmp16_ = self->priv->_foreground_nxt;
#line 291 "../src/game.vala"
							_tmp16__length1 = self->priv->_foreground_nxt_length1;
#line 291 "../src/game.vala"
							_tmp16__length2 = self->priv->_foreground_nxt_length2;
#line 291 "../src/game.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 291 "../src/game.vala"
							if (_tmp17_ != NULL) {
#line 1584 "game.c"
								TileView** _tmp18_;
								gint _tmp18__length1;
								gint _tmp18__length2;
								TileView* _tmp19_;
#line 292 "../src/game.vala"
								_tmp18_ = self->priv->_foreground_nxt;
#line 292 "../src/game.vala"
								_tmp18__length1 = self->priv->_foreground_nxt_length1;
#line 292 "../src/game.vala"
								_tmp18__length2 = self->priv->_foreground_nxt_length2;
#line 292 "../src/game.vala"
								_tmp19_ = _tmp18_[(i * _tmp18__length2) + j];
#line 292 "../src/game.vala"
								rounded_rectangle_idle_resize ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_TILE_VIEW, TileView));
#line 1599 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 296 "../src/game.vala"
	self->priv->_resize_view_id = (guint) 0;
#line 297 "../src/game.vala"
	result = FALSE;
#line 297 "../src/game.vala"
	return result;
#line 1613 "game.c"
}

static void
_game_create_random_tile (Game* self)
{
	Tile tile = {0};
	Grid* _tmp0_;
	Tile _tmp1_ = {0};
	Tile _tmp2_;
	GeeLinkedList* _tmp3_;
	Tile _tmp4_;
	Tile _tmp5_;
	GridPosition _tmp6_;
	ClutterTransitionGroup* _tmp7_;
#line 300 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 303 "../src/game.vala"
	grid_new_tile (_tmp0_, &_tmp1_);
#line 303 "../src/game.vala"
	tile = _tmp1_;
#line 305 "../src/game.vala"
	if (self->priv->_state == GAME_GAME_STATE_SHOWING_FIRST_TILE) {
#line 306 "../src/game.vala"
		self->priv->_update_handled = TRUE;
#line 1640 "game.c"
	} else {
#line 309 "../src/game.vala"
		self->priv->_update_handled = FALSE;
#line 310 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 1646 "game.c"
	}
#line 312 "../src/game.vala"
	_game_create_show_hide_transition (self, TRUE);
#line 314 "../src/game.vala"
	_tmp2_ = tile;
#line 314 "../src/game.vala"
	_game_create_tile (self, &_tmp2_);
#line 315 "../src/game.vala"
	_tmp3_ = self->priv->_to_show;
#line 315 "../src/game.vala"
	_tmp4_ = tile;
#line 315 "../src/game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, &_tmp4_);
#line 316 "../src/game.vala"
	_tmp5_ = tile;
#line 316 "../src/game.vala"
	_tmp6_ = _tmp5_.pos;
#line 316 "../src/game.vala"
	_game_show_tile (self, &_tmp6_);
#line 317 "../src/game.vala"
	_tmp7_ = self->priv->_show_hide_trans;
#line 317 "../src/game.vala"
	clutter_timeline_start ((ClutterTimeline*) _tmp7_);
#line 1670 "game.c"
}

static void
_game_create_tile (Game* self,
                   Tile* tile)
{
	GridPosition pos = {0};
	Tile _tmp0_;
	GridPosition _tmp1_;
	TileView** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	GridPosition _tmp3_;
	GridPosition _tmp4_;
	TileView* _tmp5_;
	ClutterActor* actor = NULL;
	RoundedRectangle** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GridPosition _tmp7_;
	GridPosition _tmp8_;
	RoundedRectangle* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	TileView** _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	GridPosition _tmp14_;
	GridPosition _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	Tile _tmp24_;
	TileView* _tmp25_;
#line 320 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/game.vala"
	g_return_if_fail (tile != NULL);
#line 322 "../src/game.vala"
	_tmp0_ = *tile;
#line 322 "../src/game.vala"
	_tmp1_ = _tmp0_.pos;
#line 322 "../src/game.vala"
	pos = _tmp1_;
#line 323 "../src/game.vala"
	_tmp2_ = self->priv->_foreground_nxt;
#line 323 "../src/game.vala"
	_tmp2__length1 = self->priv->_foreground_nxt_length1;
#line 323 "../src/game.vala"
	_tmp2__length2 = self->priv->_foreground_nxt_length2;
#line 323 "../src/game.vala"
	_tmp3_ = pos;
#line 323 "../src/game.vala"
	_tmp4_ = pos;
#line 323 "../src/game.vala"
	_tmp5_ = _tmp2_[(_tmp3_.row * _tmp2__length2) + _tmp4_.col];
#line 323 "../src/game.vala"
	_vala_assert (_tmp5_ == NULL, "_foreground_nxt [pos.row, pos.col] == null");
#line 325 "../src/game.vala"
	_tmp6_ = self->priv->_background;
#line 325 "../src/game.vala"
	_tmp6__length1 = self->priv->_background_length1;
#line 325 "../src/game.vala"
	_tmp6__length2 = self->priv->_background_length2;
#line 325 "../src/game.vala"
	_tmp7_ = pos;
#line 325 "../src/game.vala"
	_tmp8_ = pos;
#line 325 "../src/game.vala"
	_tmp9_ = _tmp6_[(_tmp7_.row * _tmp6__length2) + _tmp8_.col];
#line 325 "../src/game.vala"
	_tmp10_ = rounded_rectangle_get_actor (_tmp9_);
#line 325 "../src/game.vala"
	_tmp11_ = _tmp10_;
#line 325 "../src/game.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 325 "../src/game.vala"
	actor = _tmp12_;
#line 326 "../src/game.vala"
	_tmp13_ = self->priv->_foreground_nxt;
#line 326 "../src/game.vala"
	_tmp13__length1 = self->priv->_foreground_nxt_length1;
#line 326 "../src/game.vala"
	_tmp13__length2 = self->priv->_foreground_nxt_length2;
#line 326 "../src/game.vala"
	_tmp14_ = pos;
#line 326 "../src/game.vala"
	_tmp15_ = pos;
#line 326 "../src/game.vala"
	_tmp16_ = clutter_actor_get_x (actor);
#line 326 "../src/game.vala"
	_tmp17_ = _tmp16_;
#line 326 "../src/game.vala"
	_tmp18_ = clutter_actor_get_y (actor);
#line 326 "../src/game.vala"
	_tmp19_ = _tmp18_;
#line 326 "../src/game.vala"
	_tmp20_ = clutter_actor_get_width (actor);
#line 326 "../src/game.vala"
	_tmp21_ = _tmp20_;
#line 326 "../src/game.vala"
	_tmp22_ = clutter_actor_get_height (actor);
#line 326 "../src/game.vala"
	_tmp23_ = _tmp22_;
#line 326 "../src/game.vala"
	_tmp24_ = *tile;
#line 326 "../src/game.vala"
	_tmp25_ = tile_view_new (_tmp17_, _tmp19_, _tmp21_, _tmp23_, _tmp24_.val);
#line 326 "../src/game.vala"
	_g_object_unref0 (_tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col]);
#line 326 "../src/game.vala"
	_tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col] = _tmp25_;
#line 320 "../src/game.vala"
	_g_object_unref0 (actor);
#line 1791 "game.c"
}

static void
_game_show_tile (Game* self,
                 GridPosition* pos)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ClutterPropertyTransition* trans = NULL;
	TileView* tile_view = NULL;
	TileView** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	GridPosition _tmp5_;
	GridPosition _tmp6_;
	TileView* _tmp7_;
	TileView* _tmp8_;
	ClutterActor* actor = NULL;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterCanvas* _tmp12_;
	ClutterCanvas* _tmp13_;
	ClutterActor* _tmp14_;
	ClutterPropertyTransition* _tmp15_;
	ClutterPropertyTransition* _tmp16_;
	GValue _tmp17_ = {0};
	ClutterPropertyTransition* _tmp18_;
	GValue _tmp19_ = {0};
	ClutterPropertyTransition* _tmp20_;
	ClutterPropertyTransition* _tmp21_;
	ClutterTransitionGroup* _tmp22_;
	ClutterPropertyTransition* _tmp23_;
	ClutterPropertyTransition* _tmp24_;
	ClutterPropertyTransition* _tmp25_;
	GValue _tmp26_ = {0};
	ClutterPropertyTransition* _tmp27_;
	GValue _tmp28_ = {0};
	ClutterPropertyTransition* _tmp29_;
	ClutterPropertyTransition* _tmp30_;
	ClutterTransitionGroup* _tmp31_;
	ClutterPropertyTransition* _tmp32_;
	ClutterPropertyTransition* _tmp33_;
	ClutterPropertyTransition* _tmp34_;
	GValue _tmp35_ = {0};
	ClutterPropertyTransition* _tmp36_;
	GValue _tmp37_ = {0};
	ClutterPropertyTransition* _tmp38_;
	ClutterPropertyTransition* _tmp39_;
	ClutterPropertyTransition* _tmp40_;
#line 333 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/game.vala"
	g_return_if_fail (pos != NULL);
#line 335 "../src/game.vala"
	_tmp0_ = grid_position_to_string (pos);
#line 335 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 335 "../src/game.vala"
	_tmp2_ = g_strconcat ("show tile pos ", _tmp1_, NULL);
#line 335 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 335 "../src/game.vala"
	g_debug ("game.vala:335: %s", _tmp3_);
#line 335 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 335 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 339 "../src/game.vala"
	_tmp4_ = self->priv->_foreground_nxt;
#line 339 "../src/game.vala"
	_tmp4__length1 = self->priv->_foreground_nxt_length1;
#line 339 "../src/game.vala"
	_tmp4__length2 = self->priv->_foreground_nxt_length2;
#line 339 "../src/game.vala"
	_tmp5_ = *pos;
#line 339 "../src/game.vala"
	_tmp6_ = *pos;
#line 339 "../src/game.vala"
	_tmp7_ = _tmp4_[(_tmp5_.row * _tmp4__length2) + _tmp6_.col];
#line 339 "../src/game.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 339 "../src/game.vala"
	tile_view = _tmp8_;
#line 340 "../src/game.vala"
	if (tile_view == NULL) {
#line 341 "../src/game.vala"
		g_assert_not_reached ();
#line 1882 "game.c"
	}
#line 342 "../src/game.vala"
	_tmp9_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 342 "../src/game.vala"
	_tmp10_ = _tmp9_;
#line 342 "../src/game.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 342 "../src/game.vala"
	actor = _tmp11_;
#line 344 "../src/game.vala"
	_tmp12_ = rounded_rectangle_get_canvas ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 344 "../src/game.vala"
	_tmp13_ = _tmp12_;
#line 344 "../src/game.vala"
	clutter_content_invalidate ((ClutterContent*) _tmp13_);
#line 345 "../src/game.vala"
	clutter_actor_set_opacity (actor, (guint8) 0);
#line 346 "../src/game.vala"
	clutter_actor_show (actor);
#line 347 "../src/game.vala"
	_tmp14_ = self->priv->_view_foreground;
#line 347 "../src/game.vala"
	clutter_actor_add_child (_tmp14_, actor);
#line 349 "../src/game.vala"
	_tmp15_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-x");
#line 349 "../src/game.vala"
	_g_object_unref0 (trans);
#line 349 "../src/game.vala"
	trans = _tmp15_;
#line 350 "../src/game.vala"
	_tmp16_ = trans;
#line 350 "../src/game.vala"
	g_value_init (&_tmp17_, G_TYPE_DOUBLE);
#line 350 "../src/game.vala"
	g_value_set_double (&_tmp17_, 1.0);
#line 350 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp16_, &_tmp17_);
#line 350 "../src/game.vala"
	G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
#line 351 "../src/game.vala"
	_tmp18_ = trans;
#line 351 "../src/game.vala"
	g_value_init (&_tmp19_, G_TYPE_DOUBLE);
#line 351 "../src/game.vala"
	g_value_set_double (&_tmp19_, 1.1);
#line 351 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp18_, &_tmp19_);
#line 351 "../src/game.vala"
	G_IS_VALUE (&_tmp19_) ? (g_value_unset (&_tmp19_), NULL) : NULL;
#line 352 "../src/game.vala"
	_tmp20_ = trans;
#line 352 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp20_, (guint) self->priv->_animations_duration);
#line 353 "../src/game.vala"
	_tmp21_ = trans;
#line 353 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp21_, (ClutterAnimatable*) actor);
#line 354 "../src/game.vala"
	_tmp22_ = self->priv->_show_hide_trans;
#line 354 "../src/game.vala"
	_tmp23_ = trans;
#line 354 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp22_, (ClutterTransition*) _tmp23_);
#line 356 "../src/game.vala"
	_tmp24_ = (ClutterPropertyTransition*) clutter_property_transition_new ("scale-y");
#line 356 "../src/game.vala"
	_g_object_unref0 (trans);
#line 356 "../src/game.vala"
	trans = _tmp24_;
#line 357 "../src/game.vala"
	_tmp25_ = trans;
#line 357 "../src/game.vala"
	g_value_init (&_tmp26_, G_TYPE_DOUBLE);
#line 357 "../src/game.vala"
	g_value_set_double (&_tmp26_, 1.0);
#line 357 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp25_, &_tmp26_);
#line 357 "../src/game.vala"
	G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
#line 358 "../src/game.vala"
	_tmp27_ = trans;
#line 358 "../src/game.vala"
	g_value_init (&_tmp28_, G_TYPE_DOUBLE);
#line 358 "../src/game.vala"
	g_value_set_double (&_tmp28_, 1.1);
#line 358 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp27_, &_tmp28_);
#line 358 "../src/game.vala"
	G_IS_VALUE (&_tmp28_) ? (g_value_unset (&_tmp28_), NULL) : NULL;
#line 359 "../src/game.vala"
	_tmp29_ = trans;
#line 359 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp29_, (guint) self->priv->_animations_duration);
#line 360 "../src/game.vala"
	_tmp30_ = trans;
#line 360 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp30_, (ClutterAnimatable*) actor);
#line 361 "../src/game.vala"
	_tmp31_ = self->priv->_show_hide_trans;
#line 361 "../src/game.vala"
	_tmp32_ = trans;
#line 361 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp31_, (ClutterTransition*) _tmp32_);
#line 363 "../src/game.vala"
	_tmp33_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 363 "../src/game.vala"
	_g_object_unref0 (trans);
#line 363 "../src/game.vala"
	trans = _tmp33_;
#line 364 "../src/game.vala"
	_tmp34_ = trans;
#line 364 "../src/game.vala"
	g_value_init (&_tmp35_, G_TYPE_INT);
#line 364 "../src/game.vala"
	g_value_set_int (&_tmp35_, 0);
#line 364 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp34_, &_tmp35_);
#line 364 "../src/game.vala"
	G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
#line 365 "../src/game.vala"
	_tmp36_ = trans;
#line 365 "../src/game.vala"
	g_value_init (&_tmp37_, G_TYPE_INT);
#line 365 "../src/game.vala"
	g_value_set_int (&_tmp37_, 255);
#line 365 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp36_, &_tmp37_);
#line 365 "../src/game.vala"
	G_IS_VALUE (&_tmp37_) ? (g_value_unset (&_tmp37_), NULL) : NULL;
#line 366 "../src/game.vala"
	_tmp38_ = trans;
#line 366 "../src/game.vala"
	clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp38_, TRUE);
#line 367 "../src/game.vala"
	_tmp39_ = trans;
#line 367 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp39_, (guint) (self->priv->_animations_duration / 2));
#line 368 "../src/game.vala"
	_tmp40_ = trans;
#line 368 "../src/game.vala"
	clutter_actor_add_transition (actor, "show", (ClutterTransition*) _tmp40_);
#line 333 "../src/game.vala"
	_g_object_unref0 (actor);
#line 333 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 333 "../src/game.vala"
	_g_object_unref0 (trans);
#line 2030 "game.c"
}

static void
_game_move_tile (Game* self,
                 GridPosition* from,
                 GridPosition* to)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	TileView** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GridPosition _tmp9_;
	GridPosition _tmp10_;
	TileView** _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	GridPosition _tmp12_;
	GridPosition _tmp13_;
	TileView* _tmp14_;
	TileView* _tmp15_;
	TileView** _tmp16_;
	gint _tmp16__length1;
	gint _tmp16__length2;
	GridPosition _tmp17_;
	GridPosition _tmp18_;
#line 371 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/game.vala"
	g_return_if_fail (from != NULL);
#line 371 "../src/game.vala"
	g_return_if_fail (to != NULL);
#line 373 "../src/game.vala"
	_tmp0_ = grid_position_to_string (from);
#line 373 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 373 "../src/game.vala"
	_tmp2_ = grid_position_to_string (to);
#line 373 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 373 "../src/game.vala"
	_tmp4_ = g_strconcat ("move tile from ", _tmp1_, " to ", _tmp3_, NULL);
#line 373 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 373 "../src/game.vala"
	g_debug ("game.vala:373: %s", _tmp5_);
#line 373 "../src/game.vala"
	_g_free0 (_tmp5_);
#line 373 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 373 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 375 "../src/game.vala"
	_tmp6_ = *from;
#line 375 "../src/game.vala"
	_tmp7_ = *to;
#line 375 "../src/game.vala"
	_game_prepare_move_tile (self, &_tmp6_, &_tmp7_);
#line 377 "../src/game.vala"
	_tmp8_ = self->priv->_foreground_nxt;
#line 377 "../src/game.vala"
	_tmp8__length1 = self->priv->_foreground_nxt_length1;
#line 377 "../src/game.vala"
	_tmp8__length2 = self->priv->_foreground_nxt_length2;
#line 377 "../src/game.vala"
	_tmp9_ = *to;
#line 377 "../src/game.vala"
	_tmp10_ = *to;
#line 377 "../src/game.vala"
	_tmp11_ = self->priv->_foreground_cur;
#line 377 "../src/game.vala"
	_tmp11__length1 = self->priv->_foreground_cur_length1;
#line 377 "../src/game.vala"
	_tmp11__length2 = self->priv->_foreground_cur_length2;
#line 377 "../src/game.vala"
	_tmp12_ = *from;
#line 377 "../src/game.vala"
	_tmp13_ = *from;
#line 377 "../src/game.vala"
	_tmp14_ = _tmp11_[(_tmp12_.row * _tmp11__length2) + _tmp13_.col];
#line 377 "../src/game.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 377 "../src/game.vala"
	_g_object_unref0 (_tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col]);
#line 377 "../src/game.vala"
	_tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col] = _tmp15_;
#line 378 "../src/game.vala"
	_tmp16_ = self->priv->_foreground_cur;
#line 378 "../src/game.vala"
	_tmp16__length1 = self->priv->_foreground_cur_length1;
#line 378 "../src/game.vala"
	_tmp16__length2 = self->priv->_foreground_cur_length2;
#line 378 "../src/game.vala"
	_tmp17_ = *from;
#line 378 "../src/game.vala"
	_tmp18_ = *from;
#line 378 "../src/game.vala"
	_g_object_unref0 (_tmp16_[(_tmp17_.row * _tmp16__length2) + _tmp18_.col]);
#line 378 "../src/game.vala"
	_tmp16_[(_tmp17_.row * _tmp16__length2) + _tmp18_.col] = NULL;
#line 2137 "game.c"
}

static void
_game_prepare_move_tile (Game* self,
                         GridPosition* from,
                         GridPosition* to)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean row_move = FALSE;
	GridPosition _tmp6_;
	GridPosition _tmp7_;
	RoundedRectangle* rect_from = NULL;
	RoundedRectangle** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	GridPosition _tmp9_;
	GridPosition _tmp10_;
	RoundedRectangle* _tmp11_;
	RoundedRectangle* _tmp12_;
	RoundedRectangle* rect_to = NULL;
	RoundedRectangle** _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	GridPosition _tmp14_;
	GridPosition _tmp15_;
	RoundedRectangle* _tmp16_;
	RoundedRectangle* _tmp17_;
	TileView* tile_view = NULL;
	TileView** _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	GridPosition _tmp19_;
	GridPosition _tmp20_;
	TileView* _tmp21_;
	TileView* _tmp22_;
	const gchar* _tmp23_ = NULL;
	ClutterPropertyTransition* trans = NULL;
	ClutterPropertyTransition* _tmp24_;
	gfloat _tmp25_ = 0.0F;
	ClutterPropertyTransition* _tmp34_;
	GValue _tmp35_ = {0};
	gfloat _tmp36_ = 0.0F;
	ClutterPropertyTransition* _tmp45_;
	GValue _tmp46_ = {0};
	ClutterPropertyTransition* _tmp47_;
	ClutterPropertyTransition* _tmp48_;
	ClutterActor* _tmp49_;
	ClutterActor* _tmp50_;
	ClutterTransitionGroup* _tmp51_;
	ClutterPropertyTransition* _tmp52_;
#line 381 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/game.vala"
	g_return_if_fail (from != NULL);
#line 381 "../src/game.vala"
	g_return_if_fail (to != NULL);
#line 383 "../src/game.vala"
	_tmp0_ = grid_position_to_string (from);
#line 383 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 383 "../src/game.vala"
	_tmp2_ = grid_position_to_string (to);
#line 383 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 383 "../src/game.vala"
	_tmp4_ = g_strconcat ("prepare move tile from ", _tmp1_, " to ", _tmp3_, NULL);
#line 383 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 383 "../src/game.vala"
	g_debug ("game.vala:383: %s", _tmp5_);
#line 383 "../src/game.vala"
	_g_free0 (_tmp5_);
#line 383 "../src/game.vala"
	_g_free0 (_tmp3_);
#line 383 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 385 "../src/game.vala"
	_tmp6_ = *from;
#line 385 "../src/game.vala"
	_tmp7_ = *to;
#line 385 "../src/game.vala"
	row_move = _tmp6_.col == _tmp7_.col;
#line 387 "../src/game.vala"
	_tmp8_ = self->priv->_background;
#line 387 "../src/game.vala"
	_tmp8__length1 = self->priv->_background_length1;
#line 387 "../src/game.vala"
	_tmp8__length2 = self->priv->_background_length2;
#line 387 "../src/game.vala"
	_tmp9_ = *from;
#line 387 "../src/game.vala"
	_tmp10_ = *from;
#line 387 "../src/game.vala"
	_tmp11_ = _tmp8_[(_tmp9_.row * _tmp8__length2) + _tmp10_.col];
#line 387 "../src/game.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 387 "../src/game.vala"
	rect_from = _tmp12_;
#line 388 "../src/game.vala"
	_tmp13_ = self->priv->_background;
#line 388 "../src/game.vala"
	_tmp13__length1 = self->priv->_background_length1;
#line 388 "../src/game.vala"
	_tmp13__length2 = self->priv->_background_length2;
#line 388 "../src/game.vala"
	_tmp14_ = *to;
#line 388 "../src/game.vala"
	_tmp15_ = *to;
#line 388 "../src/game.vala"
	_tmp16_ = _tmp13_[(_tmp14_.row * _tmp13__length2) + _tmp15_.col];
#line 388 "../src/game.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 388 "../src/game.vala"
	rect_to = _tmp17_;
#line 390 "../src/game.vala"
	_tmp18_ = self->priv->_foreground_cur;
#line 390 "../src/game.vala"
	_tmp18__length1 = self->priv->_foreground_cur_length1;
#line 390 "../src/game.vala"
	_tmp18__length2 = self->priv->_foreground_cur_length2;
#line 390 "../src/game.vala"
	_tmp19_ = *from;
#line 390 "../src/game.vala"
	_tmp20_ = *from;
#line 390 "../src/game.vala"
	_tmp21_ = _tmp18_[(_tmp19_.row * _tmp18__length2) + _tmp20_.col];
#line 390 "../src/game.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 390 "../src/game.vala"
	tile_view = _tmp22_;
#line 391 "../src/game.vala"
	if (tile_view == NULL) {
#line 392 "../src/game.vala"
		g_assert_not_reached ();
#line 2277 "game.c"
	}
#line 394 "../src/game.vala"
	if (row_move) {
#line 394 "../src/game.vala"
		_tmp23_ = "y";
#line 2283 "game.c"
	} else {
#line 394 "../src/game.vala"
		_tmp23_ = "x";
#line 2287 "game.c"
	}
#line 394 "../src/game.vala"
	_tmp24_ = (ClutterPropertyTransition*) clutter_property_transition_new (_tmp23_);
#line 394 "../src/game.vala"
	trans = _tmp24_;
#line 395 "../src/game.vala"
	if (row_move) {
#line 2295 "game.c"
		ClutterActor* _tmp26_;
		ClutterActor* _tmp27_;
		gfloat _tmp28_;
		gfloat _tmp29_;
#line 395 "../src/game.vala"
		_tmp26_ = rounded_rectangle_get_actor (rect_from);
#line 395 "../src/game.vala"
		_tmp27_ = _tmp26_;
#line 395 "../src/game.vala"
		_tmp28_ = clutter_actor_get_y (_tmp27_);
#line 395 "../src/game.vala"
		_tmp29_ = _tmp28_;
#line 395 "../src/game.vala"
		_tmp25_ = _tmp29_;
#line 2310 "game.c"
	} else {
		ClutterActor* _tmp30_;
		ClutterActor* _tmp31_;
		gfloat _tmp32_;
		gfloat _tmp33_;
#line 395 "../src/game.vala"
		_tmp30_ = rounded_rectangle_get_actor (rect_from);
#line 395 "../src/game.vala"
		_tmp31_ = _tmp30_;
#line 395 "../src/game.vala"
		_tmp32_ = clutter_actor_get_x (_tmp31_);
#line 395 "../src/game.vala"
		_tmp33_ = _tmp32_;
#line 395 "../src/game.vala"
		_tmp25_ = _tmp33_;
#line 2326 "game.c"
	}
#line 395 "../src/game.vala"
	_tmp34_ = trans;
#line 395 "../src/game.vala"
	g_value_init (&_tmp35_, G_TYPE_FLOAT);
#line 395 "../src/game.vala"
	g_value_set_float (&_tmp35_, _tmp25_);
#line 395 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) _tmp34_, &_tmp35_);
#line 395 "../src/game.vala"
	G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
#line 396 "../src/game.vala"
	if (row_move) {
#line 2340 "game.c"
		ClutterActor* _tmp37_;
		ClutterActor* _tmp38_;
		gfloat _tmp39_;
		gfloat _tmp40_;
#line 396 "../src/game.vala"
		_tmp37_ = rounded_rectangle_get_actor (rect_to);
#line 396 "../src/game.vala"
		_tmp38_ = _tmp37_;
#line 396 "../src/game.vala"
		_tmp39_ = clutter_actor_get_y (_tmp38_);
#line 396 "../src/game.vala"
		_tmp40_ = _tmp39_;
#line 396 "../src/game.vala"
		_tmp36_ = _tmp40_;
#line 2355 "game.c"
	} else {
		ClutterActor* _tmp41_;
		ClutterActor* _tmp42_;
		gfloat _tmp43_;
		gfloat _tmp44_;
#line 396 "../src/game.vala"
		_tmp41_ = rounded_rectangle_get_actor (rect_to);
#line 396 "../src/game.vala"
		_tmp42_ = _tmp41_;
#line 396 "../src/game.vala"
		_tmp43_ = clutter_actor_get_x (_tmp42_);
#line 396 "../src/game.vala"
		_tmp44_ = _tmp43_;
#line 396 "../src/game.vala"
		_tmp36_ = _tmp44_;
#line 2371 "game.c"
	}
#line 396 "../src/game.vala"
	_tmp45_ = trans;
#line 396 "../src/game.vala"
	g_value_init (&_tmp46_, G_TYPE_FLOAT);
#line 396 "../src/game.vala"
	g_value_set_float (&_tmp46_, _tmp36_);
#line 396 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) _tmp45_, &_tmp46_);
#line 396 "../src/game.vala"
	G_IS_VALUE (&_tmp46_) ? (g_value_unset (&_tmp46_), NULL) : NULL;
#line 397 "../src/game.vala"
	_tmp47_ = trans;
#line 397 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp47_, (guint) self->priv->_animations_duration);
#line 398 "../src/game.vala"
	_tmp48_ = trans;
#line 398 "../src/game.vala"
	_tmp49_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 398 "../src/game.vala"
	_tmp50_ = _tmp49_;
#line 398 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) _tmp48_, (ClutterAnimatable*) _tmp50_);
#line 399 "../src/game.vala"
	_tmp51_ = self->priv->_move_trans;
#line 399 "../src/game.vala"
	_tmp52_ = trans;
#line 399 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp51_, (ClutterTransition*) _tmp52_);
#line 381 "../src/game.vala"
	_g_object_unref0 (trans);
#line 381 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 381 "../src/game.vala"
	_g_object_unref0 (rect_to);
#line 381 "../src/game.vala"
	_g_object_unref0 (rect_from);
#line 2409 "game.c"
}

static void
_game_dim_tile (Game* self,
                GridPosition* pos)
{
	TileView* tile_view = NULL;
	TileView** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GridPosition _tmp1_;
	GridPosition _tmp2_;
	TileView* _tmp3_;
	TileView* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	ClutterActor* actor = NULL;
	ClutterPropertyTransition* trans = NULL;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	ClutterActor* _tmp17_;
	ClutterPropertyTransition* _tmp18_;
	guint _tmp19_;
	guint _tmp20_;
	GValue _tmp21_ = {0};
	GValue _tmp22_ = {0};
	ClutterTransitionGroup* _tmp23_;
#line 402 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/game.vala"
	g_return_if_fail (pos != NULL);
#line 404 "../src/game.vala"
	_tmp0_ = self->priv->_foreground_cur;
#line 404 "../src/game.vala"
	_tmp0__length1 = self->priv->_foreground_cur_length1;
#line 404 "../src/game.vala"
	_tmp0__length2 = self->priv->_foreground_cur_length2;
#line 404 "../src/game.vala"
	_tmp1_ = *pos;
#line 404 "../src/game.vala"
	_tmp2_ = *pos;
#line 404 "../src/game.vala"
	_tmp3_ = _tmp0_[(_tmp1_.row * _tmp0__length2) + _tmp2_.col];
#line 404 "../src/game.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 404 "../src/game.vala"
	tile_view = _tmp4_;
#line 405 "../src/game.vala"
	if (tile_view == NULL) {
#line 406 "../src/game.vala"
		g_assert_not_reached ();
#line 2469 "game.c"
	}
#line 407 "../src/game.vala"
	_tmp5_ = grid_position_to_string (pos);
#line 407 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 407 "../src/game.vala"
	_tmp7_ = g_strconcat ("diming tile at ", _tmp6_, " ", NULL);
#line 407 "../src/game.vala"
	_tmp8_ = _tmp7_;
#line 407 "../src/game.vala"
	_tmp9_ = rounded_rectangle_get_color ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 407 "../src/game.vala"
	_tmp10_ = _tmp9_;
#line 407 "../src/game.vala"
	_tmp11_ = g_strdup_printf ("%hhu", _tmp10_);
#line 407 "../src/game.vala"
	_tmp12_ = _tmp11_;
#line 407 "../src/game.vala"
	_tmp13_ = g_strconcat (_tmp8_, _tmp12_, NULL);
#line 407 "../src/game.vala"
	_tmp14_ = _tmp13_;
#line 407 "../src/game.vala"
	g_debug ("game.vala:407: %s", _tmp14_);
#line 407 "../src/game.vala"
	_g_free0 (_tmp14_);
#line 407 "../src/game.vala"
	_g_free0 (_tmp12_);
#line 407 "../src/game.vala"
	_g_free0 (_tmp8_);
#line 407 "../src/game.vala"
	_g_free0 (_tmp6_);
#line 412 "../src/game.vala"
	_tmp15_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (tile_view, TYPE_TILE_VIEW, TileView));
#line 412 "../src/game.vala"
	_tmp16_ = _tmp15_;
#line 412 "../src/game.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 412 "../src/game.vala"
	_g_object_unref0 (actor);
#line 412 "../src/game.vala"
	actor = _tmp17_;
#line 414 "../src/game.vala"
	_tmp18_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
#line 414 "../src/game.vala"
	_g_object_unref0 (trans);
#line 414 "../src/game.vala"
	trans = _tmp18_;
#line 415 "../src/game.vala"
	_tmp19_ = clutter_actor_get_opacity (actor);
#line 415 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 415 "../src/game.vala"
	g_value_init (&_tmp21_, G_TYPE_UINT);
#line 415 "../src/game.vala"
	g_value_set_uint (&_tmp21_, _tmp20_);
#line 415 "../src/game.vala"
	clutter_transition_set_from_value ((ClutterTransition*) trans, &_tmp21_);
#line 415 "../src/game.vala"
	G_IS_VALUE (&_tmp21_) ? (g_value_unset (&_tmp21_), NULL) : NULL;
#line 416 "../src/game.vala"
	g_value_init (&_tmp22_, G_TYPE_INT);
#line 416 "../src/game.vala"
	g_value_set_int (&_tmp22_, 0);
#line 416 "../src/game.vala"
	clutter_transition_set_to_value ((ClutterTransition*) trans, &_tmp22_);
#line 416 "../src/game.vala"
	G_IS_VALUE (&_tmp22_) ? (g_value_unset (&_tmp22_), NULL) : NULL;
#line 417 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) trans, (guint) self->priv->_animations_duration);
#line 418 "../src/game.vala"
	clutter_transition_set_animatable ((ClutterTransition*) trans, (ClutterAnimatable*) actor);
#line 420 "../src/game.vala"
	_tmp23_ = self->priv->_show_hide_trans;
#line 420 "../src/game.vala"
	clutter_transition_group_add_transition (_tmp23_, (ClutterTransition*) trans);
#line 402 "../src/game.vala"
	_g_object_unref0 (trans);
#line 402 "../src/game.vala"
	_g_object_unref0 (actor);
#line 402 "../src/game.vala"
	_g_object_unref0 (tile_view);
#line 2551 "game.c"
}

static void
_game_clear_background (Game* self)
{
	ClutterActor* _tmp0_;
#line 423 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/game.vala"
	_tmp0_ = self->priv->_view_background;
#line 425 "../src/game.vala"
	clutter_actor_remove_all_children (_tmp0_);
#line 2564 "game.c"
}

static void
_game_clear_foreground (Game* self)
{
	guint8 rows = 0U;
	Grid* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 cols = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	ClutterActor* _tmp6_;
#line 428 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 430 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 430 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 430 "../src/game.vala"
	rows = _tmp2_;
#line 431 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 431 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 431 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 431 "../src/game.vala"
	cols = _tmp5_;
#line 432 "../src/game.vala"
	_tmp6_ = self->priv->_view_foreground;
#line 432 "../src/game.vala"
	clutter_actor_remove_all_children (_tmp6_);
#line 2601 "game.c"
	{
		guint8 i = 0U;
#line 433 "../src/game.vala"
		i = (guint8) 0;
#line 2606 "game.c"
		{
			gboolean _tmp7_ = FALSE;
#line 433 "../src/game.vala"
			_tmp7_ = TRUE;
#line 433 "../src/game.vala"
			while (TRUE) {
#line 433 "../src/game.vala"
				if (!_tmp7_) {
#line 2615 "game.c"
					guint8 _tmp8_;
#line 433 "../src/game.vala"
					_tmp8_ = i;
#line 433 "../src/game.vala"
					i = _tmp8_ + 1;
#line 2621 "game.c"
				}
#line 433 "../src/game.vala"
				_tmp7_ = FALSE;
#line 433 "../src/game.vala"
				if (!(i < rows)) {
#line 433 "../src/game.vala"
					break;
#line 2629 "game.c"
				}
				{
					guint8 j = 0U;
#line 435 "../src/game.vala"
					j = (guint8) 0;
#line 2635 "game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 435 "../src/game.vala"
						_tmp9_ = TRUE;
#line 435 "../src/game.vala"
						while (TRUE) {
#line 2642 "game.c"
							TileView** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							TileView* _tmp12_;
							TileView** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							TileView* _tmp15_;
#line 435 "../src/game.vala"
							if (!_tmp9_) {
#line 2653 "game.c"
								guint8 _tmp10_;
#line 435 "../src/game.vala"
								_tmp10_ = j;
#line 435 "../src/game.vala"
								j = _tmp10_ + 1;
#line 2659 "game.c"
							}
#line 435 "../src/game.vala"
							_tmp9_ = FALSE;
#line 435 "../src/game.vala"
							if (!(j < cols)) {
#line 435 "../src/game.vala"
								break;
#line 2667 "game.c"
							}
#line 437 "../src/game.vala"
							_tmp11_ = self->priv->_foreground_cur;
#line 437 "../src/game.vala"
							_tmp11__length1 = self->priv->_foreground_cur_length1;
#line 437 "../src/game.vala"
							_tmp11__length2 = self->priv->_foreground_cur_length2;
#line 437 "../src/game.vala"
							_tmp12_ = _tmp11_[(i * _tmp11__length2) + j];
#line 437 "../src/game.vala"
							if (_tmp12_ != NULL) {
#line 2679 "game.c"
								TileView** _tmp13_;
								gint _tmp13__length1;
								gint _tmp13__length2;
#line 438 "../src/game.vala"
								_tmp13_ = self->priv->_foreground_cur;
#line 438 "../src/game.vala"
								_tmp13__length1 = self->priv->_foreground_cur_length1;
#line 438 "../src/game.vala"
								_tmp13__length2 = self->priv->_foreground_cur_length2;
#line 438 "../src/game.vala"
								_g_object_unref0 (_tmp13_[(i * _tmp13__length2) + j]);
#line 438 "../src/game.vala"
								_tmp13_[(i * _tmp13__length2) + j] = NULL;
#line 2693 "game.c"
							}
#line 439 "../src/game.vala"
							_tmp14_ = self->priv->_foreground_nxt;
#line 439 "../src/game.vala"
							_tmp14__length1 = self->priv->_foreground_nxt_length1;
#line 439 "../src/game.vala"
							_tmp14__length2 = self->priv->_foreground_nxt_length2;
#line 439 "../src/game.vala"
							_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 439 "../src/game.vala"
							if (_tmp15_ != NULL) {
#line 2705 "game.c"
								TileView** _tmp16_;
								gint _tmp16__length1;
								gint _tmp16__length2;
#line 440 "../src/game.vala"
								_tmp16_ = self->priv->_foreground_nxt;
#line 440 "../src/game.vala"
								_tmp16__length1 = self->priv->_foreground_nxt_length1;
#line 440 "../src/game.vala"
								_tmp16__length2 = self->priv->_foreground_nxt_length2;
#line 440 "../src/game.vala"
								_g_object_unref0 (_tmp16_[(i * _tmp16__length2) + j]);
#line 440 "../src/game.vala"
								_tmp16_[(i * _tmp16__length2) + j] = NULL;
#line 2719 "game.c"
							}
						}
					}
				}
			}
		}
	}
}

static void
_game_restore_foreground (Game* self,
                          gboolean animate)
{
	guint8 rows = 0U;
	Grid* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 cols = 0U;
	Grid* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	GeeLinkedList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 445 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 447 "../src/game.vala"
	_tmp1_ = grid_get_rows (_tmp0_);
#line 447 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 447 "../src/game.vala"
	rows = _tmp2_;
#line 448 "../src/game.vala"
	_tmp3_ = self->priv->_grid;
#line 448 "../src/game.vala"
	_tmp4_ = grid_get_cols (_tmp3_);
#line 448 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 448 "../src/game.vala"
	cols = _tmp5_;
#line 450 "../src/game.vala"
	_game_create_show_hide_transition (self, animate);
#line 2764 "game.c"
	{
		guint8 i = 0U;
#line 452 "../src/game.vala"
		i = (guint8) 0;
#line 2769 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 452 "../src/game.vala"
			_tmp6_ = TRUE;
#line 452 "../src/game.vala"
			while (TRUE) {
#line 452 "../src/game.vala"
				if (!_tmp6_) {
#line 2778 "game.c"
					guint8 _tmp7_;
#line 452 "../src/game.vala"
					_tmp7_ = i;
#line 452 "../src/game.vala"
					i = _tmp7_ + 1;
#line 2784 "game.c"
				}
#line 452 "../src/game.vala"
				_tmp6_ = FALSE;
#line 452 "../src/game.vala"
				if (!(i < rows)) {
#line 452 "../src/game.vala"
					break;
#line 2792 "game.c"
				}
				{
					guint8 j = 0U;
#line 454 "../src/game.vala"
					j = (guint8) 0;
#line 2798 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 454 "../src/game.vala"
						_tmp8_ = TRUE;
#line 454 "../src/game.vala"
						while (TRUE) {
#line 2805 "game.c"
							guint8 val = 0U;
							Grid* _tmp10_;
#line 454 "../src/game.vala"
							if (!_tmp8_) {
#line 2810 "game.c"
								guint8 _tmp9_;
#line 454 "../src/game.vala"
								_tmp9_ = j;
#line 454 "../src/game.vala"
								j = _tmp9_ + 1;
#line 2816 "game.c"
							}
#line 454 "../src/game.vala"
							_tmp8_ = FALSE;
#line 454 "../src/game.vala"
							if (!(j < cols)) {
#line 454 "../src/game.vala"
								break;
#line 2824 "game.c"
							}
#line 456 "../src/game.vala"
							_tmp10_ = self->priv->_grid;
#line 456 "../src/game.vala"
							val = grid_get (_tmp10_, i, j);
#line 457 "../src/game.vala"
							if (((gint) val) != 0) {
#line 2832 "game.c"
								GridPosition pos = {0};
								GridPosition _tmp11_ = {0};
								Tile tile = {0};
								GridPosition _tmp12_;
								Tile _tmp13_ = {0};
								Tile _tmp14_;
								GeeLinkedList* _tmp15_;
								Tile _tmp16_;
								GridPosition _tmp17_;
#line 459 "../src/game.vala"
								_tmp11_.row = (gint8) i;
#line 459 "../src/game.vala"
								_tmp11_.col = (gint8) j;
#line 459 "../src/game.vala"
								pos = _tmp11_;
#line 460 "../src/game.vala"
								_tmp12_ = pos;
#line 460 "../src/game.vala"
								_tmp13_.pos = _tmp12_;
#line 460 "../src/game.vala"
								_tmp13_.val = val;
#line 460 "../src/game.vala"
								tile = _tmp13_;
#line 461 "../src/game.vala"
								_tmp14_ = tile;
#line 461 "../src/game.vala"
								_game_create_tile (self, &_tmp14_);
#line 462 "../src/game.vala"
								_tmp15_ = self->priv->_to_show;
#line 462 "../src/game.vala"
								_tmp16_ = tile;
#line 462 "../src/game.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, &_tmp16_);
#line 463 "../src/game.vala"
								_tmp17_ = pos;
#line 463 "../src/game.vala"
								_game_show_tile (self, &_tmp17_);
#line 2870 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 468 "../src/game.vala"
	_tmp18_ = self->priv->_to_show;
#line 468 "../src/game.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 468 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 468 "../src/game.vala"
	if (_tmp20_ > 0) {
#line 2886 "game.c"
		ClutterTransitionGroup* _tmp21_;
#line 470 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_RESTORING_TILES;
#line 471 "../src/game.vala"
		_tmp21_ = self->priv->_show_hide_trans;
#line 471 "../src/game.vala"
		clutter_timeline_start ((ClutterTimeline*) _tmp21_);
#line 2894 "game.c"
	}
}

static void
__game_on_move_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                       gboolean is_finished,
                                                       gpointer self)
{
#line 491 "../src/game.vala"
	_game_on_move_trans_stopped ((Game*) self, _sender, is_finished);
#line 2905 "game.c"
}

void
game_move (Game* self,
           MoveRequest request)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	Grid* clone = NULL;
	Grid* _tmp2_;
	Grid* _tmp3_;
	ClutterTransitionGroup* _tmp4_;
	ClutterTransitionGroup* _tmp5_;
	ClutterTransitionGroup* _tmp6_;
	Grid* _tmp7_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GeeLinkedList* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
#line 479 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/game.vala"
	if (self->priv->_state == GAME_GAME_STATE_SHOWING_NEW_TILE) {
#line 482 "../src/game.vala"
		_game_apply_move (self);
#line 2932 "game.c"
	} else {
#line 483 "../src/game.vala"
		if (self->priv->_state != GAME_GAME_STATE_IDLE) {
#line 484 "../src/game.vala"
			g_assert_not_reached ();
#line 2938 "game.c"
		}
	}
#line 486 "../src/game.vala"
	_tmp0_ = move_request_debug_string (request);
#line 486 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 486 "../src/game.vala"
	g_debug ("game.vala:486: %s", _tmp1_);
#line 486 "../src/game.vala"
	_g_free0 (_tmp1_);
#line 488 "../src/game.vala"
	_tmp2_ = self->priv->_grid;
#line 488 "../src/game.vala"
	_tmp3_ = grid_clone (_tmp2_);
#line 488 "../src/game.vala"
	clone = _tmp3_;
#line 490 "../src/game.vala"
	_tmp4_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 490 "../src/game.vala"
	_g_object_unref0 (self->priv->_move_trans);
#line 490 "../src/game.vala"
	self->priv->_move_trans = _tmp4_;
#line 491 "../src/game.vala"
	_tmp5_ = self->priv->_move_trans;
#line 491 "../src/game.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp5_, "stopped", (GCallback) __game_on_move_trans_stopped_clutter_timeline_stopped, self, 0);
#line 492 "../src/game.vala"
	_tmp6_ = self->priv->_move_trans;
#line 492 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp6_, (guint) self->priv->_animations_duration);
#line 494 "../src/game.vala"
	_tmp7_ = self->priv->_grid;
#line 494 "../src/game.vala"
	grid_move (_tmp7_, request, &self->priv->_to_move, &self->priv->_to_hide, &self->priv->_to_show);
#line 2973 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp8_;
		gint _e_size = 0;
		GeeLinkedList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _e_index = 0;
#line 496 "../src/game.vala"
		_tmp8_ = self->priv->_to_move;
#line 496 "../src/game.vala"
		_e_list = _tmp8_;
#line 496 "../src/game.vala"
		_tmp9_ = _e_list;
#line 496 "../src/game.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 496 "../src/game.vala"
		_tmp11_ = _tmp10_;
#line 496 "../src/game.vala"
		_e_size = _tmp11_;
#line 496 "../src/game.vala"
		_e_index = -1;
#line 496 "../src/game.vala"
		while (TRUE) {
#line 2998 "game.c"
			gint _tmp12_;
			gint _tmp13_;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp14_;
			gpointer _tmp15_;
			TileMovement* _tmp16_;
			TileMovement* _tmp17_;
			GridPosition _tmp18_;
			TileMovement* _tmp19_;
			GridPosition _tmp20_;
#line 496 "../src/game.vala"
			_e_index = _e_index + 1;
#line 496 "../src/game.vala"
			_tmp12_ = _e_index;
#line 496 "../src/game.vala"
			_tmp13_ = _e_size;
#line 496 "../src/game.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 496 "../src/game.vala"
				break;
#line 3019 "game.c"
			}
#line 496 "../src/game.vala"
			_tmp14_ = _e_list;
#line 496 "../src/game.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _e_index);
#line 496 "../src/game.vala"
			e = (TileMovement*) _tmp15_;
#line 498 "../src/game.vala"
			_tmp16_ = e;
#line 498 "../src/game.vala"
			if (_tmp16_ == NULL) {
#line 499 "../src/game.vala"
				g_assert_not_reached ();
#line 3033 "game.c"
			}
#line 500 "../src/game.vala"
			_tmp17_ = e;
#line 500 "../src/game.vala"
			_tmp18_ = ((TileMovement) (*_tmp17_)).from;
#line 500 "../src/game.vala"
			_tmp19_ = e;
#line 500 "../src/game.vala"
			_tmp20_ = ((TileMovement) (*_tmp19_)).to;
#line 500 "../src/game.vala"
			_game_move_tile (self, &_tmp18_, &_tmp20_);
#line 496 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3047 "game.c"
		}
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp21_;
		gint _e_size = 0;
		GeeLinkedList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _e_index = 0;
#line 502 "../src/game.vala"
		_tmp21_ = self->priv->_to_hide;
#line 502 "../src/game.vala"
		_e_list = _tmp21_;
#line 502 "../src/game.vala"
		_tmp22_ = _e_list;
#line 502 "../src/game.vala"
		_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 502 "../src/game.vala"
		_tmp24_ = _tmp23_;
#line 502 "../src/game.vala"
		_e_size = _tmp24_;
#line 502 "../src/game.vala"
		_e_index = -1;
#line 502 "../src/game.vala"
		while (TRUE) {
#line 3074 "game.c"
			gint _tmp25_;
			gint _tmp26_;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp27_;
			gpointer _tmp28_;
			TileMovement* _tmp29_;
			TileMovement* _tmp30_;
			GridPosition _tmp31_;
			TileMovement* _tmp32_;
			GridPosition _tmp33_;
#line 502 "../src/game.vala"
			_e_index = _e_index + 1;
#line 502 "../src/game.vala"
			_tmp25_ = _e_index;
#line 502 "../src/game.vala"
			_tmp26_ = _e_size;
#line 502 "../src/game.vala"
			if (!(_tmp25_ < _tmp26_)) {
#line 502 "../src/game.vala"
				break;
#line 3095 "game.c"
			}
#line 502 "../src/game.vala"
			_tmp27_ = _e_list;
#line 502 "../src/game.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _e_index);
#line 502 "../src/game.vala"
			e = (TileMovement*) _tmp28_;
#line 504 "../src/game.vala"
			_tmp29_ = e;
#line 504 "../src/game.vala"
			if (_tmp29_ == NULL) {
#line 505 "../src/game.vala"
				g_assert_not_reached ();
#line 3109 "game.c"
			}
#line 506 "../src/game.vala"
			_tmp30_ = e;
#line 506 "../src/game.vala"
			_tmp31_ = ((TileMovement) (*_tmp30_)).from;
#line 506 "../src/game.vala"
			_tmp32_ = e;
#line 506 "../src/game.vala"
			_tmp33_ = ((TileMovement) (*_tmp32_)).to;
#line 506 "../src/game.vala"
			_game_prepare_move_tile (self, &_tmp31_, &_tmp33_);
#line 502 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3123 "game.c"
		}
	}
#line 509 "../src/game.vala"
	_tmp36_ = self->priv->_to_move;
#line 509 "../src/game.vala"
	_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 509 "../src/game.vala"
	_tmp38_ = _tmp37_;
#line 509 "../src/game.vala"
	if (_tmp38_ > 0) {
#line 509 "../src/game.vala"
		_tmp35_ = TRUE;
#line 3136 "game.c"
	} else {
		GeeLinkedList* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
#line 509 "../src/game.vala"
		_tmp39_ = self->priv->_to_hide;
#line 509 "../src/game.vala"
		_tmp40_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp39_);
#line 509 "../src/game.vala"
		_tmp41_ = _tmp40_;
#line 509 "../src/game.vala"
		_tmp35_ = _tmp41_ > 0;
#line 3149 "game.c"
	}
#line 509 "../src/game.vala"
	if (_tmp35_) {
#line 509 "../src/game.vala"
		_tmp34_ = TRUE;
#line 3155 "game.c"
	} else {
		GeeLinkedList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
#line 509 "../src/game.vala"
		_tmp42_ = self->priv->_to_show;
#line 509 "../src/game.vala"
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 509 "../src/game.vala"
		_tmp44_ = _tmp43_;
#line 509 "../src/game.vala"
		_tmp34_ = _tmp44_ > 0;
#line 3168 "game.c"
	}
#line 509 "../src/game.vala"
	if (_tmp34_) {
#line 3172 "game.c"
		ClutterTransitionGroup* _tmp45_;
		Grid* _tmp46_;
#line 511 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_MOVING;
#line 512 "../src/game.vala"
		_tmp45_ = self->priv->_move_trans;
#line 512 "../src/game.vala"
		clutter_timeline_start ((ClutterTimeline*) _tmp45_);
#line 513 "../src/game.vala"
		_tmp46_ = clone;
#line 513 "../src/game.vala"
		_game_store_movement (self, _tmp46_);
#line 3185 "game.c"
	}
#line 516 "../src/game.vala"
	self->priv->_just_restored = FALSE;
#line 479 "../src/game.vala"
	_g_object_unref0 (clone);
#line 3191 "game.c"
}

static void
_game_on_move_trans_stopped (Game* self,
                             ClutterTimeline* trans,
                             gboolean is_finished)
{
	Grid* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	glong delta_score = 0L;
	glong _tmp30_;
#line 519 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 519 "../src/game.vala"
	g_return_if_fail (trans != NULL);
#line 521 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 521 "../src/game.vala"
	_tmp1_ = grid_to_string (_tmp0_);
#line 521 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 521 "../src/game.vala"
	_tmp3_ = g_strconcat ("move animation stopped\n", _tmp2_, NULL);
#line 521 "../src/game.vala"
	_tmp4_ = _tmp3_;
#line 521 "../src/game.vala"
	g_debug ("game.vala:521: %s", _tmp4_);
#line 521 "../src/game.vala"
	_g_free0 (_tmp4_);
#line 521 "../src/game.vala"
	_g_free0 (_tmp2_);
#line 523 "../src/game.vala"
	clutter_transition_group_remove_all (G_TYPE_CHECK_INSTANCE_CAST (trans, clutter_transition_group_get_type (), ClutterTransitionGroup));
#line 3228 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp5_;
		gint _e_size = 0;
		GeeLinkedList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _e_index = 0;
#line 525 "../src/game.vala"
		_tmp5_ = self->priv->_to_hide;
#line 525 "../src/game.vala"
		_e_list = _tmp5_;
#line 525 "../src/game.vala"
		_tmp6_ = _e_list;
#line 525 "../src/game.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 525 "../src/game.vala"
		_tmp8_ = _tmp7_;
#line 525 "../src/game.vala"
		_e_size = _tmp8_;
#line 525 "../src/game.vala"
		_e_index = -1;
#line 525 "../src/game.vala"
		while (TRUE) {
#line 3253 "game.c"
			gint _tmp9_;
			gint _tmp10_;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp11_;
			gpointer _tmp12_;
			TileMovement* _tmp13_;
			TileMovement* _tmp14_;
			GridPosition _tmp15_;
#line 525 "../src/game.vala"
			_e_index = _e_index + 1;
#line 525 "../src/game.vala"
			_tmp9_ = _e_index;
#line 525 "../src/game.vala"
			_tmp10_ = _e_size;
#line 525 "../src/game.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 525 "../src/game.vala"
				break;
#line 3272 "game.c"
			}
#line 525 "../src/game.vala"
			_tmp11_ = _e_list;
#line 525 "../src/game.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _e_index);
#line 525 "../src/game.vala"
			e = (TileMovement*) _tmp12_;
#line 527 "../src/game.vala"
			_tmp13_ = e;
#line 527 "../src/game.vala"
			if (_tmp13_ == NULL) {
#line 528 "../src/game.vala"
				g_assert_not_reached ();
#line 3286 "game.c"
			}
#line 529 "../src/game.vala"
			_tmp14_ = e;
#line 529 "../src/game.vala"
			_tmp15_ = ((TileMovement) (*_tmp14_)).from;
#line 529 "../src/game.vala"
			_game_dim_tile (self, &_tmp15_);
#line 525 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3296 "game.c"
		}
	}
#line 532 "../src/game.vala"
	delta_score = (glong) 0;
#line 3301 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp16_;
		gint _e_size = 0;
		GeeLinkedList* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _e_index = 0;
#line 533 "../src/game.vala"
		_tmp16_ = self->priv->_to_show;
#line 533 "../src/game.vala"
		_e_list = _tmp16_;
#line 533 "../src/game.vala"
		_tmp17_ = _e_list;
#line 533 "../src/game.vala"
		_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 533 "../src/game.vala"
		_tmp19_ = _tmp18_;
#line 533 "../src/game.vala"
		_e_size = _tmp19_;
#line 533 "../src/game.vala"
		_e_index = -1;
#line 533 "../src/game.vala"
		while (TRUE) {
#line 3326 "game.c"
			gint _tmp20_;
			gint _tmp21_;
			Tile* e = NULL;
			GeeLinkedList* _tmp22_;
			gpointer _tmp23_;
			Tile* _tmp24_;
			Tile* _tmp25_;
			Tile _tmp26_;
			Tile* _tmp27_;
			GridPosition _tmp28_;
			Tile* _tmp29_;
#line 533 "../src/game.vala"
			_e_index = _e_index + 1;
#line 533 "../src/game.vala"
			_tmp20_ = _e_index;
#line 533 "../src/game.vala"
			_tmp21_ = _e_size;
#line 533 "../src/game.vala"
			if (!(_tmp20_ < _tmp21_)) {
#line 533 "../src/game.vala"
				break;
#line 3348 "game.c"
			}
#line 533 "../src/game.vala"
			_tmp22_ = _e_list;
#line 533 "../src/game.vala"
			_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _e_index);
#line 533 "../src/game.vala"
			e = (Tile*) _tmp23_;
#line 535 "../src/game.vala"
			_tmp24_ = e;
#line 535 "../src/game.vala"
			if (_tmp24_ == NULL) {
#line 536 "../src/game.vala"
				g_assert_not_reached ();
#line 3362 "game.c"
			}
#line 537 "../src/game.vala"
			_tmp25_ = e;
#line 537 "../src/game.vala"
			_tmp26_ = (Tile) (*_tmp25_);
#line 537 "../src/game.vala"
			_game_create_tile (self, &_tmp26_);
#line 538 "../src/game.vala"
			_tmp27_ = e;
#line 538 "../src/game.vala"
			_tmp28_ = ((Tile) (*_tmp27_)).pos;
#line 538 "../src/game.vala"
			_game_show_tile (self, &_tmp28_);
#line 539 "../src/game.vala"
			_tmp29_ = e;
#line 539 "../src/game.vala"
			delta_score += (glong) pow ((gdouble) 2, (gdouble) ((Tile) (*_tmp29_)).val);
#line 533 "../src/game.vala"
			_tile_free0 (e);
#line 3382 "game.c"
		}
	}
#line 541 "../src/game.vala"
	_tmp30_ = self->priv->_score;
#line 541 "../src/game.vala"
	game_set_score (self, _tmp30_ + delta_score);
#line 543 "../src/game.vala"
	_game_create_random_tile (self);
#line 3391 "game.c"
}

static void
__game_on_show_hide_trans_stopped_clutter_timeline_stopped (ClutterTimeline* _sender,
                                                            gboolean is_finished,
                                                            gpointer self)
{
#line 559 "../src/game.vala"
	_game_on_show_hide_trans_stopped ((Game*) self, _sender, is_finished);
#line 3401 "game.c"
}

static void
_game_create_show_hide_transition (Game* self,
                                   gboolean animate)
{
	ClutterTransitionGroup* _tmp0_;
	ClutterTransitionGroup* _tmp1_;
	gint _tmp2_ = 0;
	ClutterTransitionGroup* _tmp3_;
#line 556 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 558 "../src/game.vala"
	_tmp0_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
#line 558 "../src/game.vala"
	_g_object_unref0 (self->priv->_show_hide_trans);
#line 558 "../src/game.vala"
	self->priv->_show_hide_trans = _tmp0_;
#line 559 "../src/game.vala"
	_tmp1_ = self->priv->_show_hide_trans;
#line 559 "../src/game.vala"
	g_signal_connect_object ((ClutterTimeline*) _tmp1_, "stopped", (GCallback) __game_on_show_hide_trans_stopped_clutter_timeline_stopped, self, 0);
#line 562 "../src/game.vala"
	if (animate) {
#line 562 "../src/game.vala"
		_tmp2_ = self->priv->_animations_duration / 3;
#line 3428 "game.c"
	} else {
#line 562 "../src/game.vala"
		_tmp2_ = 10;
#line 3432 "game.c"
	}
#line 562 "../src/game.vala"
	_tmp3_ = self->priv->_show_hide_trans;
#line 562 "../src/game.vala"
	clutter_timeline_set_duration ((ClutterTimeline*) _tmp3_, (guint) _tmp2_);
#line 3438 "game.c"
}

static void
_game_on_show_hide_trans_stopped (Game* self,
                                  ClutterTimeline* trans,
                                  gboolean is_finished)
{
	ClutterTimelineDirection _tmp0_;
	ClutterTimelineDirection _tmp1_;
#line 565 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 565 "../src/game.vala"
	g_return_if_fail (trans != NULL);
#line 567 "../src/game.vala"
	g_debug ("game.vala:567: show/hide animation stopped");
#line 569 "../src/game.vala"
	_tmp0_ = clutter_timeline_get_direction (trans);
#line 569 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 569 "../src/game.vala"
	if (_tmp1_ == CLUTTER_TIMELINE_FORWARD) {
#line 571 "../src/game.vala"
		clutter_timeline_set_direction (trans, CLUTTER_TIMELINE_BACKWARD);
#line 572 "../src/game.vala"
		clutter_timeline_start (trans);
#line 573 "../src/game.vala"
		return;
#line 3466 "game.c"
	}
#line 576 "../src/game.vala"
	clutter_transition_group_remove_all (G_TYPE_CHECK_INSTANCE_CAST (trans, clutter_transition_group_get_type (), ClutterTransitionGroup));
#line 577 "../src/game.vala"
	_game_apply_move (self);
#line 3472 "game.c"
}

static gboolean
__game_finish_move_gsource_func (gpointer self)
{
	gboolean result;
	result = _game_finish_move ((Game*) self);
#line 643 "../src/game.vala"
	return result;
#line 3482 "game.c"
}

static void
_game_apply_move (Game* self)
{
	Grid* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeLinkedList* _tmp82_;
	GeeLinkedList* _tmp83_;
	GeeLinkedList* _tmp84_;
	Grid* _tmp85_;
	gboolean _tmp86_;
	gboolean _tmp87_;
#line 580 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 582 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 582 "../src/game.vala"
	_tmp1_ = grid_to_string (_tmp0_);
#line 582 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 582 "../src/game.vala"
	g_debug ("game.vala:582: %s", _tmp2_);
#line 582 "../src/game.vala"
	_g_free0 (_tmp2_);
#line 584 "../src/game.vala"
	if (self->priv->_update_handled) {
#line 584 "../src/game.vala"
		_tmp3_ = self->priv->_state != GAME_GAME_STATE_SHOWING_FIRST_TILE;
#line 3514 "game.c"
	} else {
#line 584 "../src/game.vala"
		_tmp3_ = FALSE;
#line 3518 "game.c"
	}
#line 584 "../src/game.vala"
	if (_tmp3_) {
#line 585 "../src/game.vala"
		return;
#line 3524 "game.c"
	}
#line 586 "../src/game.vala"
	self->priv->_update_handled = TRUE;
#line 3528 "game.c"
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp4_;
		gint _e_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _e_index = 0;
#line 588 "../src/game.vala"
		_tmp4_ = self->priv->_to_hide;
#line 588 "../src/game.vala"
		_e_list = _tmp4_;
#line 588 "../src/game.vala"
		_tmp5_ = _e_list;
#line 588 "../src/game.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 588 "../src/game.vala"
		_tmp7_ = _tmp6_;
#line 588 "../src/game.vala"
		_e_size = _tmp7_;
#line 588 "../src/game.vala"
		_e_index = -1;
#line 588 "../src/game.vala"
		while (TRUE) {
#line 3553 "game.c"
			gint _tmp8_;
			gint _tmp9_;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp10_;
			gpointer _tmp11_;
			TileMovement* _tmp12_;
			GridPosition pos = {0};
			TileMovement* _tmp13_;
			GridPosition _tmp14_;
			TileView* tile_view = NULL;
			TileView** _tmp15_;
			gint _tmp15__length1;
			gint _tmp15__length2;
			GridPosition _tmp16_;
			GridPosition _tmp17_;
			TileView* _tmp18_;
			TileView* _tmp19_;
			TileView* _tmp20_;
			TileView* _tmp21_;
			ClutterActor* _tmp22_;
			ClutterActor* _tmp23_;
			TileView* _tmp24_;
			guint8 _tmp25_;
			guint8 _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			ClutterActor* _tmp31_;
			TileView* _tmp32_;
			ClutterActor* _tmp33_;
			ClutterActor* _tmp34_;
			TileView** _tmp35_;
			gint _tmp35__length1;
			gint _tmp35__length2;
			GridPosition _tmp36_;
			GridPosition _tmp37_;
#line 588 "../src/game.vala"
			_e_index = _e_index + 1;
#line 588 "../src/game.vala"
			_tmp8_ = _e_index;
#line 588 "../src/game.vala"
			_tmp9_ = _e_size;
#line 588 "../src/game.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 588 "../src/game.vala"
				break;
#line 3601 "game.c"
			}
#line 588 "../src/game.vala"
			_tmp10_ = _e_list;
#line 588 "../src/game.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _e_index);
#line 588 "../src/game.vala"
			e = (TileMovement*) _tmp11_;
#line 590 "../src/game.vala"
			_tmp12_ = e;
#line 590 "../src/game.vala"
			if (_tmp12_ == NULL) {
#line 591 "../src/game.vala"
				g_assert_not_reached ();
#line 3615 "game.c"
			}
#line 592 "../src/game.vala"
			_tmp13_ = e;
#line 592 "../src/game.vala"
			_tmp14_ = ((TileMovement) (*_tmp13_)).from;
#line 592 "../src/game.vala"
			pos = _tmp14_;
#line 593 "../src/game.vala"
			_tmp15_ = self->priv->_foreground_cur;
#line 593 "../src/game.vala"
			_tmp15__length1 = self->priv->_foreground_cur_length1;
#line 593 "../src/game.vala"
			_tmp15__length2 = self->priv->_foreground_cur_length2;
#line 593 "../src/game.vala"
			_tmp16_ = pos;
#line 593 "../src/game.vala"
			_tmp17_ = pos;
#line 593 "../src/game.vala"
			_tmp18_ = _tmp15_[(_tmp16_.row * _tmp15__length2) + _tmp17_.col];
#line 593 "../src/game.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 593 "../src/game.vala"
			tile_view = _tmp19_;
#line 594 "../src/game.vala"
			_tmp20_ = tile_view;
#line 594 "../src/game.vala"
			if (_tmp20_ == NULL) {
#line 595 "../src/game.vala"
				g_assert_not_reached ();
#line 3645 "game.c"
			}
#line 596 "../src/game.vala"
			_tmp21_ = tile_view;
#line 596 "../src/game.vala"
			_tmp22_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_TILE_VIEW, TileView));
#line 596 "../src/game.vala"
			_tmp23_ = _tmp22_;
#line 596 "../src/game.vala"
			clutter_actor_hide (_tmp23_);
#line 597 "../src/game.vala"
			_tmp24_ = tile_view;
#line 597 "../src/game.vala"
			_tmp25_ = rounded_rectangle_get_color ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_TILE_VIEW, TileView));
#line 597 "../src/game.vala"
			_tmp26_ = _tmp25_;
#line 597 "../src/game.vala"
			_tmp27_ = g_strdup_printf ("%hhu", _tmp26_);
#line 597 "../src/game.vala"
			_tmp28_ = _tmp27_;
#line 597 "../src/game.vala"
			_tmp29_ = g_strconcat ("remove child ", _tmp28_, NULL);
#line 597 "../src/game.vala"
			_tmp30_ = _tmp29_;
#line 597 "../src/game.vala"
			g_debug ("game.vala:597: %s", _tmp30_);
#line 597 "../src/game.vala"
			_g_free0 (_tmp30_);
#line 597 "../src/game.vala"
			_g_free0 (_tmp28_);
#line 598 "../src/game.vala"
			_tmp31_ = self->priv->_view_foreground;
#line 598 "../src/game.vala"
			_tmp32_ = tile_view;
#line 598 "../src/game.vala"
			_tmp33_ = rounded_rectangle_get_actor ((RoundedRectangle*) G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_TILE_VIEW, TileView));
#line 598 "../src/game.vala"
			_tmp34_ = _tmp33_;
#line 598 "../src/game.vala"
			clutter_actor_remove_child (_tmp31_, _tmp34_);
#line 600 "../src/game.vala"
			_tmp35_ = self->priv->_foreground_cur;
#line 600 "../src/game.vala"
			_tmp35__length1 = self->priv->_foreground_cur_length1;
#line 600 "../src/game.vala"
			_tmp35__length2 = self->priv->_foreground_cur_length2;
#line 600 "../src/game.vala"
			_tmp36_ = pos;
#line 600 "../src/game.vala"
			_tmp37_ = pos;
#line 600 "../src/game.vala"
			_g_object_unref0 (_tmp35_[(_tmp36_.row * _tmp35__length2) + _tmp37_.col]);
#line 600 "../src/game.vala"
			_tmp35_[(_tmp36_.row * _tmp35__length2) + _tmp37_.col] = NULL;
#line 588 "../src/game.vala"
			_g_object_unref0 (tile_view);
#line 588 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3703 "game.c"
		}
	}
#line 603 "../src/game.vala"
	if (self->priv->_state == GAME_GAME_STATE_SHOWING_FIRST_TILE) {
#line 605 "../src/game.vala"
		self->priv->_state = GAME_GAME_STATE_SHOWING_NEW_TILE;
#line 606 "../src/game.vala"
		g_debug ("game.vala:606: state show second tile");
#line 607 "../src/game.vala"
		_game_create_random_tile (self);
#line 3714 "game.c"
	} else {
#line 609 "../src/game.vala"
		if (self->priv->_state != GAME_GAME_STATE_IDLE) {
#line 611 "../src/game.vala"
			self->priv->_state = GAME_GAME_STATE_IDLE;
#line 612 "../src/game.vala"
			g_debug ("game.vala:612: state idle");
#line 3722 "game.c"
		}
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp38_;
		gint _e_size = 0;
		GeeLinkedList* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _e_index = 0;
#line 615 "../src/game.vala"
		_tmp38_ = self->priv->_to_move;
#line 615 "../src/game.vala"
		_e_list = _tmp38_;
#line 615 "../src/game.vala"
		_tmp39_ = _e_list;
#line 615 "../src/game.vala"
		_tmp40_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp39_);
#line 615 "../src/game.vala"
		_tmp41_ = _tmp40_;
#line 615 "../src/game.vala"
		_e_size = _tmp41_;
#line 615 "../src/game.vala"
		_e_index = -1;
#line 615 "../src/game.vala"
		while (TRUE) {
#line 3749 "game.c"
			gint _tmp42_;
			gint _tmp43_;
			TileMovement* e = NULL;
			GeeLinkedList* _tmp44_;
			gpointer _tmp45_;
			TileMovement* _tmp46_;
			GridPosition to = {0};
			TileMovement* _tmp47_;
			GridPosition _tmp48_;
			TileView** _tmp49_;
			gint _tmp49__length1;
			gint _tmp49__length2;
			GridPosition _tmp50_;
			GridPosition _tmp51_;
			TileView** _tmp52_;
			gint _tmp52__length1;
			gint _tmp52__length2;
			GridPosition _tmp53_;
			GridPosition _tmp54_;
			TileView* _tmp55_;
			TileView* _tmp56_;
			TileView** _tmp57_;
			gint _tmp57__length1;
			gint _tmp57__length2;
			GridPosition _tmp58_;
			GridPosition _tmp59_;
#line 615 "../src/game.vala"
			_e_index = _e_index + 1;
#line 615 "../src/game.vala"
			_tmp42_ = _e_index;
#line 615 "../src/game.vala"
			_tmp43_ = _e_size;
#line 615 "../src/game.vala"
			if (!(_tmp42_ < _tmp43_)) {
#line 615 "../src/game.vala"
				break;
#line 3786 "game.c"
			}
#line 615 "../src/game.vala"
			_tmp44_ = _e_list;
#line 615 "../src/game.vala"
			_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp44_, _e_index);
#line 615 "../src/game.vala"
			e = (TileMovement*) _tmp45_;
#line 617 "../src/game.vala"
			_tmp46_ = e;
#line 617 "../src/game.vala"
			if (_tmp46_ == NULL) {
#line 618 "../src/game.vala"
				g_assert_not_reached ();
#line 3800 "game.c"
			}
#line 619 "../src/game.vala"
			_tmp47_ = e;
#line 619 "../src/game.vala"
			_tmp48_ = ((TileMovement) (*_tmp47_)).to;
#line 619 "../src/game.vala"
			to = _tmp48_;
#line 620 "../src/game.vala"
			_tmp49_ = self->priv->_foreground_cur;
#line 620 "../src/game.vala"
			_tmp49__length1 = self->priv->_foreground_cur_length1;
#line 620 "../src/game.vala"
			_tmp49__length2 = self->priv->_foreground_cur_length2;
#line 620 "../src/game.vala"
			_tmp50_ = to;
#line 620 "../src/game.vala"
			_tmp51_ = to;
#line 620 "../src/game.vala"
			_tmp52_ = self->priv->_foreground_nxt;
#line 620 "../src/game.vala"
			_tmp52__length1 = self->priv->_foreground_nxt_length1;
#line 620 "../src/game.vala"
			_tmp52__length2 = self->priv->_foreground_nxt_length2;
#line 620 "../src/game.vala"
			_tmp53_ = to;
#line 620 "../src/game.vala"
			_tmp54_ = to;
#line 620 "../src/game.vala"
			_tmp55_ = _tmp52_[(_tmp53_.row * _tmp52__length2) + _tmp54_.col];
#line 620 "../src/game.vala"
			_tmp56_ = _g_object_ref0 (_tmp55_);
#line 620 "../src/game.vala"
			_g_object_unref0 (_tmp49_[(_tmp50_.row * _tmp49__length2) + _tmp51_.col]);
#line 620 "../src/game.vala"
			_tmp49_[(_tmp50_.row * _tmp49__length2) + _tmp51_.col] = _tmp56_;
#line 621 "../src/game.vala"
			_tmp57_ = self->priv->_foreground_nxt;
#line 621 "../src/game.vala"
			_tmp57__length1 = self->priv->_foreground_nxt_length1;
#line 621 "../src/game.vala"
			_tmp57__length2 = self->priv->_foreground_nxt_length2;
#line 621 "../src/game.vala"
			_tmp58_ = to;
#line 621 "../src/game.vala"
			_tmp59_ = to;
#line 621 "../src/game.vala"
			_g_object_unref0 (_tmp57_[(_tmp58_.row * _tmp57__length2) + _tmp59_.col]);
#line 621 "../src/game.vala"
			_tmp57_[(_tmp58_.row * _tmp57__length2) + _tmp59_.col] = NULL;
#line 615 "../src/game.vala"
			_tile_movement_free0 (e);
#line 3852 "game.c"
		}
	}
	{
		GeeLinkedList* _e_list = NULL;
		GeeLinkedList* _tmp60_;
		gint _e_size = 0;
		GeeLinkedList* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
		gint _e_index = 0;
#line 623 "../src/game.vala"
		_tmp60_ = self->priv->_to_show;
#line 623 "../src/game.vala"
		_e_list = _tmp60_;
#line 623 "../src/game.vala"
		_tmp61_ = _e_list;
#line 623 "../src/game.vala"
		_tmp62_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp61_);
#line 623 "../src/game.vala"
		_tmp63_ = _tmp62_;
#line 623 "../src/game.vala"
		_e_size = _tmp63_;
#line 623 "../src/game.vala"
		_e_index = -1;
#line 623 "../src/game.vala"
		while (TRUE) {
#line 3879 "game.c"
			gint _tmp64_;
			gint _tmp65_;
			Tile* e = NULL;
			GeeLinkedList* _tmp66_;
			gpointer _tmp67_;
			Tile* _tmp68_;
			GridPosition pos = {0};
			Tile* _tmp69_;
			GridPosition _tmp70_;
			TileView** _tmp71_;
			gint _tmp71__length1;
			gint _tmp71__length2;
			GridPosition _tmp72_;
			GridPosition _tmp73_;
			TileView** _tmp74_;
			gint _tmp74__length1;
			gint _tmp74__length2;
			GridPosition _tmp75_;
			GridPosition _tmp76_;
			TileView* _tmp77_;
			TileView* _tmp78_;
			TileView** _tmp79_;
			gint _tmp79__length1;
			gint _tmp79__length2;
			GridPosition _tmp80_;
			GridPosition _tmp81_;
#line 623 "../src/game.vala"
			_e_index = _e_index + 1;
#line 623 "../src/game.vala"
			_tmp64_ = _e_index;
#line 623 "../src/game.vala"
			_tmp65_ = _e_size;
#line 623 "../src/game.vala"
			if (!(_tmp64_ < _tmp65_)) {
#line 623 "../src/game.vala"
				break;
#line 3916 "game.c"
			}
#line 623 "../src/game.vala"
			_tmp66_ = _e_list;
#line 623 "../src/game.vala"
			_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _tmp66_, _e_index);
#line 623 "../src/game.vala"
			e = (Tile*) _tmp67_;
#line 625 "../src/game.vala"
			_tmp68_ = e;
#line 625 "../src/game.vala"
			if (_tmp68_ == NULL) {
#line 626 "../src/game.vala"
				g_assert_not_reached ();
#line 3930 "game.c"
			}
#line 627 "../src/game.vala"
			_tmp69_ = e;
#line 627 "../src/game.vala"
			_tmp70_ = ((Tile) (*_tmp69_)).pos;
#line 627 "../src/game.vala"
			pos = _tmp70_;
#line 628 "../src/game.vala"
			_tmp71_ = self->priv->_foreground_cur;
#line 628 "../src/game.vala"
			_tmp71__length1 = self->priv->_foreground_cur_length1;
#line 628 "../src/game.vala"
			_tmp71__length2 = self->priv->_foreground_cur_length2;
#line 628 "../src/game.vala"
			_tmp72_ = pos;
#line 628 "../src/game.vala"
			_tmp73_ = pos;
#line 628 "../src/game.vala"
			_tmp74_ = self->priv->_foreground_nxt;
#line 628 "../src/game.vala"
			_tmp74__length1 = self->priv->_foreground_nxt_length1;
#line 628 "../src/game.vala"
			_tmp74__length2 = self->priv->_foreground_nxt_length2;
#line 628 "../src/game.vala"
			_tmp75_ = pos;
#line 628 "../src/game.vala"
			_tmp76_ = pos;
#line 628 "../src/game.vala"
			_tmp77_ = _tmp74_[(_tmp75_.row * _tmp74__length2) + _tmp76_.col];
#line 628 "../src/game.vala"
			_tmp78_ = _g_object_ref0 (_tmp77_);
#line 628 "../src/game.vala"
			_g_object_unref0 (_tmp71_[(_tmp72_.row * _tmp71__length2) + _tmp73_.col]);
#line 628 "../src/game.vala"
			_tmp71_[(_tmp72_.row * _tmp71__length2) + _tmp73_.col] = _tmp78_;
#line 629 "../src/game.vala"
			_tmp79_ = self->priv->_foreground_nxt;
#line 629 "../src/game.vala"
			_tmp79__length1 = self->priv->_foreground_nxt_length1;
#line 629 "../src/game.vala"
			_tmp79__length2 = self->priv->_foreground_nxt_length2;
#line 629 "../src/game.vala"
			_tmp80_ = pos;
#line 629 "../src/game.vala"
			_tmp81_ = pos;
#line 629 "../src/game.vala"
			_g_object_unref0 (_tmp79_[(_tmp80_.row * _tmp79__length2) + _tmp81_.col]);
#line 629 "../src/game.vala"
			_tmp79_[(_tmp80_.row * _tmp79__length2) + _tmp81_.col] = NULL;
#line 623 "../src/game.vala"
			_tile_free0 (e);
#line 3982 "game.c"
		}
	}
#line 632 "../src/game.vala"
	_tmp82_ = self->priv->_to_hide;
#line 632 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp82_);
#line 633 "../src/game.vala"
	_tmp83_ = self->priv->_to_move;
#line 633 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp83_);
#line 634 "../src/game.vala"
	_tmp84_ = self->priv->_to_show;
#line 634 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp84_);
#line 636 "../src/game.vala"
	_tmp85_ = self->priv->_grid;
#line 636 "../src/game.vala"
	_tmp86_ = grid_get_target_value_reached (_tmp85_);
#line 636 "../src/game.vala"
	_tmp87_ = _tmp86_;
#line 636 "../src/game.vala"
	if (_tmp87_) {
#line 4005 "game.c"
		Grid* _tmp88_;
		guint _tmp89_;
		guint _tmp90_;
		Grid* _tmp91_;
#line 638 "../src/game.vala"
		_tmp88_ = self->priv->_grid;
#line 638 "../src/game.vala"
		_tmp89_ = grid_get_target_value (_tmp88_);
#line 638 "../src/game.vala"
		_tmp90_ = _tmp89_;
#line 638 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_TARGET_VALUE_REACHED_SIGNAL], 0, _tmp90_);
#line 639 "../src/game.vala"
		_tmp91_ = self->priv->_grid;
#line 639 "../src/game.vala"
		grid_set_target_value_reached (_tmp91_, FALSE);
#line 4022 "game.c"
	}
#line 642 "../src/game.vala"
	if (!self->priv->_just_restored) {
#line 643 "../src/game.vala"
		self->priv->_finish_move_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, __game_finish_move_gsource_func, g_object_ref (self), g_object_unref);
#line 4028 "game.c"
	} else {
		Grid* _tmp92_;
#line 644 "../src/game.vala"
		_tmp92_ = self->priv->_grid;
#line 644 "../src/game.vala"
		if (grid_is_finished (_tmp92_)) {
#line 645 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_FINISHED_SIGNAL], 0, FALSE);
#line 4037 "game.c"
		}
	}
}

static gboolean
_game_finish_move (Game* self)
{
	Grid* _tmp0_;
	gboolean result;
#line 648 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 650 "../src/game.vala"
	_tmp0_ = self->priv->_grid;
#line 650 "../src/game.vala"
	if (grid_is_finished (_tmp0_)) {
#line 651 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_FINISHED_SIGNAL], 0, TRUE);
#line 4055 "game.c"
	}
#line 653 "../src/game.vala"
	self->priv->_finish_move_id = (guint) 0;
#line 654 "../src/game.vala"
	result = FALSE;
#line 654 "../src/game.vala"
	return result;
#line 4063 "game.c"
}

static inline void
_game_clean_finish_move_animation (Game* self)
{
#line 657 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 659 "../src/game.vala"
	if (self->priv->_finish_move_id > ((guint) 0)) {
#line 660 "../src/game.vala"
		g_source_remove (self->priv->_finish_move_id);
#line 4075 "game.c"
	}
}

void
game_undo (Game* self)
{
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	Grid* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 674 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 674 "../src/game.vala"
	_vala_return_if_fail (self->priv->_allow_undo == TRUE, "_allow_undo == true");
#line 677 "../src/game.vala"
	if (self->priv->_state != GAME_GAME_STATE_IDLE) {
#line 678 "../src/game.vala"
		return;
#line 4096 "game.c"
	}
#line 680 "../src/game.vala"
	_game_clear_foreground (self);
#line 681 "../src/game.vala"
	_tmp0_ = self->priv->_undo_stack;
#line 681 "../src/game.vala"
	_tmp1_ = gee_deque_poll_head ((GeeDeque*) _tmp0_);
#line 681 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 681 "../src/game.vala"
	self->priv->_grid = (Grid*) _tmp1_;
#line 682 "../src/game.vala"
	_game_restore_foreground (self, FALSE);
#line 683 "../src/game.vala"
	_tmp2_ = self->priv->_grid;
#line 683 "../src/game.vala"
	game_set_score (self, grid_get_score (_tmp2_));
#line 685 "../src/game.vala"
	_tmp3_ = self->priv->_undo_stack;
#line 685 "../src/game.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 685 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 685 "../src/game.vala"
	if (_tmp5_ == 0) {
#line 686 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 4124 "game.c"
	}
#line 687 "../src/game.vala"
	self->priv->_update_handled = FALSE;
#line 4128 "game.c"
}

static void
_game_load_undo_settings (Game* self,
                          GSettings** settings)
{
	gboolean allow_undo = FALSE;
	gboolean _tmp0_ = FALSE;
#line 690 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 690 "../src/game.vala"
	g_return_if_fail (*settings != NULL);
#line 692 "../src/game.vala"
	allow_undo = g_settings_get_boolean (*settings, "allow-undo");
#line 693 "../src/game.vala"
	if (self->priv->_allow_undo) {
#line 693 "../src/game.vala"
		_tmp0_ = !allow_undo;
#line 4147 "game.c"
	} else {
#line 693 "../src/game.vala"
		_tmp0_ = FALSE;
#line 4151 "game.c"
	}
#line 693 "../src/game.vala"
	if (_tmp0_) {
#line 695 "../src/game.vala"
		_game_clear_history (self);
#line 696 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_DISABLED_SIGNAL], 0);
#line 4159 "game.c"
	}
#line 698 "../src/game.vala"
	self->priv->_allow_undo = allow_undo;
#line 699 "../src/game.vala"
	self->priv->_undo_stack_max_size = g_settings_get_uint (*settings, "allow-undo-max");
#line 4165 "game.c"
}

static void
_game_clear_history (Game* self)
{
	GeeLinkedList* _tmp0_;
#line 702 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 704 "../src/game.vala"
	_tmp0_ = self->priv->_undo_stack;
#line 704 "../src/game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 4178 "game.c"
}

static void
_game_store_movement (Game* self,
                      Grid* clone)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* _tmp6_;
	GeeLinkedList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 707 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 707 "../src/game.vala"
	g_return_if_fail (clone != NULL);
#line 709 "../src/game.vala"
	if (!self->priv->_allow_undo) {
#line 710 "../src/game.vala"
		return;
#line 4200 "game.c"
	}
#line 712 "../src/game.vala"
	_tmp0_ = self->priv->_undo_stack;
#line 712 "../src/game.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 712 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 712 "../src/game.vala"
	if (((guint) _tmp2_) >= self->priv->_undo_stack_max_size) {
#line 4210 "game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Grid* _tmp5_;
#line 713 "../src/game.vala"
		_tmp3_ = self->priv->_undo_stack;
#line 713 "../src/game.vala"
		_tmp4_ = gee_deque_poll_tail ((GeeDeque*) _tmp3_);
#line 713 "../src/game.vala"
		_tmp5_ = (Grid*) _tmp4_;
#line 713 "../src/game.vala"
		_g_object_unref0 (_tmp5_);
#line 4222 "game.c"
	}
#line 714 "../src/game.vala"
	_tmp6_ = self->priv->_undo_stack;
#line 714 "../src/game.vala"
	gee_deque_offer_head ((GeeDeque*) _tmp6_, clone);
#line 715 "../src/game.vala"
	_tmp7_ = self->priv->_undo_stack;
#line 715 "../src/game.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 715 "../src/game.vala"
	_tmp9_ = _tmp8_;
#line 715 "../src/game.vala"
	if (_tmp9_ == 1) {
#line 716 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_UNDO_ENABLED_SIGNAL], 0);
#line 4238 "game.c"
	}
}

ClutterActor*
game_get_view (Game* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 91 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/game.vala"
	_tmp0_ = self->priv->_view;
#line 91 "../src/game.vala"
	result = _tmp0_;
#line 91 "../src/game.vala"
	return result;
#line 4255 "game.c"
}

static void
__game_on_allocation_changed_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                               ClutterActorBox* box,
                                                               ClutterAllocationFlags flags,
                                                               gpointer self)
{
#line 94 "../src/game.vala"
	_game_on_allocation_changed ((Game*) self, box, flags);
#line 4266 "game.c"
}

void
game_set_view (Game* self,
               ClutterActor* value)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* _tmp3_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterActor* _tmp6_;
	ClutterActor* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
#line 92 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/game.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 93 "../src/game.vala"
	_g_object_unref0 (self->priv->_view);
#line 93 "../src/game.vala"
	self->priv->_view = _tmp0_;
#line 94 "../src/game.vala"
	_tmp1_ = self->priv->_view;
#line 94 "../src/game.vala"
	g_signal_connect_object (_tmp1_, "allocation-changed", (GCallback) __game_on_allocation_changed_clutter_actor_allocation_changed, self, 0);
#line 96 "../src/game.vala"
	_tmp2_ = clutter_actor_new ();
#line 96 "../src/game.vala"
	g_object_ref_sink (_tmp2_);
#line 96 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_background);
#line 96 "../src/game.vala"
	self->priv->_view_background = _tmp2_;
#line 97 "../src/game.vala"
	_tmp3_ = clutter_actor_new ();
#line 97 "../src/game.vala"
	g_object_ref_sink (_tmp3_);
#line 97 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_foreground);
#line 97 "../src/game.vala"
	self->priv->_view_foreground = _tmp3_;
#line 98 "../src/game.vala"
	_tmp4_ = self->priv->_view_background;
#line 98 "../src/game.vala"
	clutter_actor_show (_tmp4_);
#line 99 "../src/game.vala"
	_tmp5_ = self->priv->_view_foreground;
#line 99 "../src/game.vala"
	clutter_actor_show (_tmp5_);
#line 100 "../src/game.vala"
	_tmp6_ = self->priv->_view;
#line 100 "../src/game.vala"
	_tmp7_ = self->priv->_view_background;
#line 100 "../src/game.vala"
	clutter_actor_add_child (_tmp6_, _tmp7_);
#line 101 "../src/game.vala"
	_tmp8_ = self->priv->_view;
#line 101 "../src/game.vala"
	_tmp9_ = self->priv->_view_foreground;
#line 101 "../src/game.vala"
	clutter_actor_add_child (_tmp8_, _tmp9_);
#line 4331 "game.c"
}

glong
game_get_score (Game* self)
{
	glong result;
#line 119 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0L);
#line 119 "../src/game.vala"
	result = self->priv->_score;
#line 119 "../src/game.vala"
	return result;
#line 4344 "game.c"
}

static void
game_set_score (Game* self,
                glong value)
{
	glong old_value;
#line 119 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/game.vala"
	old_value = game_get_score (self);
#line 119 "../src/game.vala"
	if (old_value != value) {
#line 119 "../src/game.vala"
		self->priv->_score = value;
#line 119 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
#line 4362 "game.c"
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 21 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 21 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 21 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 21 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 21 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_PROPERTY, game_properties[GAME_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_long ("score", "score", "score", G_MINLONG, G_MAXLONG, (glong) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/game.vala"
	game_signals[GAME_FINISHED_SIGNAL] = g_signal_new ("finished", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 21 "../src/game.vala"
	game_signals[GAME_TARGET_VALUE_REACHED_SIGNAL] = g_signal_new ("target-value-reached", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
#line 21 "../src/game.vala"
	game_signals[GAME_UNDO_ENABLED_SIGNAL] = g_signal_new ("undo-enabled", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/game.vala"
	game_signals[GAME_UNDO_DISABLED_SIGNAL] = g_signal_new ("undo-disabled", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4392 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GeeLinkedList* _tmp5_;
#line 21 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 46 "../src/game.vala"
	self->priv->BLANK_COL_WIDTH = 10;
#line 47 "../src/game.vala"
	self->priv->BLANK_ROW_HEIGHT = 10;
#line 52 "../src/game.vala"
	self->priv->_background_init_done = FALSE;
#line 56 "../src/game.vala"
	_tmp0_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 56 "../src/game.vala"
	self->priv->_to_move = _tmp0_;
#line 57 "../src/game.vala"
	_tmp1_ = gee_linked_list_new (TYPE_TILE_MOVEMENT, (GBoxedCopyFunc) tile_movement_dup, (GDestroyNotify) tile_movement_free, NULL, NULL, NULL);
#line 57 "../src/game.vala"
	self->priv->_to_hide = _tmp1_;
#line 58 "../src/game.vala"
	_tmp2_ = gee_linked_list_new (TYPE_TILE, (GBoxedCopyFunc) tile_dup, (GDestroyNotify) tile_free, NULL, NULL, NULL);
#line 58 "../src/game.vala"
	self->priv->_to_show = _tmp2_;
#line 60 "../src/game.vala"
	self->priv->_state = GAME_GAME_STATE_STOPPED;
#line 65 "../src/game.vala"
	_tmp3_ = g_get_user_data_dir ();
#line 65 "../src/game.vala"
	_tmp4_ = g_build_filename (_tmp3_, "gnome-2048", "saved", NULL);
#line 65 "../src/game.vala"
	self->priv->_saved_path = _tmp4_;
#line 117 "../src/game.vala"
	self->priv->_just_restored = TRUE;
#line 119 "../src/game.vala"
	self->priv->_score = (glong) 0;
#line 553 "../src/game.vala"
	self->priv->_finish_move_id = (guint) 0;
#line 554 "../src/game.vala"
	self->priv->_update_handled = FALSE;
#line 670 "../src/game.vala"
	self->priv->_allow_undo = FALSE;
#line 672 "../src/game.vala"
	_tmp5_ = gee_linked_list_new (TYPE_GRID, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 672 "../src/game.vala"
	self->priv->_undo_stack = _tmp5_;
#line 4447 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 21 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 49 "../src/game.vala"
	_g_object_unref0 (self->priv->_grid);
#line 51 "../src/game.vala"
	self->priv->_background = (_vala_array_free (self->priv->_background, self->priv->_background_length1 * self->priv->_background_length2, (GDestroyNotify) g_object_unref), NULL);
#line 53 "../src/game.vala"
	self->priv->_foreground_cur = (_vala_array_free (self->priv->_foreground_cur, self->priv->_foreground_cur_length1 * self->priv->_foreground_cur_length2, (GDestroyNotify) g_object_unref), NULL);
#line 54 "../src/game.vala"
	self->priv->_foreground_nxt = (_vala_array_free (self->priv->_foreground_nxt, self->priv->_foreground_nxt_length1 * self->priv->_foreground_nxt_length2, (GDestroyNotify) g_object_unref), NULL);
#line 56 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_move);
#line 57 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_hide);
#line 58 "../src/game.vala"
	_g_object_unref0 (self->priv->_to_show);
#line 61 "../src/game.vala"
	_g_object_unref0 (self->priv->_show_hide_trans);
#line 62 "../src/game.vala"
	_g_object_unref0 (self->priv->_move_trans);
#line 65 "../src/game.vala"
	_g_free0 (self->priv->_saved_path);
#line 86 "../src/game.vala"
	_g_object_unref0 (self->priv->_view);
#line 87 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_background);
#line 88 "../src/game.vala"
	_g_object_unref0 (self->priv->_view_foreground);
#line 672 "../src/game.vala"
	_g_object_unref0 (self->priv->_undo_stack);
#line 21 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 4486 "game.c"
}

static GType
game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
	GType game_type_id;
	game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__once = 0;
	if (g_once_init_enter (&game_type_id__once)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__once, game_type_id);
	}
	return game_type_id__once;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 21 "../src/game.vala"
	switch (property_id) {
#line 21 "../src/game.vala"
		case GAME_VIEW_PROPERTY:
#line 21 "../src/game.vala"
		g_value_set_object (value, game_get_view (self));
#line 21 "../src/game.vala"
		break;
#line 21 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 21 "../src/game.vala"
		g_value_set_long (value, game_get_score (self));
#line 21 "../src/game.vala"
		break;
#line 4533 "game.c"
		default:
#line 21 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game.vala"
		break;
#line 4539 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 21 "../src/game.vala"
	switch (property_id) {
#line 21 "../src/game.vala"
		case GAME_VIEW_PROPERTY:
#line 21 "../src/game.vala"
		game_set_view (self, g_value_get_object (value));
#line 21 "../src/game.vala"
		break;
#line 21 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 21 "../src/game.vala"
		game_set_score (self, g_value_get_long (value));
#line 21 "../src/game.vala"
		break;
#line 4565 "game.c"
		default:
#line 21 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game.vala"
		break;
#line 4571 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

